/*
 * 
 */
package net.officefloor.model.desk;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class DeskManagedObjectModel extends AbstractModel implements ItemModel<DeskManagedObjectModel> {

    public static enum DeskManagedObjectEvent {
     CHANGE_DESK_MANAGED_OBJECT_NAME, CHANGE_MANAGED_OBJECT_SCOPE, CHANGE_DESK_MANAGED_OBJECT_SOURCE, ADD_WORK_TASK_OBJECT, REMOVE_WORK_TASK_OBJECT, ADD_DESK_MANAGED_OBJECT_DEPENDENCY, REMOVE_DESK_MANAGED_OBJECT_DEPENDENCY, ADD_DEPENDENT_DESK_MANAGED_OBJECT, REMOVE_DEPENDENT_DESK_MANAGED_OBJECT
    }

    /**
     * Default constructor.
     */
    public DeskManagedObjectModel() {
    }

    /**
     * Convenience constructor for new non-linked instance.
     */
    public DeskManagedObjectModel(
      String deskManagedObjectName
    , String managedObjectScope
    ) {
        this.deskManagedObjectName = deskManagedObjectName;
        this.managedObjectScope = managedObjectScope;
    }

    /**
     * Convenience constructor.
     */
    public DeskManagedObjectModel(
      String deskManagedObjectName
    , String managedObjectScope
    , DeskManagedObjectToDeskManagedObjectSourceModel deskManagedObjectSource
    , WorkTaskObjectToDeskManagedObjectModel[] workTaskObject
    , DeskManagedObjectDependencyModel[] deskManagedObjectDependency
    , DeskManagedObjectDependencyToDeskManagedObjectModel[] dependentDeskManagedObject
    ) {
        this.deskManagedObjectName = deskManagedObjectName;
        this.managedObjectScope = managedObjectScope;
        this.deskManagedObjectSource = deskManagedObjectSource;
        if (workTaskObject != null) {
            for (WorkTaskObjectToDeskManagedObjectModel model : workTaskObject) {
                this.workTaskObject.add(model);
            }
        }
        if (deskManagedObjectDependency != null) {
            for (DeskManagedObjectDependencyModel model : deskManagedObjectDependency) {
                this.deskManagedObjectDependency.add(model);
            }
        }
        if (dependentDeskManagedObject != null) {
            for (DeskManagedObjectDependencyToDeskManagedObjectModel model : dependentDeskManagedObject) {
                this.dependentDeskManagedObject.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public DeskManagedObjectModel(
      String deskManagedObjectName
    , String managedObjectScope
    , DeskManagedObjectToDeskManagedObjectSourceModel deskManagedObjectSource
    , WorkTaskObjectToDeskManagedObjectModel[] workTaskObject
    , DeskManagedObjectDependencyModel[] deskManagedObjectDependency
    , DeskManagedObjectDependencyToDeskManagedObjectModel[] dependentDeskManagedObject
    , int x
    , int y
    ) {
        this.deskManagedObjectName = deskManagedObjectName;
        this.managedObjectScope = managedObjectScope;
        this.deskManagedObjectSource = deskManagedObjectSource;
        if (workTaskObject != null) {
            for (WorkTaskObjectToDeskManagedObjectModel model : workTaskObject) {
                this.workTaskObject.add(model);
            }
        }
        if (deskManagedObjectDependency != null) {
            for (DeskManagedObjectDependencyModel model : deskManagedObjectDependency) {
                this.deskManagedObjectDependency.add(model);
            }
        }
        if (dependentDeskManagedObject != null) {
            for (DeskManagedObjectDependencyToDeskManagedObjectModel model : dependentDeskManagedObject) {
                this.dependentDeskManagedObject.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }

    /**
     * Desk managed object name.
     */
    private String deskManagedObjectName;

    public String getDeskManagedObjectName() {
        return this.deskManagedObjectName;
    }

    public void setDeskManagedObjectName(String deskManagedObjectName) {
        String oldValue = this.deskManagedObjectName;
        this.deskManagedObjectName = deskManagedObjectName;
        this.changeField(oldValue, this.deskManagedObjectName, DeskManagedObjectEvent.CHANGE_DESK_MANAGED_OBJECT_NAME);
    }

    /**
     * Managed object scope.
     */
    private String managedObjectScope;

    public String getManagedObjectScope() {
        return this.managedObjectScope;
    }

    public void setManagedObjectScope(String managedObjectScope) {
        String oldValue = this.managedObjectScope;
        this.managedObjectScope = managedObjectScope;
        this.changeField(oldValue, this.managedObjectScope, DeskManagedObjectEvent.CHANGE_MANAGED_OBJECT_SCOPE);
    }

    /**
     * Desk managed object source.
     */
    private DeskManagedObjectToDeskManagedObjectSourceModel deskManagedObjectSource;

    public DeskManagedObjectToDeskManagedObjectSourceModel getDeskManagedObjectSource() {
        return this.deskManagedObjectSource;
    }

    public void setDeskManagedObjectSource(DeskManagedObjectToDeskManagedObjectSourceModel deskManagedObjectSource) {
        DeskManagedObjectToDeskManagedObjectSourceModel oldValue = this.deskManagedObjectSource;
        this.deskManagedObjectSource = deskManagedObjectSource;
        this.changeField(oldValue, this.deskManagedObjectSource, DeskManagedObjectEvent.CHANGE_DESK_MANAGED_OBJECT_SOURCE);
    }


    /**
     * Work task object.
     */
    private List<WorkTaskObjectToDeskManagedObjectModel> workTaskObject = new LinkedList<WorkTaskObjectToDeskManagedObjectModel>();

    public List<WorkTaskObjectToDeskManagedObjectModel> getWorkTaskObjects() {
        return this.workTaskObject;
    }

    public void addWorkTaskObject(WorkTaskObjectToDeskManagedObjectModel workTaskObject) {
        this.addItemToList(workTaskObject, this.workTaskObject, DeskManagedObjectEvent.ADD_WORK_TASK_OBJECT);
    }

    public void removeWorkTaskObject(WorkTaskObjectToDeskManagedObjectModel workTaskObject) {
        this.removeItemFromList(workTaskObject, this.workTaskObject, DeskManagedObjectEvent.REMOVE_WORK_TASK_OBJECT);
    }

    /**
     * Desk managed object dependency.
     */
    private List<DeskManagedObjectDependencyModel> deskManagedObjectDependency = new LinkedList<DeskManagedObjectDependencyModel>();

    public List<DeskManagedObjectDependencyModel> getDeskManagedObjectDependencies() {
        return this.deskManagedObjectDependency;
    }

    public void addDeskManagedObjectDependency(DeskManagedObjectDependencyModel deskManagedObjectDependency) {
        this.addItemToList(deskManagedObjectDependency, this.deskManagedObjectDependency, DeskManagedObjectEvent.ADD_DESK_MANAGED_OBJECT_DEPENDENCY);
    }

    public void removeDeskManagedObjectDependency(DeskManagedObjectDependencyModel deskManagedObjectDependency) {
        this.removeItemFromList(deskManagedObjectDependency, this.deskManagedObjectDependency, DeskManagedObjectEvent.REMOVE_DESK_MANAGED_OBJECT_DEPENDENCY);
    }

    /**
     * Dependent desk managed object.
     */
    private List<DeskManagedObjectDependencyToDeskManagedObjectModel> dependentDeskManagedObject = new LinkedList<DeskManagedObjectDependencyToDeskManagedObjectModel>();

    public List<DeskManagedObjectDependencyToDeskManagedObjectModel> getDependentDeskManagedObjects() {
        return this.dependentDeskManagedObject;
    }

    public void addDependentDeskManagedObject(DeskManagedObjectDependencyToDeskManagedObjectModel dependentDeskManagedObject) {
        this.addItemToList(dependentDeskManagedObject, this.dependentDeskManagedObject, DeskManagedObjectEvent.ADD_DEPENDENT_DESK_MANAGED_OBJECT);
    }

    public void removeDependentDeskManagedObject(DeskManagedObjectDependencyToDeskManagedObjectModel dependentDeskManagedObject) {
        this.removeItemFromList(dependentDeskManagedObject, this.dependentDeskManagedObject, DeskManagedObjectEvent.REMOVE_DEPENDENT_DESK_MANAGED_OBJECT);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<DeskManagedObjectModel> removeConnections() {
        RemoveConnectionsAction<DeskManagedObjectModel> _action = new RemoveConnectionsAction<DeskManagedObjectModel>(this);
        _action.disconnect(this.deskManagedObjectSource);
        _action.disconnect(this.workTaskObject);
        _action.disconnect(this.dependentDeskManagedObject);
        return _action;
    }
}
