/*
 * 
 */
package net.officefloor.model.desk;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class DeskManagedObjectSourceModel extends AbstractModel implements ItemModel<DeskManagedObjectSourceModel> {

    public static enum DeskManagedObjectSourceEvent {
     CHANGE_DESK_MANAGED_OBJECT_SOURCE_NAME, CHANGE_MANAGED_OBJECT_SOURCE_CLASS_NAME, CHANGE_OBJECT_TYPE, CHANGE_TIMEOUT, ADD_PROPERTY, REMOVE_PROPERTY, ADD_DESK_MANAGED_OBJECT, REMOVE_DESK_MANAGED_OBJECT, ADD_DESK_MANAGED_OBJECT_SOURCE_FLOW, REMOVE_DESK_MANAGED_OBJECT_SOURCE_FLOW
    }

    /**
     * Default constructor.
     */
    public DeskManagedObjectSourceModel() {
    }

    /**
     * Convenience constructor for new non-linked instance.
     */
    public DeskManagedObjectSourceModel(
      String deskManagedObjectSourceName
    , String managedObjectSourceClassName
    , String objectType
    , String timeout
    ) {
        this.deskManagedObjectSourceName = deskManagedObjectSourceName;
        this.managedObjectSourceClassName = managedObjectSourceClassName;
        this.objectType = objectType;
        this.timeout = timeout;
    }

    /**
     * Convenience constructor.
     */
    public DeskManagedObjectSourceModel(
      String deskManagedObjectSourceName
    , String managedObjectSourceClassName
    , String objectType
    , String timeout
    , PropertyModel[] property
    , DeskManagedObjectToDeskManagedObjectSourceModel[] deskManagedObject
    , DeskManagedObjectSourceFlowModel[] deskManagedObjectSourceFlow
    ) {
        this.deskManagedObjectSourceName = deskManagedObjectSourceName;
        this.managedObjectSourceClassName = managedObjectSourceClassName;
        this.objectType = objectType;
        this.timeout = timeout;
        if (property != null) {
            for (PropertyModel model : property) {
                this.property.add(model);
            }
        }
        if (deskManagedObject != null) {
            for (DeskManagedObjectToDeskManagedObjectSourceModel model : deskManagedObject) {
                this.deskManagedObject.add(model);
            }
        }
        if (deskManagedObjectSourceFlow != null) {
            for (DeskManagedObjectSourceFlowModel model : deskManagedObjectSourceFlow) {
                this.deskManagedObjectSourceFlow.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public DeskManagedObjectSourceModel(
      String deskManagedObjectSourceName
    , String managedObjectSourceClassName
    , String objectType
    , String timeout
    , PropertyModel[] property
    , DeskManagedObjectToDeskManagedObjectSourceModel[] deskManagedObject
    , DeskManagedObjectSourceFlowModel[] deskManagedObjectSourceFlow
    , int x
    , int y
    ) {
        this.deskManagedObjectSourceName = deskManagedObjectSourceName;
        this.managedObjectSourceClassName = managedObjectSourceClassName;
        this.objectType = objectType;
        this.timeout = timeout;
        if (property != null) {
            for (PropertyModel model : property) {
                this.property.add(model);
            }
        }
        if (deskManagedObject != null) {
            for (DeskManagedObjectToDeskManagedObjectSourceModel model : deskManagedObject) {
                this.deskManagedObject.add(model);
            }
        }
        if (deskManagedObjectSourceFlow != null) {
            for (DeskManagedObjectSourceFlowModel model : deskManagedObjectSourceFlow) {
                this.deskManagedObjectSourceFlow.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }

    /**
     * Desk managed object source name.
     */
    private String deskManagedObjectSourceName;

    public String getDeskManagedObjectSourceName() {
        return this.deskManagedObjectSourceName;
    }

    public void setDeskManagedObjectSourceName(String deskManagedObjectSourceName) {
        String oldValue = this.deskManagedObjectSourceName;
        this.deskManagedObjectSourceName = deskManagedObjectSourceName;
        this.changeField(oldValue, this.deskManagedObjectSourceName, DeskManagedObjectSourceEvent.CHANGE_DESK_MANAGED_OBJECT_SOURCE_NAME);
    }

    /**
     * Managed object source class name.
     */
    private String managedObjectSourceClassName;

    public String getManagedObjectSourceClassName() {
        return this.managedObjectSourceClassName;
    }

    public void setManagedObjectSourceClassName(String managedObjectSourceClassName) {
        String oldValue = this.managedObjectSourceClassName;
        this.managedObjectSourceClassName = managedObjectSourceClassName;
        this.changeField(oldValue, this.managedObjectSourceClassName, DeskManagedObjectSourceEvent.CHANGE_MANAGED_OBJECT_SOURCE_CLASS_NAME);
    }

    /**
     * Object type.
     */
    private String objectType;

    public String getObjectType() {
        return this.objectType;
    }

    public void setObjectType(String objectType) {
        String oldValue = this.objectType;
        this.objectType = objectType;
        this.changeField(oldValue, this.objectType, DeskManagedObjectSourceEvent.CHANGE_OBJECT_TYPE);
    }

    /**
     * Timeout.
     */
    private String timeout;

    public String getTimeout() {
        return this.timeout;
    }

    public void setTimeout(String timeout) {
        String oldValue = this.timeout;
        this.timeout = timeout;
        this.changeField(oldValue, this.timeout, DeskManagedObjectSourceEvent.CHANGE_TIMEOUT);
    }


    /**
     * Property.
     */
    private List<PropertyModel> property = new LinkedList<PropertyModel>();

    public List<PropertyModel> getProperties() {
        return this.property;
    }

    public void addProperty(PropertyModel property) {
        this.addItemToList(property, this.property, DeskManagedObjectSourceEvent.ADD_PROPERTY);
    }

    public void removeProperty(PropertyModel property) {
        this.removeItemFromList(property, this.property, DeskManagedObjectSourceEvent.REMOVE_PROPERTY);
    }

    /**
     * Desk managed object.
     */
    private List<DeskManagedObjectToDeskManagedObjectSourceModel> deskManagedObject = new LinkedList<DeskManagedObjectToDeskManagedObjectSourceModel>();

    public List<DeskManagedObjectToDeskManagedObjectSourceModel> getDeskManagedObjects() {
        return this.deskManagedObject;
    }

    public void addDeskManagedObject(DeskManagedObjectToDeskManagedObjectSourceModel deskManagedObject) {
        this.addItemToList(deskManagedObject, this.deskManagedObject, DeskManagedObjectSourceEvent.ADD_DESK_MANAGED_OBJECT);
    }

    public void removeDeskManagedObject(DeskManagedObjectToDeskManagedObjectSourceModel deskManagedObject) {
        this.removeItemFromList(deskManagedObject, this.deskManagedObject, DeskManagedObjectSourceEvent.REMOVE_DESK_MANAGED_OBJECT);
    }

    /**
     * Desk managed object source flow.
     */
    private List<DeskManagedObjectSourceFlowModel> deskManagedObjectSourceFlow = new LinkedList<DeskManagedObjectSourceFlowModel>();

    public List<DeskManagedObjectSourceFlowModel> getDeskManagedObjectSourceFlows() {
        return this.deskManagedObjectSourceFlow;
    }

    public void addDeskManagedObjectSourceFlow(DeskManagedObjectSourceFlowModel deskManagedObjectSourceFlow) {
        this.addItemToList(deskManagedObjectSourceFlow, this.deskManagedObjectSourceFlow, DeskManagedObjectSourceEvent.ADD_DESK_MANAGED_OBJECT_SOURCE_FLOW);
    }

    public void removeDeskManagedObjectSourceFlow(DeskManagedObjectSourceFlowModel deskManagedObjectSourceFlow) {
        this.removeItemFromList(deskManagedObjectSourceFlow, this.deskManagedObjectSourceFlow, DeskManagedObjectSourceEvent.REMOVE_DESK_MANAGED_OBJECT_SOURCE_FLOW);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<DeskManagedObjectSourceModel> removeConnections() {
        RemoveConnectionsAction<DeskManagedObjectSourceModel> _action = new RemoveConnectionsAction<DeskManagedObjectSourceModel>(this);
        _action.disconnect(this.deskManagedObject);
        return _action;
    }
}
