/*
 * 
 */
package net.officefloor.model.desk;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class DeskModel extends AbstractModel implements ItemModel<DeskModel> {

    public static enum DeskEvent {
     ADD_EXTERNAL_MANAGED_OBJECT, REMOVE_EXTERNAL_MANAGED_OBJECT, ADD_DESK_MANAGED_OBJECT_SOURCE, REMOVE_DESK_MANAGED_OBJECT_SOURCE, ADD_DESK_MANAGED_OBJECT, REMOVE_DESK_MANAGED_OBJECT, ADD_WORK, REMOVE_WORK, ADD_TASK, REMOVE_TASK, ADD_EXTERNAL_FLOW, REMOVE_EXTERNAL_FLOW
    }

    /**
     * Default constructor.
     */
    public DeskModel() {
    }

    /**
     * Convenience constructor.
     */
    public DeskModel(
      ExternalManagedObjectModel[] externalManagedObject
    , DeskManagedObjectSourceModel[] deskManagedObjectSource
    , DeskManagedObjectModel[] deskManagedObject
    , WorkModel[] work
    , TaskModel[] task
    , ExternalFlowModel[] externalFlow
    ) {
        if (externalManagedObject != null) {
            for (ExternalManagedObjectModel model : externalManagedObject) {
                this.externalManagedObject.add(model);
            }
        }
        if (deskManagedObjectSource != null) {
            for (DeskManagedObjectSourceModel model : deskManagedObjectSource) {
                this.deskManagedObjectSource.add(model);
            }
        }
        if (deskManagedObject != null) {
            for (DeskManagedObjectModel model : deskManagedObject) {
                this.deskManagedObject.add(model);
            }
        }
        if (work != null) {
            for (WorkModel model : work) {
                this.work.add(model);
            }
        }
        if (task != null) {
            for (TaskModel model : task) {
                this.task.add(model);
            }
        }
        if (externalFlow != null) {
            for (ExternalFlowModel model : externalFlow) {
                this.externalFlow.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public DeskModel(
      ExternalManagedObjectModel[] externalManagedObject
    , DeskManagedObjectSourceModel[] deskManagedObjectSource
    , DeskManagedObjectModel[] deskManagedObject
    , WorkModel[] work
    , TaskModel[] task
    , ExternalFlowModel[] externalFlow
    , int x
    , int y
    ) {
        if (externalManagedObject != null) {
            for (ExternalManagedObjectModel model : externalManagedObject) {
                this.externalManagedObject.add(model);
            }
        }
        if (deskManagedObjectSource != null) {
            for (DeskManagedObjectSourceModel model : deskManagedObjectSource) {
                this.deskManagedObjectSource.add(model);
            }
        }
        if (deskManagedObject != null) {
            for (DeskManagedObjectModel model : deskManagedObject) {
                this.deskManagedObject.add(model);
            }
        }
        if (work != null) {
            for (WorkModel model : work) {
                this.work.add(model);
            }
        }
        if (task != null) {
            for (TaskModel model : task) {
                this.task.add(model);
            }
        }
        if (externalFlow != null) {
            for (ExternalFlowModel model : externalFlow) {
                this.externalFlow.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }


    /**
     * External managed object.
     */
    private List<ExternalManagedObjectModel> externalManagedObject = new LinkedList<ExternalManagedObjectModel>();

    public List<ExternalManagedObjectModel> getExternalManagedObjects() {
        return this.externalManagedObject;
    }

    public void addExternalManagedObject(ExternalManagedObjectModel externalManagedObject) {
        this.addItemToList(externalManagedObject, this.externalManagedObject, DeskEvent.ADD_EXTERNAL_MANAGED_OBJECT);
    }

    public void removeExternalManagedObject(ExternalManagedObjectModel externalManagedObject) {
        this.removeItemFromList(externalManagedObject, this.externalManagedObject, DeskEvent.REMOVE_EXTERNAL_MANAGED_OBJECT);
    }

    /**
     * Desk managed object source.
     */
    private List<DeskManagedObjectSourceModel> deskManagedObjectSource = new LinkedList<DeskManagedObjectSourceModel>();

    public List<DeskManagedObjectSourceModel> getDeskManagedObjectSources() {
        return this.deskManagedObjectSource;
    }

    public void addDeskManagedObjectSource(DeskManagedObjectSourceModel deskManagedObjectSource) {
        this.addItemToList(deskManagedObjectSource, this.deskManagedObjectSource, DeskEvent.ADD_DESK_MANAGED_OBJECT_SOURCE);
    }

    public void removeDeskManagedObjectSource(DeskManagedObjectSourceModel deskManagedObjectSource) {
        this.removeItemFromList(deskManagedObjectSource, this.deskManagedObjectSource, DeskEvent.REMOVE_DESK_MANAGED_OBJECT_SOURCE);
    }

    /**
     * Desk managed object.
     */
    private List<DeskManagedObjectModel> deskManagedObject = new LinkedList<DeskManagedObjectModel>();

    public List<DeskManagedObjectModel> getDeskManagedObjects() {
        return this.deskManagedObject;
    }

    public void addDeskManagedObject(DeskManagedObjectModel deskManagedObject) {
        this.addItemToList(deskManagedObject, this.deskManagedObject, DeskEvent.ADD_DESK_MANAGED_OBJECT);
    }

    public void removeDeskManagedObject(DeskManagedObjectModel deskManagedObject) {
        this.removeItemFromList(deskManagedObject, this.deskManagedObject, DeskEvent.REMOVE_DESK_MANAGED_OBJECT);
    }

    /**
     * Work.
     */
    private List<WorkModel> work = new LinkedList<WorkModel>();

    public List<WorkModel> getWorks() {
        return this.work;
    }

    public void addWork(WorkModel work) {
        this.addItemToList(work, this.work, DeskEvent.ADD_WORK);
    }

    public void removeWork(WorkModel work) {
        this.removeItemFromList(work, this.work, DeskEvent.REMOVE_WORK);
    }

    /**
     * Task.
     */
    private List<TaskModel> task = new LinkedList<TaskModel>();

    public List<TaskModel> getTasks() {
        return this.task;
    }

    public void addTask(TaskModel task) {
        this.addItemToList(task, this.task, DeskEvent.ADD_TASK);
    }

    public void removeTask(TaskModel task) {
        this.removeItemFromList(task, this.task, DeskEvent.REMOVE_TASK);
    }

    /**
     * External flow.
     */
    private List<ExternalFlowModel> externalFlow = new LinkedList<ExternalFlowModel>();

    public List<ExternalFlowModel> getExternalFlows() {
        return this.externalFlow;
    }

    public void addExternalFlow(ExternalFlowModel externalFlow) {
        this.addItemToList(externalFlow, this.externalFlow, DeskEvent.ADD_EXTERNAL_FLOW);
    }

    public void removeExternalFlow(ExternalFlowModel externalFlow) {
        this.removeItemFromList(externalFlow, this.externalFlow, DeskEvent.REMOVE_EXTERNAL_FLOW);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<DeskModel> removeConnections() {
        RemoveConnectionsAction<DeskModel> _action = new RemoveConnectionsAction<DeskModel>(this);
        return _action;
    }
}
