/*
 * 
 */
package net.officefloor.model.desk;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class ExternalFlowModel extends AbstractModel implements ItemModel<ExternalFlowModel> {

    public static enum ExternalFlowEvent {
     CHANGE_EXTERNAL_FLOW_NAME, CHANGE_ARGUMENT_TYPE, ADD_TASK_FLOW, REMOVE_TASK_FLOW, ADD_PREVIOUS_TASK, REMOVE_PREVIOUS_TASK, ADD_TASK_ESCALATION, REMOVE_TASK_ESCALATION, ADD_DESK_MANAGED_OBJECT_SOURCE_FLOW, REMOVE_DESK_MANAGED_OBJECT_SOURCE_FLOW
    }

    /**
     * Default constructor.
     */
    public ExternalFlowModel() {
    }

    /**
     * Convenience constructor for new non-linked instance.
     */
    public ExternalFlowModel(
      String externalFlowName
    , String argumentType
    ) {
        this.externalFlowName = externalFlowName;
        this.argumentType = argumentType;
    }

    /**
     * Convenience constructor.
     */
    public ExternalFlowModel(
      String externalFlowName
    , String argumentType
    , TaskFlowToExternalFlowModel[] taskFlow
    , TaskToNextExternalFlowModel[] previousTask
    , TaskEscalationToExternalFlowModel[] taskEscalation
    , DeskManagedObjectSourceFlowToExternalFlowModel[] deskManagedObjectSourceFlow
    ) {
        this.externalFlowName = externalFlowName;
        this.argumentType = argumentType;
        if (taskFlow != null) {
            for (TaskFlowToExternalFlowModel model : taskFlow) {
                this.taskFlow.add(model);
            }
        }
        if (previousTask != null) {
            for (TaskToNextExternalFlowModel model : previousTask) {
                this.previousTask.add(model);
            }
        }
        if (taskEscalation != null) {
            for (TaskEscalationToExternalFlowModel model : taskEscalation) {
                this.taskEscalation.add(model);
            }
        }
        if (deskManagedObjectSourceFlow != null) {
            for (DeskManagedObjectSourceFlowToExternalFlowModel model : deskManagedObjectSourceFlow) {
                this.deskManagedObjectSourceFlow.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public ExternalFlowModel(
      String externalFlowName
    , String argumentType
    , TaskFlowToExternalFlowModel[] taskFlow
    , TaskToNextExternalFlowModel[] previousTask
    , TaskEscalationToExternalFlowModel[] taskEscalation
    , DeskManagedObjectSourceFlowToExternalFlowModel[] deskManagedObjectSourceFlow
    , int x
    , int y
    ) {
        this.externalFlowName = externalFlowName;
        this.argumentType = argumentType;
        if (taskFlow != null) {
            for (TaskFlowToExternalFlowModel model : taskFlow) {
                this.taskFlow.add(model);
            }
        }
        if (previousTask != null) {
            for (TaskToNextExternalFlowModel model : previousTask) {
                this.previousTask.add(model);
            }
        }
        if (taskEscalation != null) {
            for (TaskEscalationToExternalFlowModel model : taskEscalation) {
                this.taskEscalation.add(model);
            }
        }
        if (deskManagedObjectSourceFlow != null) {
            for (DeskManagedObjectSourceFlowToExternalFlowModel model : deskManagedObjectSourceFlow) {
                this.deskManagedObjectSourceFlow.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }

    /**
     * External flow name.
     */
    private String externalFlowName;

    public String getExternalFlowName() {
        return this.externalFlowName;
    }

    public void setExternalFlowName(String externalFlowName) {
        String oldValue = this.externalFlowName;
        this.externalFlowName = externalFlowName;
        this.changeField(oldValue, this.externalFlowName, ExternalFlowEvent.CHANGE_EXTERNAL_FLOW_NAME);
    }

    /**
     * Argument type.
     */
    private String argumentType;

    public String getArgumentType() {
        return this.argumentType;
    }

    public void setArgumentType(String argumentType) {
        String oldValue = this.argumentType;
        this.argumentType = argumentType;
        this.changeField(oldValue, this.argumentType, ExternalFlowEvent.CHANGE_ARGUMENT_TYPE);
    }


    /**
     * Task flow.
     */
    private List<TaskFlowToExternalFlowModel> taskFlow = new LinkedList<TaskFlowToExternalFlowModel>();

    public List<TaskFlowToExternalFlowModel> getTaskFlows() {
        return this.taskFlow;
    }

    public void addTaskFlow(TaskFlowToExternalFlowModel taskFlow) {
        this.addItemToList(taskFlow, this.taskFlow, ExternalFlowEvent.ADD_TASK_FLOW);
    }

    public void removeTaskFlow(TaskFlowToExternalFlowModel taskFlow) {
        this.removeItemFromList(taskFlow, this.taskFlow, ExternalFlowEvent.REMOVE_TASK_FLOW);
    }

    /**
     * Previous task.
     */
    private List<TaskToNextExternalFlowModel> previousTask = new LinkedList<TaskToNextExternalFlowModel>();

    public List<TaskToNextExternalFlowModel> getPreviousTasks() {
        return this.previousTask;
    }

    public void addPreviousTask(TaskToNextExternalFlowModel previousTask) {
        this.addItemToList(previousTask, this.previousTask, ExternalFlowEvent.ADD_PREVIOUS_TASK);
    }

    public void removePreviousTask(TaskToNextExternalFlowModel previousTask) {
        this.removeItemFromList(previousTask, this.previousTask, ExternalFlowEvent.REMOVE_PREVIOUS_TASK);
    }

    /**
     * Task escalation.
     */
    private List<TaskEscalationToExternalFlowModel> taskEscalation = new LinkedList<TaskEscalationToExternalFlowModel>();

    public List<TaskEscalationToExternalFlowModel> getTaskEscalations() {
        return this.taskEscalation;
    }

    public void addTaskEscalation(TaskEscalationToExternalFlowModel taskEscalation) {
        this.addItemToList(taskEscalation, this.taskEscalation, ExternalFlowEvent.ADD_TASK_ESCALATION);
    }

    public void removeTaskEscalation(TaskEscalationToExternalFlowModel taskEscalation) {
        this.removeItemFromList(taskEscalation, this.taskEscalation, ExternalFlowEvent.REMOVE_TASK_ESCALATION);
    }

    /**
     * Desk managed object source flow.
     */
    private List<DeskManagedObjectSourceFlowToExternalFlowModel> deskManagedObjectSourceFlow = new LinkedList<DeskManagedObjectSourceFlowToExternalFlowModel>();

    public List<DeskManagedObjectSourceFlowToExternalFlowModel> getDeskManagedObjectSourceFlows() {
        return this.deskManagedObjectSourceFlow;
    }

    public void addDeskManagedObjectSourceFlow(DeskManagedObjectSourceFlowToExternalFlowModel deskManagedObjectSourceFlow) {
        this.addItemToList(deskManagedObjectSourceFlow, this.deskManagedObjectSourceFlow, ExternalFlowEvent.ADD_DESK_MANAGED_OBJECT_SOURCE_FLOW);
    }

    public void removeDeskManagedObjectSourceFlow(DeskManagedObjectSourceFlowToExternalFlowModel deskManagedObjectSourceFlow) {
        this.removeItemFromList(deskManagedObjectSourceFlow, this.deskManagedObjectSourceFlow, ExternalFlowEvent.REMOVE_DESK_MANAGED_OBJECT_SOURCE_FLOW);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<ExternalFlowModel> removeConnections() {
        RemoveConnectionsAction<ExternalFlowModel> _action = new RemoveConnectionsAction<ExternalFlowModel>(this);
        _action.disconnect(this.taskFlow);
        _action.disconnect(this.previousTask);
        _action.disconnect(this.taskEscalation);
        _action.disconnect(this.deskManagedObjectSourceFlow);
        return _action;
    }
}
