/*
 * 
 */
package net.officefloor.model.desk;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class ExternalManagedObjectModel extends AbstractModel implements ItemModel<ExternalManagedObjectModel> {

    public static enum ExternalManagedObjectEvent {
     CHANGE_EXTERNAL_MANAGED_OBJECT_NAME, CHANGE_OBJECT_TYPE, ADD_TASK_OBJECT, REMOVE_TASK_OBJECT, ADD_DEPENDENT_DESK_MANAGED_OBJECT, REMOVE_DEPENDENT_DESK_MANAGED_OBJECT
    }

    /**
     * Default constructor.
     */
    public ExternalManagedObjectModel() {
    }

    /**
     * Convenience constructor for new non-linked instance.
     */
    public ExternalManagedObjectModel(
      String externalManagedObjectName
    , String objectType
    ) {
        this.externalManagedObjectName = externalManagedObjectName;
        this.objectType = objectType;
    }

    /**
     * Convenience constructor.
     */
    public ExternalManagedObjectModel(
      String externalManagedObjectName
    , String objectType
    , WorkTaskObjectToExternalManagedObjectModel[] taskObject
    , DeskManagedObjectDependencyToExternalManagedObjectModel[] dependentDeskManagedObject
    ) {
        this.externalManagedObjectName = externalManagedObjectName;
        this.objectType = objectType;
        if (taskObject != null) {
            for (WorkTaskObjectToExternalManagedObjectModel model : taskObject) {
                this.taskObject.add(model);
            }
        }
        if (dependentDeskManagedObject != null) {
            for (DeskManagedObjectDependencyToExternalManagedObjectModel model : dependentDeskManagedObject) {
                this.dependentDeskManagedObject.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public ExternalManagedObjectModel(
      String externalManagedObjectName
    , String objectType
    , WorkTaskObjectToExternalManagedObjectModel[] taskObject
    , DeskManagedObjectDependencyToExternalManagedObjectModel[] dependentDeskManagedObject
    , int x
    , int y
    ) {
        this.externalManagedObjectName = externalManagedObjectName;
        this.objectType = objectType;
        if (taskObject != null) {
            for (WorkTaskObjectToExternalManagedObjectModel model : taskObject) {
                this.taskObject.add(model);
            }
        }
        if (dependentDeskManagedObject != null) {
            for (DeskManagedObjectDependencyToExternalManagedObjectModel model : dependentDeskManagedObject) {
                this.dependentDeskManagedObject.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }

    /**
     * External managed object name.
     */
    private String externalManagedObjectName;

    public String getExternalManagedObjectName() {
        return this.externalManagedObjectName;
    }

    public void setExternalManagedObjectName(String externalManagedObjectName) {
        String oldValue = this.externalManagedObjectName;
        this.externalManagedObjectName = externalManagedObjectName;
        this.changeField(oldValue, this.externalManagedObjectName, ExternalManagedObjectEvent.CHANGE_EXTERNAL_MANAGED_OBJECT_NAME);
    }

    /**
     * Object type.
     */
    private String objectType;

    public String getObjectType() {
        return this.objectType;
    }

    public void setObjectType(String objectType) {
        String oldValue = this.objectType;
        this.objectType = objectType;
        this.changeField(oldValue, this.objectType, ExternalManagedObjectEvent.CHANGE_OBJECT_TYPE);
    }


    /**
     * Task object.
     */
    private List<WorkTaskObjectToExternalManagedObjectModel> taskObject = new LinkedList<WorkTaskObjectToExternalManagedObjectModel>();

    public List<WorkTaskObjectToExternalManagedObjectModel> getTaskObjects() {
        return this.taskObject;
    }

    public void addTaskObject(WorkTaskObjectToExternalManagedObjectModel taskObject) {
        this.addItemToList(taskObject, this.taskObject, ExternalManagedObjectEvent.ADD_TASK_OBJECT);
    }

    public void removeTaskObject(WorkTaskObjectToExternalManagedObjectModel taskObject) {
        this.removeItemFromList(taskObject, this.taskObject, ExternalManagedObjectEvent.REMOVE_TASK_OBJECT);
    }

    /**
     * Dependent desk managed object.
     */
    private List<DeskManagedObjectDependencyToExternalManagedObjectModel> dependentDeskManagedObject = new LinkedList<DeskManagedObjectDependencyToExternalManagedObjectModel>();

    public List<DeskManagedObjectDependencyToExternalManagedObjectModel> getDependentDeskManagedObjects() {
        return this.dependentDeskManagedObject;
    }

    public void addDependentDeskManagedObject(DeskManagedObjectDependencyToExternalManagedObjectModel dependentDeskManagedObject) {
        this.addItemToList(dependentDeskManagedObject, this.dependentDeskManagedObject, ExternalManagedObjectEvent.ADD_DEPENDENT_DESK_MANAGED_OBJECT);
    }

    public void removeDependentDeskManagedObject(DeskManagedObjectDependencyToExternalManagedObjectModel dependentDeskManagedObject) {
        this.removeItemFromList(dependentDeskManagedObject, this.dependentDeskManagedObject, ExternalManagedObjectEvent.REMOVE_DEPENDENT_DESK_MANAGED_OBJECT);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<ExternalManagedObjectModel> removeConnections() {
        RemoveConnectionsAction<ExternalManagedObjectModel> _action = new RemoveConnectionsAction<ExternalManagedObjectModel>(this);
        _action.disconnect(this.taskObject);
        _action.disconnect(this.dependentDeskManagedObject);
        return _action;
    }
}
