/*
 * 
 */
package net.officefloor.model.desk;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class TaskModel extends AbstractModel implements ItemModel<TaskModel> {

    public static enum TaskEvent {
     CHANGE_TASK_NAME, CHANGE_IS_PUBLIC, CHANGE_WORK_NAME, CHANGE_WORK_TASK_NAME, CHANGE_RETURN_TYPE, CHANGE_INITIAL_TASK_FOR_WORK, CHANGE_WORK_TASK, CHANGE_NEXT_EXTERNAL_FLOW, CHANGE_NEXT_TASK, ADD_PREVIOUS_TASK, REMOVE_PREVIOUS_TASK, ADD_TASK_FLOW, REMOVE_TASK_FLOW, ADD_TASK_FLOW_INPUT, REMOVE_TASK_FLOW_INPUT, ADD_TASK_ESCALATION, REMOVE_TASK_ESCALATION, ADD_TASK_ESCALATION_INPUT, REMOVE_TASK_ESCALATION_INPUT, ADD_DESK_MANAGED_OBJECT_SOURCE_FLOW, REMOVE_DESK_MANAGED_OBJECT_SOURCE_FLOW
    }

    /**
     * Default constructor.
     */
    public TaskModel() {
    }

    /**
     * Convenience constructor for new non-linked instance.
     */
    public TaskModel(
      String taskName
    , boolean isPublic
    , String workName
    , String workTaskName
    , String returnType
    ) {
        this.taskName = taskName;
        this.isPublic = isPublic;
        this.workName = workName;
        this.workTaskName = workTaskName;
        this.returnType = returnType;
    }

    /**
     * Convenience constructor.
     */
    public TaskModel(
      String taskName
    , boolean isPublic
    , String workName
    , String workTaskName
    , String returnType
    , WorkToInitialTaskModel initialTaskForWork
    , WorkTaskToTaskModel workTask
    , TaskToNextExternalFlowModel nextExternalFlow
    , TaskToNextTaskModel nextTask
    , TaskToNextTaskModel[] previousTask
    , TaskFlowModel[] taskFlow
    , TaskFlowToTaskModel[] taskFlowInput
    , TaskEscalationModel[] taskEscalation
    , TaskEscalationToTaskModel[] taskEscalationInput
    , DeskManagedObjectSourceFlowToTaskModel[] deskManagedObjectSourceFlow
    ) {
        this.taskName = taskName;
        this.isPublic = isPublic;
        this.workName = workName;
        this.workTaskName = workTaskName;
        this.returnType = returnType;
        this.initialTaskForWork = initialTaskForWork;
        this.workTask = workTask;
        this.nextExternalFlow = nextExternalFlow;
        this.nextTask = nextTask;
        if (previousTask != null) {
            for (TaskToNextTaskModel model : previousTask) {
                this.previousTask.add(model);
            }
        }
        if (taskFlow != null) {
            for (TaskFlowModel model : taskFlow) {
                this.taskFlow.add(model);
            }
        }
        if (taskFlowInput != null) {
            for (TaskFlowToTaskModel model : taskFlowInput) {
                this.taskFlowInput.add(model);
            }
        }
        if (taskEscalation != null) {
            for (TaskEscalationModel model : taskEscalation) {
                this.taskEscalation.add(model);
            }
        }
        if (taskEscalationInput != null) {
            for (TaskEscalationToTaskModel model : taskEscalationInput) {
                this.taskEscalationInput.add(model);
            }
        }
        if (deskManagedObjectSourceFlow != null) {
            for (DeskManagedObjectSourceFlowToTaskModel model : deskManagedObjectSourceFlow) {
                this.deskManagedObjectSourceFlow.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public TaskModel(
      String taskName
    , boolean isPublic
    , String workName
    , String workTaskName
    , String returnType
    , WorkToInitialTaskModel initialTaskForWork
    , WorkTaskToTaskModel workTask
    , TaskToNextExternalFlowModel nextExternalFlow
    , TaskToNextTaskModel nextTask
    , TaskToNextTaskModel[] previousTask
    , TaskFlowModel[] taskFlow
    , TaskFlowToTaskModel[] taskFlowInput
    , TaskEscalationModel[] taskEscalation
    , TaskEscalationToTaskModel[] taskEscalationInput
    , DeskManagedObjectSourceFlowToTaskModel[] deskManagedObjectSourceFlow
    , int x
    , int y
    ) {
        this.taskName = taskName;
        this.isPublic = isPublic;
        this.workName = workName;
        this.workTaskName = workTaskName;
        this.returnType = returnType;
        this.initialTaskForWork = initialTaskForWork;
        this.workTask = workTask;
        this.nextExternalFlow = nextExternalFlow;
        this.nextTask = nextTask;
        if (previousTask != null) {
            for (TaskToNextTaskModel model : previousTask) {
                this.previousTask.add(model);
            }
        }
        if (taskFlow != null) {
            for (TaskFlowModel model : taskFlow) {
                this.taskFlow.add(model);
            }
        }
        if (taskFlowInput != null) {
            for (TaskFlowToTaskModel model : taskFlowInput) {
                this.taskFlowInput.add(model);
            }
        }
        if (taskEscalation != null) {
            for (TaskEscalationModel model : taskEscalation) {
                this.taskEscalation.add(model);
            }
        }
        if (taskEscalationInput != null) {
            for (TaskEscalationToTaskModel model : taskEscalationInput) {
                this.taskEscalationInput.add(model);
            }
        }
        if (deskManagedObjectSourceFlow != null) {
            for (DeskManagedObjectSourceFlowToTaskModel model : deskManagedObjectSourceFlow) {
                this.deskManagedObjectSourceFlow.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }

    /**
     * Task name.
     */
    private String taskName;

    public String getTaskName() {
        return this.taskName;
    }

    public void setTaskName(String taskName) {
        String oldValue = this.taskName;
        this.taskName = taskName;
        this.changeField(oldValue, this.taskName, TaskEvent.CHANGE_TASK_NAME);
    }

    /**
     * Is public.
     */
    private boolean isPublic;

    public boolean getIsPublic() {
        return this.isPublic;
    }

    public void setIsPublic(boolean isPublic) {
        boolean oldValue = this.isPublic;
        this.isPublic = isPublic;
        this.changeField(oldValue, this.isPublic, TaskEvent.CHANGE_IS_PUBLIC);
    }

    /**
     * Work name.
     */
    private String workName;

    public String getWorkName() {
        return this.workName;
    }

    public void setWorkName(String workName) {
        String oldValue = this.workName;
        this.workName = workName;
        this.changeField(oldValue, this.workName, TaskEvent.CHANGE_WORK_NAME);
    }

    /**
     * Work task name.
     */
    private String workTaskName;

    public String getWorkTaskName() {
        return this.workTaskName;
    }

    public void setWorkTaskName(String workTaskName) {
        String oldValue = this.workTaskName;
        this.workTaskName = workTaskName;
        this.changeField(oldValue, this.workTaskName, TaskEvent.CHANGE_WORK_TASK_NAME);
    }

    /**
     * Return type.
     */
    private String returnType;

    public String getReturnType() {
        return this.returnType;
    }

    public void setReturnType(String returnType) {
        String oldValue = this.returnType;
        this.returnType = returnType;
        this.changeField(oldValue, this.returnType, TaskEvent.CHANGE_RETURN_TYPE);
    }

    /**
     * Initial task for work.
     */
    private WorkToInitialTaskModel initialTaskForWork;

    public WorkToInitialTaskModel getInitialTaskForWork() {
        return this.initialTaskForWork;
    }

    public void setInitialTaskForWork(WorkToInitialTaskModel initialTaskForWork) {
        WorkToInitialTaskModel oldValue = this.initialTaskForWork;
        this.initialTaskForWork = initialTaskForWork;
        this.changeField(oldValue, this.initialTaskForWork, TaskEvent.CHANGE_INITIAL_TASK_FOR_WORK);
    }

    /**
     * Work task.
     */
    private WorkTaskToTaskModel workTask;

    public WorkTaskToTaskModel getWorkTask() {
        return this.workTask;
    }

    public void setWorkTask(WorkTaskToTaskModel workTask) {
        WorkTaskToTaskModel oldValue = this.workTask;
        this.workTask = workTask;
        this.changeField(oldValue, this.workTask, TaskEvent.CHANGE_WORK_TASK);
    }

    /**
     * Next external flow.
     */
    private TaskToNextExternalFlowModel nextExternalFlow;

    public TaskToNextExternalFlowModel getNextExternalFlow() {
        return this.nextExternalFlow;
    }

    public void setNextExternalFlow(TaskToNextExternalFlowModel nextExternalFlow) {
        TaskToNextExternalFlowModel oldValue = this.nextExternalFlow;
        this.nextExternalFlow = nextExternalFlow;
        this.changeField(oldValue, this.nextExternalFlow, TaskEvent.CHANGE_NEXT_EXTERNAL_FLOW);
    }

    /**
     * Next task.
     */
    private TaskToNextTaskModel nextTask;

    public TaskToNextTaskModel getNextTask() {
        return this.nextTask;
    }

    public void setNextTask(TaskToNextTaskModel nextTask) {
        TaskToNextTaskModel oldValue = this.nextTask;
        this.nextTask = nextTask;
        this.changeField(oldValue, this.nextTask, TaskEvent.CHANGE_NEXT_TASK);
    }


    /**
     * Previous task.
     */
    private List<TaskToNextTaskModel> previousTask = new LinkedList<TaskToNextTaskModel>();

    public List<TaskToNextTaskModel> getPreviousTasks() {
        return this.previousTask;
    }

    public void addPreviousTask(TaskToNextTaskModel previousTask) {
        this.addItemToList(previousTask, this.previousTask, TaskEvent.ADD_PREVIOUS_TASK);
    }

    public void removePreviousTask(TaskToNextTaskModel previousTask) {
        this.removeItemFromList(previousTask, this.previousTask, TaskEvent.REMOVE_PREVIOUS_TASK);
    }

    /**
     * Task flow.
     */
    private List<TaskFlowModel> taskFlow = new LinkedList<TaskFlowModel>();

    public List<TaskFlowModel> getTaskFlows() {
        return this.taskFlow;
    }

    public void addTaskFlow(TaskFlowModel taskFlow) {
        this.addItemToList(taskFlow, this.taskFlow, TaskEvent.ADD_TASK_FLOW);
    }

    public void removeTaskFlow(TaskFlowModel taskFlow) {
        this.removeItemFromList(taskFlow, this.taskFlow, TaskEvent.REMOVE_TASK_FLOW);
    }

    /**
     * Task flow input.
     */
    private List<TaskFlowToTaskModel> taskFlowInput = new LinkedList<TaskFlowToTaskModel>();

    public List<TaskFlowToTaskModel> getTaskFlowInputs() {
        return this.taskFlowInput;
    }

    public void addTaskFlowInput(TaskFlowToTaskModel taskFlowInput) {
        this.addItemToList(taskFlowInput, this.taskFlowInput, TaskEvent.ADD_TASK_FLOW_INPUT);
    }

    public void removeTaskFlowInput(TaskFlowToTaskModel taskFlowInput) {
        this.removeItemFromList(taskFlowInput, this.taskFlowInput, TaskEvent.REMOVE_TASK_FLOW_INPUT);
    }

    /**
     * Task escalation.
     */
    private List<TaskEscalationModel> taskEscalation = new LinkedList<TaskEscalationModel>();

    public List<TaskEscalationModel> getTaskEscalations() {
        return this.taskEscalation;
    }

    public void addTaskEscalation(TaskEscalationModel taskEscalation) {
        this.addItemToList(taskEscalation, this.taskEscalation, TaskEvent.ADD_TASK_ESCALATION);
    }

    public void removeTaskEscalation(TaskEscalationModel taskEscalation) {
        this.removeItemFromList(taskEscalation, this.taskEscalation, TaskEvent.REMOVE_TASK_ESCALATION);
    }

    /**
     * Task escalation input.
     */
    private List<TaskEscalationToTaskModel> taskEscalationInput = new LinkedList<TaskEscalationToTaskModel>();

    public List<TaskEscalationToTaskModel> getTaskEscalationInputs() {
        return this.taskEscalationInput;
    }

    public void addTaskEscalationInput(TaskEscalationToTaskModel taskEscalationInput) {
        this.addItemToList(taskEscalationInput, this.taskEscalationInput, TaskEvent.ADD_TASK_ESCALATION_INPUT);
    }

    public void removeTaskEscalationInput(TaskEscalationToTaskModel taskEscalationInput) {
        this.removeItemFromList(taskEscalationInput, this.taskEscalationInput, TaskEvent.REMOVE_TASK_ESCALATION_INPUT);
    }

    /**
     * Desk managed object source flow.
     */
    private List<DeskManagedObjectSourceFlowToTaskModel> deskManagedObjectSourceFlow = new LinkedList<DeskManagedObjectSourceFlowToTaskModel>();

    public List<DeskManagedObjectSourceFlowToTaskModel> getDeskManagedObjectSourceFlows() {
        return this.deskManagedObjectSourceFlow;
    }

    public void addDeskManagedObjectSourceFlow(DeskManagedObjectSourceFlowToTaskModel deskManagedObjectSourceFlow) {
        this.addItemToList(deskManagedObjectSourceFlow, this.deskManagedObjectSourceFlow, TaskEvent.ADD_DESK_MANAGED_OBJECT_SOURCE_FLOW);
    }

    public void removeDeskManagedObjectSourceFlow(DeskManagedObjectSourceFlowToTaskModel deskManagedObjectSourceFlow) {
        this.removeItemFromList(deskManagedObjectSourceFlow, this.deskManagedObjectSourceFlow, TaskEvent.REMOVE_DESK_MANAGED_OBJECT_SOURCE_FLOW);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<TaskModel> removeConnections() {
        RemoveConnectionsAction<TaskModel> _action = new RemoveConnectionsAction<TaskModel>(this);
        _action.disconnect(this.initialTaskForWork);
        _action.disconnect(this.workTask);
        _action.disconnect(this.nextExternalFlow);
        _action.disconnect(this.nextTask);
        _action.disconnect(this.previousTask);
        _action.disconnect(this.taskFlowInput);
        _action.disconnect(this.taskEscalationInput);
        _action.disconnect(this.deskManagedObjectSourceFlow);
        for (TaskFlowModel _cascade : this.taskFlow) {
            _action.addCascadeModel(_cascade.removeConnections());
        }
        for (TaskEscalationModel _cascade : this.taskEscalation) {
            _action.addCascadeModel(_cascade.removeConnections());
        }
        return _action;
    }
}
