/*
 * 
 */
package net.officefloor.model.desk;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ConnectionModel;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class TaskToNextExternalFlowModel extends AbstractModel implements ConnectionModel {

    public static enum TaskToNextExternalFlowEvent {
     CHANGE_EXTERNAL_FLOW_NAME, CHANGE_PREVIOUS_TASK, CHANGE_NEXT_EXTERNAL_FLOW
    }

    /**
     * Default constructor.
     */
    public TaskToNextExternalFlowModel() {
    }

    /**
     * Convenience constructor for new non-linked instance.
     */
    public TaskToNextExternalFlowModel(
      String externalFlowName
    ) {
        this.externalFlowName = externalFlowName;
    }

    /**
     * Convenience constructor.
     */
    public TaskToNextExternalFlowModel(
      String externalFlowName
    , TaskModel previousTask
    , ExternalFlowModel nextExternalFlow
    ) {
        this.externalFlowName = externalFlowName;
        this.previousTask = previousTask;
        this.nextExternalFlow = nextExternalFlow;
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public TaskToNextExternalFlowModel(
      String externalFlowName
    , TaskModel previousTask
    , ExternalFlowModel nextExternalFlow
    , int x
    , int y
    ) {
        this.externalFlowName = externalFlowName;
        this.previousTask = previousTask;
        this.nextExternalFlow = nextExternalFlow;
        this.setX(x);
        this.setY(y);
    }

    /**
     * External flow name.
     */
    private String externalFlowName;

    public String getExternalFlowName() {
        return this.externalFlowName;
    }

    public void setExternalFlowName(String externalFlowName) {
        String oldValue = this.externalFlowName;
        this.externalFlowName = externalFlowName;
        this.changeField(oldValue, this.externalFlowName, TaskToNextExternalFlowEvent.CHANGE_EXTERNAL_FLOW_NAME);
    }

    /**
     * Previous task.
     */
    private TaskModel previousTask;

    public TaskModel getPreviousTask() {
        return this.previousTask;
    }

    public void setPreviousTask(TaskModel previousTask) {
        TaskModel oldValue = this.previousTask;
        this.previousTask = previousTask;
        this.changeField(oldValue, this.previousTask, TaskToNextExternalFlowEvent.CHANGE_PREVIOUS_TASK);
    }

    /**
     * Next external flow.
     */
    private ExternalFlowModel nextExternalFlow;

    public ExternalFlowModel getNextExternalFlow() {
        return this.nextExternalFlow;
    }

    public void setNextExternalFlow(ExternalFlowModel nextExternalFlow) {
        ExternalFlowModel oldValue = this.nextExternalFlow;
        this.nextExternalFlow = nextExternalFlow;
        this.changeField(oldValue, this.nextExternalFlow, TaskToNextExternalFlowEvent.CHANGE_NEXT_EXTERNAL_FLOW);
    }



    /*
     * ConnectionModel
     */
    public boolean isRemovable() {
        return true;
    }

    public void connect() {
        this.previousTask.setNextExternalFlow(this);
        this.nextExternalFlow.addPreviousTask(this);
    }

    public void remove() {
        this.previousTask.setNextExternalFlow(null);
        this.nextExternalFlow.removePreviousTask(this);
    }

}
