/*
 * 
 */
package net.officefloor.model.desk;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ConnectionModel;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class TaskToNextTaskModel extends AbstractModel implements ConnectionModel {

    public static enum TaskToNextTaskEvent {
     CHANGE_NEXT_TASK_NAME, CHANGE_PREVIOUS_TASK, CHANGE_NEXT_TASK
    }

    /**
     * Default constructor.
     */
    public TaskToNextTaskModel() {
    }

    /**
     * Convenience constructor for new non-linked instance.
     */
    public TaskToNextTaskModel(
      String nextTaskName
    ) {
        this.nextTaskName = nextTaskName;
    }

    /**
     * Convenience constructor.
     */
    public TaskToNextTaskModel(
      String nextTaskName
    , TaskModel previousTask
    , TaskModel nextTask
    ) {
        this.nextTaskName = nextTaskName;
        this.previousTask = previousTask;
        this.nextTask = nextTask;
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public TaskToNextTaskModel(
      String nextTaskName
    , TaskModel previousTask
    , TaskModel nextTask
    , int x
    , int y
    ) {
        this.nextTaskName = nextTaskName;
        this.previousTask = previousTask;
        this.nextTask = nextTask;
        this.setX(x);
        this.setY(y);
    }

    /**
     * Next task name.
     */
    private String nextTaskName;

    public String getNextTaskName() {
        return this.nextTaskName;
    }

    public void setNextTaskName(String nextTaskName) {
        String oldValue = this.nextTaskName;
        this.nextTaskName = nextTaskName;
        this.changeField(oldValue, this.nextTaskName, TaskToNextTaskEvent.CHANGE_NEXT_TASK_NAME);
    }

    /**
     * Previous task.
     */
    private TaskModel previousTask;

    public TaskModel getPreviousTask() {
        return this.previousTask;
    }

    public void setPreviousTask(TaskModel previousTask) {
        TaskModel oldValue = this.previousTask;
        this.previousTask = previousTask;
        this.changeField(oldValue, this.previousTask, TaskToNextTaskEvent.CHANGE_PREVIOUS_TASK);
    }

    /**
     * Next task.
     */
    private TaskModel nextTask;

    public TaskModel getNextTask() {
        return this.nextTask;
    }

    public void setNextTask(TaskModel nextTask) {
        TaskModel oldValue = this.nextTask;
        this.nextTask = nextTask;
        this.changeField(oldValue, this.nextTask, TaskToNextTaskEvent.CHANGE_NEXT_TASK);
    }



    /*
     * ConnectionModel
     */
    public boolean isRemovable() {
        return true;
    }

    public void connect() {
        this.previousTask.setNextTask(this);
        this.nextTask.addPreviousTask(this);
    }

    public void remove() {
        this.previousTask.setNextTask(null);
        this.nextTask.removePreviousTask(this);
    }

}
