/*
 * 
 */
package net.officefloor.model.desk;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class WorkModel extends AbstractModel implements ItemModel<WorkModel> {

    public static enum WorkEvent {
     CHANGE_WORK_NAME, CHANGE_WORK_SOURCE_CLASS_NAME, CHANGE_INITIAL_TASK, ADD_WORK_TASK, REMOVE_WORK_TASK, ADD_PROPERTY, REMOVE_PROPERTY
    }

    /**
     * Default constructor.
     */
    public WorkModel() {
    }

    /**
     * Convenience constructor for new non-linked instance.
     */
    public WorkModel(
      String workName
    , String workSourceClassName
    ) {
        this.workName = workName;
        this.workSourceClassName = workSourceClassName;
    }

    /**
     * Convenience constructor.
     */
    public WorkModel(
      String workName
    , String workSourceClassName
    , WorkToInitialTaskModel initialTask
    , WorkTaskModel[] workTask
    , PropertyModel[] property
    ) {
        this.workName = workName;
        this.workSourceClassName = workSourceClassName;
        this.initialTask = initialTask;
        if (workTask != null) {
            for (WorkTaskModel model : workTask) {
                this.workTask.add(model);
            }
        }
        if (property != null) {
            for (PropertyModel model : property) {
                this.property.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public WorkModel(
      String workName
    , String workSourceClassName
    , WorkToInitialTaskModel initialTask
    , WorkTaskModel[] workTask
    , PropertyModel[] property
    , int x
    , int y
    ) {
        this.workName = workName;
        this.workSourceClassName = workSourceClassName;
        this.initialTask = initialTask;
        if (workTask != null) {
            for (WorkTaskModel model : workTask) {
                this.workTask.add(model);
            }
        }
        if (property != null) {
            for (PropertyModel model : property) {
                this.property.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }

    /**
     * Work name.
     */
    private String workName;

    public String getWorkName() {
        return this.workName;
    }

    public void setWorkName(String workName) {
        String oldValue = this.workName;
        this.workName = workName;
        this.changeField(oldValue, this.workName, WorkEvent.CHANGE_WORK_NAME);
    }

    /**
     * Work source class name.
     */
    private String workSourceClassName;

    public String getWorkSourceClassName() {
        return this.workSourceClassName;
    }

    public void setWorkSourceClassName(String workSourceClassName) {
        String oldValue = this.workSourceClassName;
        this.workSourceClassName = workSourceClassName;
        this.changeField(oldValue, this.workSourceClassName, WorkEvent.CHANGE_WORK_SOURCE_CLASS_NAME);
    }

    /**
     * Initial task.
     */
    private WorkToInitialTaskModel initialTask;

    public WorkToInitialTaskModel getInitialTask() {
        return this.initialTask;
    }

    public void setInitialTask(WorkToInitialTaskModel initialTask) {
        WorkToInitialTaskModel oldValue = this.initialTask;
        this.initialTask = initialTask;
        this.changeField(oldValue, this.initialTask, WorkEvent.CHANGE_INITIAL_TASK);
    }


    /**
     * Work task.
     */
    private List<WorkTaskModel> workTask = new LinkedList<WorkTaskModel>();

    public List<WorkTaskModel> getWorkTasks() {
        return this.workTask;
    }

    public void addWorkTask(WorkTaskModel workTask) {
        this.addItemToList(workTask, this.workTask, WorkEvent.ADD_WORK_TASK);
    }

    public void removeWorkTask(WorkTaskModel workTask) {
        this.removeItemFromList(workTask, this.workTask, WorkEvent.REMOVE_WORK_TASK);
    }

    /**
     * Property.
     */
    private List<PropertyModel> property = new LinkedList<PropertyModel>();

    public List<PropertyModel> getProperties() {
        return this.property;
    }

    public void addProperty(PropertyModel property) {
        this.addItemToList(property, this.property, WorkEvent.ADD_PROPERTY);
    }

    public void removeProperty(PropertyModel property) {
        this.removeItemFromList(property, this.property, WorkEvent.REMOVE_PROPERTY);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<WorkModel> removeConnections() {
        RemoveConnectionsAction<WorkModel> _action = new RemoveConnectionsAction<WorkModel>(this);
        _action.disconnect(this.initialTask);
        for (WorkTaskModel _cascade : this.workTask) {
            _action.addCascadeModel(_cascade.removeConnections());
        }
        return _action;
    }
}
