/*
 * 
 */
package net.officefloor.model.desk;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class WorkTaskModel extends AbstractModel implements ItemModel<WorkTaskModel> {

    public static enum WorkTaskEvent {
     CHANGE_WORK_TASK_NAME, ADD_TASK_OBJECT, REMOVE_TASK_OBJECT, ADD_TASK, REMOVE_TASK
    }

    /**
     * Default constructor.
     */
    public WorkTaskModel() {
    }

    /**
     * Convenience constructor for new non-linked instance.
     */
    public WorkTaskModel(
      String workTaskName
    ) {
        this.workTaskName = workTaskName;
    }

    /**
     * Convenience constructor.
     */
    public WorkTaskModel(
      String workTaskName
    , WorkTaskObjectModel[] taskObject
    , WorkTaskToTaskModel[] task
    ) {
        this.workTaskName = workTaskName;
        if (taskObject != null) {
            for (WorkTaskObjectModel model : taskObject) {
                this.taskObject.add(model);
            }
        }
        if (task != null) {
            for (WorkTaskToTaskModel model : task) {
                this.task.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public WorkTaskModel(
      String workTaskName
    , WorkTaskObjectModel[] taskObject
    , WorkTaskToTaskModel[] task
    , int x
    , int y
    ) {
        this.workTaskName = workTaskName;
        if (taskObject != null) {
            for (WorkTaskObjectModel model : taskObject) {
                this.taskObject.add(model);
            }
        }
        if (task != null) {
            for (WorkTaskToTaskModel model : task) {
                this.task.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }

    /**
     * Work task name.
     */
    private String workTaskName;

    public String getWorkTaskName() {
        return this.workTaskName;
    }

    public void setWorkTaskName(String workTaskName) {
        String oldValue = this.workTaskName;
        this.workTaskName = workTaskName;
        this.changeField(oldValue, this.workTaskName, WorkTaskEvent.CHANGE_WORK_TASK_NAME);
    }


    /**
     * Task object.
     */
    private List<WorkTaskObjectModel> taskObject = new LinkedList<WorkTaskObjectModel>();

    public List<WorkTaskObjectModel> getTaskObjects() {
        return this.taskObject;
    }

    public void addTaskObject(WorkTaskObjectModel taskObject) {
        this.addItemToList(taskObject, this.taskObject, WorkTaskEvent.ADD_TASK_OBJECT);
    }

    public void removeTaskObject(WorkTaskObjectModel taskObject) {
        this.removeItemFromList(taskObject, this.taskObject, WorkTaskEvent.REMOVE_TASK_OBJECT);
    }

    /**
     * Task.
     */
    private List<WorkTaskToTaskModel> task = new LinkedList<WorkTaskToTaskModel>();

    public List<WorkTaskToTaskModel> getTasks() {
        return this.task;
    }

    public void addTask(WorkTaskToTaskModel task) {
        this.addItemToList(task, this.task, WorkTaskEvent.ADD_TASK);
    }

    public void removeTask(WorkTaskToTaskModel task) {
        this.removeItemFromList(task, this.task, WorkTaskEvent.REMOVE_TASK);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<WorkTaskModel> removeConnections() {
        RemoveConnectionsAction<WorkTaskModel> _action = new RemoveConnectionsAction<WorkTaskModel>(this);
        _action.disconnect(this.task);
        for (WorkTaskObjectModel _cascade : this.taskObject) {
            _action.addCascadeModel(_cascade.removeConnections());
        }
        return _action;
    }
}
