/*
 * 
 */
package net.officefloor.model.office;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class AdministratorModel extends AbstractModel implements ItemModel<AdministratorModel> {

    public static enum AdministratorEvent {
     CHANGE_ADMINISTRATOR_NAME, CHANGE_ADMINISTRATOR_SOURCE_CLASS_NAME, CHANGE_ADMINISTRATOR_SCOPE, CHANGE_OFFICE_TEAM, ADD_PROPERTY, REMOVE_PROPERTY, ADD_DUTY, REMOVE_DUTY, ADD_EXTERNAL_MANAGED_OBJECT, REMOVE_EXTERNAL_MANAGED_OBJECT, ADD_OFFICE_MANAGED_OBJECT, REMOVE_OFFICE_MANAGED_OBJECT
    }

    /**
     * Default constructor.
     */
    public AdministratorModel() {
    }

    /**
     * Convenience constructor for new non-linked instance.
     */
    public AdministratorModel(
      String administratorName
    , String administratorSourceClassName
    , String administratorScope
    ) {
        this.administratorName = administratorName;
        this.administratorSourceClassName = administratorSourceClassName;
        this.administratorScope = administratorScope;
    }

    /**
     * Convenience constructor.
     */
    public AdministratorModel(
      String administratorName
    , String administratorSourceClassName
    , String administratorScope
    , AdministratorToOfficeTeamModel officeTeam
    , PropertyModel[] property
    , DutyModel[] duty
    , ExternalManagedObjectToAdministratorModel[] externalManagedObject
    , OfficeManagedObjectToAdministratorModel[] officeManagedObject
    ) {
        this.administratorName = administratorName;
        this.administratorSourceClassName = administratorSourceClassName;
        this.administratorScope = administratorScope;
        this.officeTeam = officeTeam;
        if (property != null) {
            for (PropertyModel model : property) {
                this.property.add(model);
            }
        }
        if (duty != null) {
            for (DutyModel model : duty) {
                this.duty.add(model);
            }
        }
        if (externalManagedObject != null) {
            for (ExternalManagedObjectToAdministratorModel model : externalManagedObject) {
                this.externalManagedObject.add(model);
            }
        }
        if (officeManagedObject != null) {
            for (OfficeManagedObjectToAdministratorModel model : officeManagedObject) {
                this.officeManagedObject.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public AdministratorModel(
      String administratorName
    , String administratorSourceClassName
    , String administratorScope
    , AdministratorToOfficeTeamModel officeTeam
    , PropertyModel[] property
    , DutyModel[] duty
    , ExternalManagedObjectToAdministratorModel[] externalManagedObject
    , OfficeManagedObjectToAdministratorModel[] officeManagedObject
    , int x
    , int y
    ) {
        this.administratorName = administratorName;
        this.administratorSourceClassName = administratorSourceClassName;
        this.administratorScope = administratorScope;
        this.officeTeam = officeTeam;
        if (property != null) {
            for (PropertyModel model : property) {
                this.property.add(model);
            }
        }
        if (duty != null) {
            for (DutyModel model : duty) {
                this.duty.add(model);
            }
        }
        if (externalManagedObject != null) {
            for (ExternalManagedObjectToAdministratorModel model : externalManagedObject) {
                this.externalManagedObject.add(model);
            }
        }
        if (officeManagedObject != null) {
            for (OfficeManagedObjectToAdministratorModel model : officeManagedObject) {
                this.officeManagedObject.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }

    /**
     * Administrator name.
     */
    private String administratorName;

    public String getAdministratorName() {
        return this.administratorName;
    }

    public void setAdministratorName(String administratorName) {
        String oldValue = this.administratorName;
        this.administratorName = administratorName;
        this.changeField(oldValue, this.administratorName, AdministratorEvent.CHANGE_ADMINISTRATOR_NAME);
    }

    /**
     * Administrator source class name.
     */
    private String administratorSourceClassName;

    public String getAdministratorSourceClassName() {
        return this.administratorSourceClassName;
    }

    public void setAdministratorSourceClassName(String administratorSourceClassName) {
        String oldValue = this.administratorSourceClassName;
        this.administratorSourceClassName = administratorSourceClassName;
        this.changeField(oldValue, this.administratorSourceClassName, AdministratorEvent.CHANGE_ADMINISTRATOR_SOURCE_CLASS_NAME);
    }

    /**
     * Administrator scope.
     */
    private String administratorScope;

    public String getAdministratorScope() {
        return this.administratorScope;
    }

    public void setAdministratorScope(String administratorScope) {
        String oldValue = this.administratorScope;
        this.administratorScope = administratorScope;
        this.changeField(oldValue, this.administratorScope, AdministratorEvent.CHANGE_ADMINISTRATOR_SCOPE);
    }

    /**
     * Office team.
     */
    private AdministratorToOfficeTeamModel officeTeam;

    public AdministratorToOfficeTeamModel getOfficeTeam() {
        return this.officeTeam;
    }

    public void setOfficeTeam(AdministratorToOfficeTeamModel officeTeam) {
        AdministratorToOfficeTeamModel oldValue = this.officeTeam;
        this.officeTeam = officeTeam;
        this.changeField(oldValue, this.officeTeam, AdministratorEvent.CHANGE_OFFICE_TEAM);
    }


    /**
     * Property.
     */
    private List<PropertyModel> property = new LinkedList<PropertyModel>();

    public List<PropertyModel> getProperties() {
        return this.property;
    }

    public void addProperty(PropertyModel property) {
        this.addItemToList(property, this.property, AdministratorEvent.ADD_PROPERTY);
    }

    public void removeProperty(PropertyModel property) {
        this.removeItemFromList(property, this.property, AdministratorEvent.REMOVE_PROPERTY);
    }

    /**
     * Duty.
     */
    private List<DutyModel> duty = new LinkedList<DutyModel>();

    public List<DutyModel> getDuties() {
        return this.duty;
    }

    public void addDuty(DutyModel duty) {
        this.addItemToList(duty, this.duty, AdministratorEvent.ADD_DUTY);
    }

    public void removeDuty(DutyModel duty) {
        this.removeItemFromList(duty, this.duty, AdministratorEvent.REMOVE_DUTY);
    }

    /**
     * External managed object.
     */
    private List<ExternalManagedObjectToAdministratorModel> externalManagedObject = new LinkedList<ExternalManagedObjectToAdministratorModel>();

    public List<ExternalManagedObjectToAdministratorModel> getExternalManagedObjects() {
        return this.externalManagedObject;
    }

    public void addExternalManagedObject(ExternalManagedObjectToAdministratorModel externalManagedObject) {
        this.addItemToList(externalManagedObject, this.externalManagedObject, AdministratorEvent.ADD_EXTERNAL_MANAGED_OBJECT);
    }

    public void removeExternalManagedObject(ExternalManagedObjectToAdministratorModel externalManagedObject) {
        this.removeItemFromList(externalManagedObject, this.externalManagedObject, AdministratorEvent.REMOVE_EXTERNAL_MANAGED_OBJECT);
    }

    /**
     * Office managed object.
     */
    private List<OfficeManagedObjectToAdministratorModel> officeManagedObject = new LinkedList<OfficeManagedObjectToAdministratorModel>();

    public List<OfficeManagedObjectToAdministratorModel> getOfficeManagedObjects() {
        return this.officeManagedObject;
    }

    public void addOfficeManagedObject(OfficeManagedObjectToAdministratorModel officeManagedObject) {
        this.addItemToList(officeManagedObject, this.officeManagedObject, AdministratorEvent.ADD_OFFICE_MANAGED_OBJECT);
    }

    public void removeOfficeManagedObject(OfficeManagedObjectToAdministratorModel officeManagedObject) {
        this.removeItemFromList(officeManagedObject, this.officeManagedObject, AdministratorEvent.REMOVE_OFFICE_MANAGED_OBJECT);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<AdministratorModel> removeConnections() {
        RemoveConnectionsAction<AdministratorModel> _action = new RemoveConnectionsAction<AdministratorModel>(this);
        _action.disconnect(this.officeTeam);
        _action.disconnect(this.externalManagedObject);
        _action.disconnect(this.officeManagedObject);
        return _action;
    }
}
