/*
 * 
 */
package net.officefloor.model.office;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ConnectionModel;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class AdministratorToOfficeTeamModel extends AbstractModel implements ConnectionModel {

    public static enum AdministratorToOfficeTeamEvent {
     CHANGE_OFFICE_TEAM_NAME, CHANGE_ADMINISTRATOR, CHANGE_OFFICE_TEAM
    }

    /**
     * Default constructor.
     */
    public AdministratorToOfficeTeamModel() {
    }

    /**
     * Convenience constructor for new non-linked instance.
     */
    public AdministratorToOfficeTeamModel(
      String officeTeamName
    ) {
        this.officeTeamName = officeTeamName;
    }

    /**
     * Convenience constructor.
     */
    public AdministratorToOfficeTeamModel(
      String officeTeamName
    , AdministratorModel administrator
    , OfficeTeamModel officeTeam
    ) {
        this.officeTeamName = officeTeamName;
        this.administrator = administrator;
        this.officeTeam = officeTeam;
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public AdministratorToOfficeTeamModel(
      String officeTeamName
    , AdministratorModel administrator
    , OfficeTeamModel officeTeam
    , int x
    , int y
    ) {
        this.officeTeamName = officeTeamName;
        this.administrator = administrator;
        this.officeTeam = officeTeam;
        this.setX(x);
        this.setY(y);
    }

    /**
     * Office team name.
     */
    private String officeTeamName;

    public String getOfficeTeamName() {
        return this.officeTeamName;
    }

    public void setOfficeTeamName(String officeTeamName) {
        String oldValue = this.officeTeamName;
        this.officeTeamName = officeTeamName;
        this.changeField(oldValue, this.officeTeamName, AdministratorToOfficeTeamEvent.CHANGE_OFFICE_TEAM_NAME);
    }

    /**
     * Administrator.
     */
    private AdministratorModel administrator;

    public AdministratorModel getAdministrator() {
        return this.administrator;
    }

    public void setAdministrator(AdministratorModel administrator) {
        AdministratorModel oldValue = this.administrator;
        this.administrator = administrator;
        this.changeField(oldValue, this.administrator, AdministratorToOfficeTeamEvent.CHANGE_ADMINISTRATOR);
    }

    /**
     * Office team.
     */
    private OfficeTeamModel officeTeam;

    public OfficeTeamModel getOfficeTeam() {
        return this.officeTeam;
    }

    public void setOfficeTeam(OfficeTeamModel officeTeam) {
        OfficeTeamModel oldValue = this.officeTeam;
        this.officeTeam = officeTeam;
        this.changeField(oldValue, this.officeTeam, AdministratorToOfficeTeamEvent.CHANGE_OFFICE_TEAM);
    }



    /*
     * ConnectionModel
     */
    public boolean isRemovable() {
        return true;
    }

    public void connect() {
        this.administrator.setOfficeTeam(this);
        this.officeTeam.addAdministrator(this);
    }

    public void remove() {
        this.administrator.setOfficeTeam(null);
        this.officeTeam.removeAdministrator(this);
    }

}
