/*
 * 
 */
package net.officefloor.model.office;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class DutyModel extends AbstractModel implements ItemModel<DutyModel> {

    public static enum DutyEvent {
     CHANGE_DUTY_NAME, ADD_PRE_OFFICE_TASK, REMOVE_PRE_OFFICE_TASK, ADD_POST_OFFICE_TASK, REMOVE_POST_OFFICE_TASK
    }

    /**
     * Default constructor.
     */
    public DutyModel() {
    }

    /**
     * Convenience constructor for new non-linked instance.
     */
    public DutyModel(
      String dutyName
    ) {
        this.dutyName = dutyName;
    }

    /**
     * Convenience constructor.
     */
    public DutyModel(
      String dutyName
    , OfficeTaskToPreDutyModel[] preOfficeTask
    , OfficeTaskToPostDutyModel[] postOfficeTask
    ) {
        this.dutyName = dutyName;
        if (preOfficeTask != null) {
            for (OfficeTaskToPreDutyModel model : preOfficeTask) {
                this.preOfficeTask.add(model);
            }
        }
        if (postOfficeTask != null) {
            for (OfficeTaskToPostDutyModel model : postOfficeTask) {
                this.postOfficeTask.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public DutyModel(
      String dutyName
    , OfficeTaskToPreDutyModel[] preOfficeTask
    , OfficeTaskToPostDutyModel[] postOfficeTask
    , int x
    , int y
    ) {
        this.dutyName = dutyName;
        if (preOfficeTask != null) {
            for (OfficeTaskToPreDutyModel model : preOfficeTask) {
                this.preOfficeTask.add(model);
            }
        }
        if (postOfficeTask != null) {
            for (OfficeTaskToPostDutyModel model : postOfficeTask) {
                this.postOfficeTask.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }

    /**
     * Duty name.
     */
    private String dutyName;

    public String getDutyName() {
        return this.dutyName;
    }

    public void setDutyName(String dutyName) {
        String oldValue = this.dutyName;
        this.dutyName = dutyName;
        this.changeField(oldValue, this.dutyName, DutyEvent.CHANGE_DUTY_NAME);
    }


    /**
     * Pre office task.
     */
    private List<OfficeTaskToPreDutyModel> preOfficeTask = new LinkedList<OfficeTaskToPreDutyModel>();

    public List<OfficeTaskToPreDutyModel> getPreOfficeTasks() {
        return this.preOfficeTask;
    }

    public void addPreOfficeTask(OfficeTaskToPreDutyModel preOfficeTask) {
        this.addItemToList(preOfficeTask, this.preOfficeTask, DutyEvent.ADD_PRE_OFFICE_TASK);
    }

    public void removePreOfficeTask(OfficeTaskToPreDutyModel preOfficeTask) {
        this.removeItemFromList(preOfficeTask, this.preOfficeTask, DutyEvent.REMOVE_PRE_OFFICE_TASK);
    }

    /**
     * Post office task.
     */
    private List<OfficeTaskToPostDutyModel> postOfficeTask = new LinkedList<OfficeTaskToPostDutyModel>();

    public List<OfficeTaskToPostDutyModel> getPostOfficeTasks() {
        return this.postOfficeTask;
    }

    public void addPostOfficeTask(OfficeTaskToPostDutyModel postOfficeTask) {
        this.addItemToList(postOfficeTask, this.postOfficeTask, DutyEvent.ADD_POST_OFFICE_TASK);
    }

    public void removePostOfficeTask(OfficeTaskToPostDutyModel postOfficeTask) {
        this.removeItemFromList(postOfficeTask, this.postOfficeTask, DutyEvent.REMOVE_POST_OFFICE_TASK);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<DutyModel> removeConnections() {
        RemoveConnectionsAction<DutyModel> _action = new RemoveConnectionsAction<DutyModel>(this);
        _action.disconnect(this.preOfficeTask);
        _action.disconnect(this.postOfficeTask);
        return _action;
    }
}
