/*
 * 
 */
package net.officefloor.model.office;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class ExternalManagedObjectModel extends AbstractModel implements ItemModel<ExternalManagedObjectModel> {

    public static enum ExternalManagedObjectEvent {
     CHANGE_EXTERNAL_MANAGED_OBJECT_NAME, CHANGE_OBJECT_TYPE, ADD_OFFICE_SECTION_OBJECT, REMOVE_OFFICE_SECTION_OBJECT, ADD_DEPENDENT_OFFICE_MANAGED_OBJECT, REMOVE_DEPENDENT_OFFICE_MANAGED_OBJECT, ADD_DEPENDENT_OFFICE_INPUT_MANAGED_OBJECT, REMOVE_DEPENDENT_OFFICE_INPUT_MANAGED_OBJECT, ADD_ADMINISTRATOR, REMOVE_ADMINISTRATOR, ADD_OFFICE_GOVERNANCE, REMOVE_OFFICE_GOVERNANCE
    }

    /**
     * Default constructor.
     */
    public ExternalManagedObjectModel() {
    }

    /**
     * Convenience constructor for new non-linked instance.
     */
    public ExternalManagedObjectModel(
      String externalManagedObjectName
    , String objectType
    ) {
        this.externalManagedObjectName = externalManagedObjectName;
        this.objectType = objectType;
    }

    /**
     * Convenience constructor.
     */
    public ExternalManagedObjectModel(
      String externalManagedObjectName
    , String objectType
    , OfficeSectionObjectToExternalManagedObjectModel[] officeSectionObject
    , OfficeManagedObjectDependencyToExternalManagedObjectModel[] dependentOfficeManagedObject
    , OfficeInputManagedObjectDependencyToExternalManagedObjectModel[] dependentOfficeInputManagedObject
    , ExternalManagedObjectToAdministratorModel[] administrator
    , ExternalManagedObjectToOfficeGovernanceModel[] officeGovernance
    ) {
        this.externalManagedObjectName = externalManagedObjectName;
        this.objectType = objectType;
        if (officeSectionObject != null) {
            for (OfficeSectionObjectToExternalManagedObjectModel model : officeSectionObject) {
                this.officeSectionObject.add(model);
            }
        }
        if (dependentOfficeManagedObject != null) {
            for (OfficeManagedObjectDependencyToExternalManagedObjectModel model : dependentOfficeManagedObject) {
                this.dependentOfficeManagedObject.add(model);
            }
        }
        if (dependentOfficeInputManagedObject != null) {
            for (OfficeInputManagedObjectDependencyToExternalManagedObjectModel model : dependentOfficeInputManagedObject) {
                this.dependentOfficeInputManagedObject.add(model);
            }
        }
        if (administrator != null) {
            for (ExternalManagedObjectToAdministratorModel model : administrator) {
                this.administrator.add(model);
            }
        }
        if (officeGovernance != null) {
            for (ExternalManagedObjectToOfficeGovernanceModel model : officeGovernance) {
                this.officeGovernance.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public ExternalManagedObjectModel(
      String externalManagedObjectName
    , String objectType
    , OfficeSectionObjectToExternalManagedObjectModel[] officeSectionObject
    , OfficeManagedObjectDependencyToExternalManagedObjectModel[] dependentOfficeManagedObject
    , OfficeInputManagedObjectDependencyToExternalManagedObjectModel[] dependentOfficeInputManagedObject
    , ExternalManagedObjectToAdministratorModel[] administrator
    , ExternalManagedObjectToOfficeGovernanceModel[] officeGovernance
    , int x
    , int y
    ) {
        this.externalManagedObjectName = externalManagedObjectName;
        this.objectType = objectType;
        if (officeSectionObject != null) {
            for (OfficeSectionObjectToExternalManagedObjectModel model : officeSectionObject) {
                this.officeSectionObject.add(model);
            }
        }
        if (dependentOfficeManagedObject != null) {
            for (OfficeManagedObjectDependencyToExternalManagedObjectModel model : dependentOfficeManagedObject) {
                this.dependentOfficeManagedObject.add(model);
            }
        }
        if (dependentOfficeInputManagedObject != null) {
            for (OfficeInputManagedObjectDependencyToExternalManagedObjectModel model : dependentOfficeInputManagedObject) {
                this.dependentOfficeInputManagedObject.add(model);
            }
        }
        if (administrator != null) {
            for (ExternalManagedObjectToAdministratorModel model : administrator) {
                this.administrator.add(model);
            }
        }
        if (officeGovernance != null) {
            for (ExternalManagedObjectToOfficeGovernanceModel model : officeGovernance) {
                this.officeGovernance.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }

    /**
     * External managed object name.
     */
    private String externalManagedObjectName;

    public String getExternalManagedObjectName() {
        return this.externalManagedObjectName;
    }

    public void setExternalManagedObjectName(String externalManagedObjectName) {
        String oldValue = this.externalManagedObjectName;
        this.externalManagedObjectName = externalManagedObjectName;
        this.changeField(oldValue, this.externalManagedObjectName, ExternalManagedObjectEvent.CHANGE_EXTERNAL_MANAGED_OBJECT_NAME);
    }

    /**
     * Object type.
     */
    private String objectType;

    public String getObjectType() {
        return this.objectType;
    }

    public void setObjectType(String objectType) {
        String oldValue = this.objectType;
        this.objectType = objectType;
        this.changeField(oldValue, this.objectType, ExternalManagedObjectEvent.CHANGE_OBJECT_TYPE);
    }


    /**
     * Office section object.
     */
    private List<OfficeSectionObjectToExternalManagedObjectModel> officeSectionObject = new LinkedList<OfficeSectionObjectToExternalManagedObjectModel>();

    public List<OfficeSectionObjectToExternalManagedObjectModel> getOfficeSectionObjects() {
        return this.officeSectionObject;
    }

    public void addOfficeSectionObject(OfficeSectionObjectToExternalManagedObjectModel officeSectionObject) {
        this.addItemToList(officeSectionObject, this.officeSectionObject, ExternalManagedObjectEvent.ADD_OFFICE_SECTION_OBJECT);
    }

    public void removeOfficeSectionObject(OfficeSectionObjectToExternalManagedObjectModel officeSectionObject) {
        this.removeItemFromList(officeSectionObject, this.officeSectionObject, ExternalManagedObjectEvent.REMOVE_OFFICE_SECTION_OBJECT);
    }

    /**
     * Dependent office managed object.
     */
    private List<OfficeManagedObjectDependencyToExternalManagedObjectModel> dependentOfficeManagedObject = new LinkedList<OfficeManagedObjectDependencyToExternalManagedObjectModel>();

    public List<OfficeManagedObjectDependencyToExternalManagedObjectModel> getDependentOfficeManagedObjects() {
        return this.dependentOfficeManagedObject;
    }

    public void addDependentOfficeManagedObject(OfficeManagedObjectDependencyToExternalManagedObjectModel dependentOfficeManagedObject) {
        this.addItemToList(dependentOfficeManagedObject, this.dependentOfficeManagedObject, ExternalManagedObjectEvent.ADD_DEPENDENT_OFFICE_MANAGED_OBJECT);
    }

    public void removeDependentOfficeManagedObject(OfficeManagedObjectDependencyToExternalManagedObjectModel dependentOfficeManagedObject) {
        this.removeItemFromList(dependentOfficeManagedObject, this.dependentOfficeManagedObject, ExternalManagedObjectEvent.REMOVE_DEPENDENT_OFFICE_MANAGED_OBJECT);
    }

    /**
     * Dependent office input managed object.
     */
    private List<OfficeInputManagedObjectDependencyToExternalManagedObjectModel> dependentOfficeInputManagedObject = new LinkedList<OfficeInputManagedObjectDependencyToExternalManagedObjectModel>();

    public List<OfficeInputManagedObjectDependencyToExternalManagedObjectModel> getDependentOfficeInputManagedObjects() {
        return this.dependentOfficeInputManagedObject;
    }

    public void addDependentOfficeInputManagedObject(OfficeInputManagedObjectDependencyToExternalManagedObjectModel dependentOfficeInputManagedObject) {
        this.addItemToList(dependentOfficeInputManagedObject, this.dependentOfficeInputManagedObject, ExternalManagedObjectEvent.ADD_DEPENDENT_OFFICE_INPUT_MANAGED_OBJECT);
    }

    public void removeDependentOfficeInputManagedObject(OfficeInputManagedObjectDependencyToExternalManagedObjectModel dependentOfficeInputManagedObject) {
        this.removeItemFromList(dependentOfficeInputManagedObject, this.dependentOfficeInputManagedObject, ExternalManagedObjectEvent.REMOVE_DEPENDENT_OFFICE_INPUT_MANAGED_OBJECT);
    }

    /**
     * Administrator.
     */
    private List<ExternalManagedObjectToAdministratorModel> administrator = new LinkedList<ExternalManagedObjectToAdministratorModel>();

    public List<ExternalManagedObjectToAdministratorModel> getAdministrators() {
        return this.administrator;
    }

    public void addAdministrator(ExternalManagedObjectToAdministratorModel administrator) {
        this.addItemToList(administrator, this.administrator, ExternalManagedObjectEvent.ADD_ADMINISTRATOR);
    }

    public void removeAdministrator(ExternalManagedObjectToAdministratorModel administrator) {
        this.removeItemFromList(administrator, this.administrator, ExternalManagedObjectEvent.REMOVE_ADMINISTRATOR);
    }

    /**
     * Office governance.
     */
    private List<ExternalManagedObjectToOfficeGovernanceModel> officeGovernance = new LinkedList<ExternalManagedObjectToOfficeGovernanceModel>();

    public List<ExternalManagedObjectToOfficeGovernanceModel> getOfficeGovernances() {
        return this.officeGovernance;
    }

    public void addOfficeGovernance(ExternalManagedObjectToOfficeGovernanceModel officeGovernance) {
        this.addItemToList(officeGovernance, this.officeGovernance, ExternalManagedObjectEvent.ADD_OFFICE_GOVERNANCE);
    }

    public void removeOfficeGovernance(ExternalManagedObjectToOfficeGovernanceModel officeGovernance) {
        this.removeItemFromList(officeGovernance, this.officeGovernance, ExternalManagedObjectEvent.REMOVE_OFFICE_GOVERNANCE);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<ExternalManagedObjectModel> removeConnections() {
        RemoveConnectionsAction<ExternalManagedObjectModel> _action = new RemoveConnectionsAction<ExternalManagedObjectModel>(this);
        _action.disconnect(this.officeSectionObject);
        _action.disconnect(this.dependentOfficeManagedObject);
        _action.disconnect(this.dependentOfficeInputManagedObject);
        _action.disconnect(this.administrator);
        _action.disconnect(this.officeGovernance);
        return _action;
    }
}
