/*
 * 
 */
package net.officefloor.model.office;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class OfficeGovernanceModel extends AbstractModel implements ItemModel<OfficeGovernanceModel> {

    public static enum OfficeGovernanceEvent {
     CHANGE_OFFICE_GOVERNANCE_NAME, CHANGE_GOVERNANCE_SOURCE_CLASS_NAME, CHANGE_OFFICE_TEAM, ADD_PROPERTY, REMOVE_PROPERTY, ADD_OFFICE_GOVERNANCE_AREA, REMOVE_OFFICE_GOVERNANCE_AREA, ADD_EXTERNAL_MANAGED_OBJECT, REMOVE_EXTERNAL_MANAGED_OBJECT, ADD_OFFICE_MANAGED_OBJECT, REMOVE_OFFICE_MANAGED_OBJECT, ADD_OFFICE_SECTION_MANAGED_OBJECT, REMOVE_OFFICE_SECTION_MANAGED_OBJECT, ADD_OFFICE_SUB_SECTION, REMOVE_OFFICE_SUB_SECTION, ADD_OFFICE_TASK, REMOVE_OFFICE_TASK
    }

    /**
     * Default constructor.
     */
    public OfficeGovernanceModel() {
    }

    /**
     * Convenience constructor for new non-linked instance.
     */
    public OfficeGovernanceModel(
      String officeGovernanceName
    , String governanceSourceClassName
    ) {
        this.officeGovernanceName = officeGovernanceName;
        this.governanceSourceClassName = governanceSourceClassName;
    }

    /**
     * Convenience constructor.
     */
    public OfficeGovernanceModel(
      String officeGovernanceName
    , String governanceSourceClassName
    , OfficeGovernanceToOfficeTeamModel officeTeam
    , PropertyModel[] property
    , OfficeGovernanceAreaModel[] officeGovernanceArea
    , ExternalManagedObjectToOfficeGovernanceModel[] externalManagedObject
    , OfficeManagedObjectToOfficeGovernanceModel[] officeManagedObject
    , OfficeSectionManagedObjectToOfficeGovernanceModel[] officeSectionManagedObject
    , OfficeSubSectionToOfficeGovernanceModel[] officeSubSection
    , OfficeTaskToOfficeGovernanceModel[] officeTask
    ) {
        this.officeGovernanceName = officeGovernanceName;
        this.governanceSourceClassName = governanceSourceClassName;
        this.officeTeam = officeTeam;
        if (property != null) {
            for (PropertyModel model : property) {
                this.property.add(model);
            }
        }
        if (officeGovernanceArea != null) {
            for (OfficeGovernanceAreaModel model : officeGovernanceArea) {
                this.officeGovernanceArea.add(model);
            }
        }
        if (externalManagedObject != null) {
            for (ExternalManagedObjectToOfficeGovernanceModel model : externalManagedObject) {
                this.externalManagedObject.add(model);
            }
        }
        if (officeManagedObject != null) {
            for (OfficeManagedObjectToOfficeGovernanceModel model : officeManagedObject) {
                this.officeManagedObject.add(model);
            }
        }
        if (officeSectionManagedObject != null) {
            for (OfficeSectionManagedObjectToOfficeGovernanceModel model : officeSectionManagedObject) {
                this.officeSectionManagedObject.add(model);
            }
        }
        if (officeSubSection != null) {
            for (OfficeSubSectionToOfficeGovernanceModel model : officeSubSection) {
                this.officeSubSection.add(model);
            }
        }
        if (officeTask != null) {
            for (OfficeTaskToOfficeGovernanceModel model : officeTask) {
                this.officeTask.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public OfficeGovernanceModel(
      String officeGovernanceName
    , String governanceSourceClassName
    , OfficeGovernanceToOfficeTeamModel officeTeam
    , PropertyModel[] property
    , OfficeGovernanceAreaModel[] officeGovernanceArea
    , ExternalManagedObjectToOfficeGovernanceModel[] externalManagedObject
    , OfficeManagedObjectToOfficeGovernanceModel[] officeManagedObject
    , OfficeSectionManagedObjectToOfficeGovernanceModel[] officeSectionManagedObject
    , OfficeSubSectionToOfficeGovernanceModel[] officeSubSection
    , OfficeTaskToOfficeGovernanceModel[] officeTask
    , int x
    , int y
    ) {
        this.officeGovernanceName = officeGovernanceName;
        this.governanceSourceClassName = governanceSourceClassName;
        this.officeTeam = officeTeam;
        if (property != null) {
            for (PropertyModel model : property) {
                this.property.add(model);
            }
        }
        if (officeGovernanceArea != null) {
            for (OfficeGovernanceAreaModel model : officeGovernanceArea) {
                this.officeGovernanceArea.add(model);
            }
        }
        if (externalManagedObject != null) {
            for (ExternalManagedObjectToOfficeGovernanceModel model : externalManagedObject) {
                this.externalManagedObject.add(model);
            }
        }
        if (officeManagedObject != null) {
            for (OfficeManagedObjectToOfficeGovernanceModel model : officeManagedObject) {
                this.officeManagedObject.add(model);
            }
        }
        if (officeSectionManagedObject != null) {
            for (OfficeSectionManagedObjectToOfficeGovernanceModel model : officeSectionManagedObject) {
                this.officeSectionManagedObject.add(model);
            }
        }
        if (officeSubSection != null) {
            for (OfficeSubSectionToOfficeGovernanceModel model : officeSubSection) {
                this.officeSubSection.add(model);
            }
        }
        if (officeTask != null) {
            for (OfficeTaskToOfficeGovernanceModel model : officeTask) {
                this.officeTask.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }

    /**
     * Office governance name.
     */
    private String officeGovernanceName;

    public String getOfficeGovernanceName() {
        return this.officeGovernanceName;
    }

    public void setOfficeGovernanceName(String officeGovernanceName) {
        String oldValue = this.officeGovernanceName;
        this.officeGovernanceName = officeGovernanceName;
        this.changeField(oldValue, this.officeGovernanceName, OfficeGovernanceEvent.CHANGE_OFFICE_GOVERNANCE_NAME);
    }

    /**
     * Governance source class name.
     */
    private String governanceSourceClassName;

    public String getGovernanceSourceClassName() {
        return this.governanceSourceClassName;
    }

    public void setGovernanceSourceClassName(String governanceSourceClassName) {
        String oldValue = this.governanceSourceClassName;
        this.governanceSourceClassName = governanceSourceClassName;
        this.changeField(oldValue, this.governanceSourceClassName, OfficeGovernanceEvent.CHANGE_GOVERNANCE_SOURCE_CLASS_NAME);
    }

    /**
     * Office team.
     */
    private OfficeGovernanceToOfficeTeamModel officeTeam;

    public OfficeGovernanceToOfficeTeamModel getOfficeTeam() {
        return this.officeTeam;
    }

    public void setOfficeTeam(OfficeGovernanceToOfficeTeamModel officeTeam) {
        OfficeGovernanceToOfficeTeamModel oldValue = this.officeTeam;
        this.officeTeam = officeTeam;
        this.changeField(oldValue, this.officeTeam, OfficeGovernanceEvent.CHANGE_OFFICE_TEAM);
    }


    /**
     * Property.
     */
    private List<PropertyModel> property = new LinkedList<PropertyModel>();

    public List<PropertyModel> getProperties() {
        return this.property;
    }

    public void addProperty(PropertyModel property) {
        this.addItemToList(property, this.property, OfficeGovernanceEvent.ADD_PROPERTY);
    }

    public void removeProperty(PropertyModel property) {
        this.removeItemFromList(property, this.property, OfficeGovernanceEvent.REMOVE_PROPERTY);
    }

    /**
     * Office governance area.
     */
    private List<OfficeGovernanceAreaModel> officeGovernanceArea = new LinkedList<OfficeGovernanceAreaModel>();

    public List<OfficeGovernanceAreaModel> getOfficeGovernanceAreas() {
        return this.officeGovernanceArea;
    }

    public void addOfficeGovernanceArea(OfficeGovernanceAreaModel officeGovernanceArea) {
        this.addItemToList(officeGovernanceArea, this.officeGovernanceArea, OfficeGovernanceEvent.ADD_OFFICE_GOVERNANCE_AREA);
    }

    public void removeOfficeGovernanceArea(OfficeGovernanceAreaModel officeGovernanceArea) {
        this.removeItemFromList(officeGovernanceArea, this.officeGovernanceArea, OfficeGovernanceEvent.REMOVE_OFFICE_GOVERNANCE_AREA);
    }

    /**
     * External managed object.
     */
    private List<ExternalManagedObjectToOfficeGovernanceModel> externalManagedObject = new LinkedList<ExternalManagedObjectToOfficeGovernanceModel>();

    public List<ExternalManagedObjectToOfficeGovernanceModel> getExternalManagedObjects() {
        return this.externalManagedObject;
    }

    public void addExternalManagedObject(ExternalManagedObjectToOfficeGovernanceModel externalManagedObject) {
        this.addItemToList(externalManagedObject, this.externalManagedObject, OfficeGovernanceEvent.ADD_EXTERNAL_MANAGED_OBJECT);
    }

    public void removeExternalManagedObject(ExternalManagedObjectToOfficeGovernanceModel externalManagedObject) {
        this.removeItemFromList(externalManagedObject, this.externalManagedObject, OfficeGovernanceEvent.REMOVE_EXTERNAL_MANAGED_OBJECT);
    }

    /**
     * Office managed object.
     */
    private List<OfficeManagedObjectToOfficeGovernanceModel> officeManagedObject = new LinkedList<OfficeManagedObjectToOfficeGovernanceModel>();

    public List<OfficeManagedObjectToOfficeGovernanceModel> getOfficeManagedObjects() {
        return this.officeManagedObject;
    }

    public void addOfficeManagedObject(OfficeManagedObjectToOfficeGovernanceModel officeManagedObject) {
        this.addItemToList(officeManagedObject, this.officeManagedObject, OfficeGovernanceEvent.ADD_OFFICE_MANAGED_OBJECT);
    }

    public void removeOfficeManagedObject(OfficeManagedObjectToOfficeGovernanceModel officeManagedObject) {
        this.removeItemFromList(officeManagedObject, this.officeManagedObject, OfficeGovernanceEvent.REMOVE_OFFICE_MANAGED_OBJECT);
    }

    /**
     * Office section managed object.
     */
    private List<OfficeSectionManagedObjectToOfficeGovernanceModel> officeSectionManagedObject = new LinkedList<OfficeSectionManagedObjectToOfficeGovernanceModel>();

    public List<OfficeSectionManagedObjectToOfficeGovernanceModel> getOfficeSectionManagedObjects() {
        return this.officeSectionManagedObject;
    }

    public void addOfficeSectionManagedObject(OfficeSectionManagedObjectToOfficeGovernanceModel officeSectionManagedObject) {
        this.addItemToList(officeSectionManagedObject, this.officeSectionManagedObject, OfficeGovernanceEvent.ADD_OFFICE_SECTION_MANAGED_OBJECT);
    }

    public void removeOfficeSectionManagedObject(OfficeSectionManagedObjectToOfficeGovernanceModel officeSectionManagedObject) {
        this.removeItemFromList(officeSectionManagedObject, this.officeSectionManagedObject, OfficeGovernanceEvent.REMOVE_OFFICE_SECTION_MANAGED_OBJECT);
    }

    /**
     * Office sub section.
     */
    private List<OfficeSubSectionToOfficeGovernanceModel> officeSubSection = new LinkedList<OfficeSubSectionToOfficeGovernanceModel>();

    public List<OfficeSubSectionToOfficeGovernanceModel> getOfficeSubSections() {
        return this.officeSubSection;
    }

    public void addOfficeSubSection(OfficeSubSectionToOfficeGovernanceModel officeSubSection) {
        this.addItemToList(officeSubSection, this.officeSubSection, OfficeGovernanceEvent.ADD_OFFICE_SUB_SECTION);
    }

    public void removeOfficeSubSection(OfficeSubSectionToOfficeGovernanceModel officeSubSection) {
        this.removeItemFromList(officeSubSection, this.officeSubSection, OfficeGovernanceEvent.REMOVE_OFFICE_SUB_SECTION);
    }

    /**
     * Office task.
     */
    private List<OfficeTaskToOfficeGovernanceModel> officeTask = new LinkedList<OfficeTaskToOfficeGovernanceModel>();

    public List<OfficeTaskToOfficeGovernanceModel> getOfficeTasks() {
        return this.officeTask;
    }

    public void addOfficeTask(OfficeTaskToOfficeGovernanceModel officeTask) {
        this.addItemToList(officeTask, this.officeTask, OfficeGovernanceEvent.ADD_OFFICE_TASK);
    }

    public void removeOfficeTask(OfficeTaskToOfficeGovernanceModel officeTask) {
        this.removeItemFromList(officeTask, this.officeTask, OfficeGovernanceEvent.REMOVE_OFFICE_TASK);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<OfficeGovernanceModel> removeConnections() {
        RemoveConnectionsAction<OfficeGovernanceModel> _action = new RemoveConnectionsAction<OfficeGovernanceModel>(this);
        _action.disconnect(this.officeTeam);
        _action.disconnect(this.externalManagedObject);
        _action.disconnect(this.officeManagedObject);
        _action.disconnect(this.officeSectionManagedObject);
        _action.disconnect(this.officeSubSection);
        _action.disconnect(this.officeTask);
        return _action;
    }
}
