/*
 * 
 */
package net.officefloor.model.office;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class OfficeManagedObjectModel extends AbstractModel implements ItemModel<OfficeManagedObjectModel> {

    public static enum OfficeManagedObjectEvent {
     CHANGE_OFFICE_MANAGED_OBJECT_NAME, CHANGE_MANAGED_OBJECT_SCOPE, CHANGE_OFFICE_MANAGED_OBJECT_SOURCE, ADD_ADMINISTRATOR, REMOVE_ADMINISTRATOR, ADD_OFFICE_GOVERNANCE, REMOVE_OFFICE_GOVERNANCE, ADD_OFFICE_SECTION_OBJECT, REMOVE_OFFICE_SECTION_OBJECT, ADD_OFFICE_MANAGED_OBJECT_DEPENDENCY, REMOVE_OFFICE_MANAGED_OBJECT_DEPENDENCY, ADD_DEPENDENT_OFFICE_MANAGED_OBJECT, REMOVE_DEPENDENT_OFFICE_MANAGED_OBJECT, ADD_DEPENDENT_OFFICE_INPUT_MANAGED_OBJECT, REMOVE_DEPENDENT_OFFICE_INPUT_MANAGED_OBJECT
    }

    /**
     * Default constructor.
     */
    public OfficeManagedObjectModel() {
    }

    /**
     * Convenience constructor for new non-linked instance.
     */
    public OfficeManagedObjectModel(
      String officeManagedObjectName
    , String managedObjectScope
    ) {
        this.officeManagedObjectName = officeManagedObjectName;
        this.managedObjectScope = managedObjectScope;
    }

    /**
     * Convenience constructor.
     */
    public OfficeManagedObjectModel(
      String officeManagedObjectName
    , String managedObjectScope
    , OfficeManagedObjectToOfficeManagedObjectSourceModel officeManagedObjectSource
    , OfficeManagedObjectToAdministratorModel[] administrator
    , OfficeManagedObjectToOfficeGovernanceModel[] officeGovernance
    , OfficeSectionObjectToOfficeManagedObjectModel[] officeSectionObject
    , OfficeManagedObjectDependencyModel[] officeManagedObjectDependency
    , OfficeManagedObjectDependencyToOfficeManagedObjectModel[] dependentOfficeManagedObject
    , OfficeInputManagedObjectDependencyToOfficeManagedObjectModel[] dependentOfficeInputManagedObject
    ) {
        this.officeManagedObjectName = officeManagedObjectName;
        this.managedObjectScope = managedObjectScope;
        this.officeManagedObjectSource = officeManagedObjectSource;
        if (administrator != null) {
            for (OfficeManagedObjectToAdministratorModel model : administrator) {
                this.administrator.add(model);
            }
        }
        if (officeGovernance != null) {
            for (OfficeManagedObjectToOfficeGovernanceModel model : officeGovernance) {
                this.officeGovernance.add(model);
            }
        }
        if (officeSectionObject != null) {
            for (OfficeSectionObjectToOfficeManagedObjectModel model : officeSectionObject) {
                this.officeSectionObject.add(model);
            }
        }
        if (officeManagedObjectDependency != null) {
            for (OfficeManagedObjectDependencyModel model : officeManagedObjectDependency) {
                this.officeManagedObjectDependency.add(model);
            }
        }
        if (dependentOfficeManagedObject != null) {
            for (OfficeManagedObjectDependencyToOfficeManagedObjectModel model : dependentOfficeManagedObject) {
                this.dependentOfficeManagedObject.add(model);
            }
        }
        if (dependentOfficeInputManagedObject != null) {
            for (OfficeInputManagedObjectDependencyToOfficeManagedObjectModel model : dependentOfficeInputManagedObject) {
                this.dependentOfficeInputManagedObject.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public OfficeManagedObjectModel(
      String officeManagedObjectName
    , String managedObjectScope
    , OfficeManagedObjectToOfficeManagedObjectSourceModel officeManagedObjectSource
    , OfficeManagedObjectToAdministratorModel[] administrator
    , OfficeManagedObjectToOfficeGovernanceModel[] officeGovernance
    , OfficeSectionObjectToOfficeManagedObjectModel[] officeSectionObject
    , OfficeManagedObjectDependencyModel[] officeManagedObjectDependency
    , OfficeManagedObjectDependencyToOfficeManagedObjectModel[] dependentOfficeManagedObject
    , OfficeInputManagedObjectDependencyToOfficeManagedObjectModel[] dependentOfficeInputManagedObject
    , int x
    , int y
    ) {
        this.officeManagedObjectName = officeManagedObjectName;
        this.managedObjectScope = managedObjectScope;
        this.officeManagedObjectSource = officeManagedObjectSource;
        if (administrator != null) {
            for (OfficeManagedObjectToAdministratorModel model : administrator) {
                this.administrator.add(model);
            }
        }
        if (officeGovernance != null) {
            for (OfficeManagedObjectToOfficeGovernanceModel model : officeGovernance) {
                this.officeGovernance.add(model);
            }
        }
        if (officeSectionObject != null) {
            for (OfficeSectionObjectToOfficeManagedObjectModel model : officeSectionObject) {
                this.officeSectionObject.add(model);
            }
        }
        if (officeManagedObjectDependency != null) {
            for (OfficeManagedObjectDependencyModel model : officeManagedObjectDependency) {
                this.officeManagedObjectDependency.add(model);
            }
        }
        if (dependentOfficeManagedObject != null) {
            for (OfficeManagedObjectDependencyToOfficeManagedObjectModel model : dependentOfficeManagedObject) {
                this.dependentOfficeManagedObject.add(model);
            }
        }
        if (dependentOfficeInputManagedObject != null) {
            for (OfficeInputManagedObjectDependencyToOfficeManagedObjectModel model : dependentOfficeInputManagedObject) {
                this.dependentOfficeInputManagedObject.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }

    /**
     * Office managed object name.
     */
    private String officeManagedObjectName;

    public String getOfficeManagedObjectName() {
        return this.officeManagedObjectName;
    }

    public void setOfficeManagedObjectName(String officeManagedObjectName) {
        String oldValue = this.officeManagedObjectName;
        this.officeManagedObjectName = officeManagedObjectName;
        this.changeField(oldValue, this.officeManagedObjectName, OfficeManagedObjectEvent.CHANGE_OFFICE_MANAGED_OBJECT_NAME);
    }

    /**
     * Managed object scope.
     */
    private String managedObjectScope;

    public String getManagedObjectScope() {
        return this.managedObjectScope;
    }

    public void setManagedObjectScope(String managedObjectScope) {
        String oldValue = this.managedObjectScope;
        this.managedObjectScope = managedObjectScope;
        this.changeField(oldValue, this.managedObjectScope, OfficeManagedObjectEvent.CHANGE_MANAGED_OBJECT_SCOPE);
    }

    /**
     * Office managed object source.
     */
    private OfficeManagedObjectToOfficeManagedObjectSourceModel officeManagedObjectSource;

    public OfficeManagedObjectToOfficeManagedObjectSourceModel getOfficeManagedObjectSource() {
        return this.officeManagedObjectSource;
    }

    public void setOfficeManagedObjectSource(OfficeManagedObjectToOfficeManagedObjectSourceModel officeManagedObjectSource) {
        OfficeManagedObjectToOfficeManagedObjectSourceModel oldValue = this.officeManagedObjectSource;
        this.officeManagedObjectSource = officeManagedObjectSource;
        this.changeField(oldValue, this.officeManagedObjectSource, OfficeManagedObjectEvent.CHANGE_OFFICE_MANAGED_OBJECT_SOURCE);
    }


    /**
     * Administrator.
     */
    private List<OfficeManagedObjectToAdministratorModel> administrator = new LinkedList<OfficeManagedObjectToAdministratorModel>();

    public List<OfficeManagedObjectToAdministratorModel> getAdministrators() {
        return this.administrator;
    }

    public void addAdministrator(OfficeManagedObjectToAdministratorModel administrator) {
        this.addItemToList(administrator, this.administrator, OfficeManagedObjectEvent.ADD_ADMINISTRATOR);
    }

    public void removeAdministrator(OfficeManagedObjectToAdministratorModel administrator) {
        this.removeItemFromList(administrator, this.administrator, OfficeManagedObjectEvent.REMOVE_ADMINISTRATOR);
    }

    /**
     * Office governance.
     */
    private List<OfficeManagedObjectToOfficeGovernanceModel> officeGovernance = new LinkedList<OfficeManagedObjectToOfficeGovernanceModel>();

    public List<OfficeManagedObjectToOfficeGovernanceModel> getOfficeGovernances() {
        return this.officeGovernance;
    }

    public void addOfficeGovernance(OfficeManagedObjectToOfficeGovernanceModel officeGovernance) {
        this.addItemToList(officeGovernance, this.officeGovernance, OfficeManagedObjectEvent.ADD_OFFICE_GOVERNANCE);
    }

    public void removeOfficeGovernance(OfficeManagedObjectToOfficeGovernanceModel officeGovernance) {
        this.removeItemFromList(officeGovernance, this.officeGovernance, OfficeManagedObjectEvent.REMOVE_OFFICE_GOVERNANCE);
    }

    /**
     * Office section object.
     */
    private List<OfficeSectionObjectToOfficeManagedObjectModel> officeSectionObject = new LinkedList<OfficeSectionObjectToOfficeManagedObjectModel>();

    public List<OfficeSectionObjectToOfficeManagedObjectModel> getOfficeSectionObjects() {
        return this.officeSectionObject;
    }

    public void addOfficeSectionObject(OfficeSectionObjectToOfficeManagedObjectModel officeSectionObject) {
        this.addItemToList(officeSectionObject, this.officeSectionObject, OfficeManagedObjectEvent.ADD_OFFICE_SECTION_OBJECT);
    }

    public void removeOfficeSectionObject(OfficeSectionObjectToOfficeManagedObjectModel officeSectionObject) {
        this.removeItemFromList(officeSectionObject, this.officeSectionObject, OfficeManagedObjectEvent.REMOVE_OFFICE_SECTION_OBJECT);
    }

    /**
     * Office managed object dependency.
     */
    private List<OfficeManagedObjectDependencyModel> officeManagedObjectDependency = new LinkedList<OfficeManagedObjectDependencyModel>();

    public List<OfficeManagedObjectDependencyModel> getOfficeManagedObjectDependencies() {
        return this.officeManagedObjectDependency;
    }

    public void addOfficeManagedObjectDependency(OfficeManagedObjectDependencyModel officeManagedObjectDependency) {
        this.addItemToList(officeManagedObjectDependency, this.officeManagedObjectDependency, OfficeManagedObjectEvent.ADD_OFFICE_MANAGED_OBJECT_DEPENDENCY);
    }

    public void removeOfficeManagedObjectDependency(OfficeManagedObjectDependencyModel officeManagedObjectDependency) {
        this.removeItemFromList(officeManagedObjectDependency, this.officeManagedObjectDependency, OfficeManagedObjectEvent.REMOVE_OFFICE_MANAGED_OBJECT_DEPENDENCY);
    }

    /**
     * Dependent office managed object.
     */
    private List<OfficeManagedObjectDependencyToOfficeManagedObjectModel> dependentOfficeManagedObject = new LinkedList<OfficeManagedObjectDependencyToOfficeManagedObjectModel>();

    public List<OfficeManagedObjectDependencyToOfficeManagedObjectModel> getDependentOfficeManagedObjects() {
        return this.dependentOfficeManagedObject;
    }

    public void addDependentOfficeManagedObject(OfficeManagedObjectDependencyToOfficeManagedObjectModel dependentOfficeManagedObject) {
        this.addItemToList(dependentOfficeManagedObject, this.dependentOfficeManagedObject, OfficeManagedObjectEvent.ADD_DEPENDENT_OFFICE_MANAGED_OBJECT);
    }

    public void removeDependentOfficeManagedObject(OfficeManagedObjectDependencyToOfficeManagedObjectModel dependentOfficeManagedObject) {
        this.removeItemFromList(dependentOfficeManagedObject, this.dependentOfficeManagedObject, OfficeManagedObjectEvent.REMOVE_DEPENDENT_OFFICE_MANAGED_OBJECT);
    }

    /**
     * Dependent office input managed object.
     */
    private List<OfficeInputManagedObjectDependencyToOfficeManagedObjectModel> dependentOfficeInputManagedObject = new LinkedList<OfficeInputManagedObjectDependencyToOfficeManagedObjectModel>();

    public List<OfficeInputManagedObjectDependencyToOfficeManagedObjectModel> getDependentOfficeInputManagedObjects() {
        return this.dependentOfficeInputManagedObject;
    }

    public void addDependentOfficeInputManagedObject(OfficeInputManagedObjectDependencyToOfficeManagedObjectModel dependentOfficeInputManagedObject) {
        this.addItemToList(dependentOfficeInputManagedObject, this.dependentOfficeInputManagedObject, OfficeManagedObjectEvent.ADD_DEPENDENT_OFFICE_INPUT_MANAGED_OBJECT);
    }

    public void removeDependentOfficeInputManagedObject(OfficeInputManagedObjectDependencyToOfficeManagedObjectModel dependentOfficeInputManagedObject) {
        this.removeItemFromList(dependentOfficeInputManagedObject, this.dependentOfficeInputManagedObject, OfficeManagedObjectEvent.REMOVE_DEPENDENT_OFFICE_INPUT_MANAGED_OBJECT);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<OfficeManagedObjectModel> removeConnections() {
        RemoveConnectionsAction<OfficeManagedObjectModel> _action = new RemoveConnectionsAction<OfficeManagedObjectModel>(this);
        _action.disconnect(this.officeManagedObjectSource);
        _action.disconnect(this.administrator);
        _action.disconnect(this.officeGovernance);
        _action.disconnect(this.officeSectionObject);
        _action.disconnect(this.dependentOfficeManagedObject);
        _action.disconnect(this.dependentOfficeInputManagedObject);
        return _action;
    }
}
