/*
 * 
 */
package net.officefloor.model.office;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class OfficeManagedObjectSourceModel extends AbstractModel implements ItemModel<OfficeManagedObjectSourceModel> {

    public static enum OfficeManagedObjectSourceEvent {
     CHANGE_OFFICE_MANAGED_OBJECT_SOURCE_NAME, CHANGE_MANAGED_OBJECT_SOURCE_CLASS_NAME, CHANGE_OBJECT_TYPE, CHANGE_TIMEOUT, ADD_PROPERTY, REMOVE_PROPERTY, ADD_OFFICE_MANAGED_OBJECT, REMOVE_OFFICE_MANAGED_OBJECT, ADD_OFFICE_INPUT_MANAGED_OBJECT_DEPENDENCY, REMOVE_OFFICE_INPUT_MANAGED_OBJECT_DEPENDENCY, ADD_OFFICE_MANAGED_OBJECT_SOURCE_FLOW, REMOVE_OFFICE_MANAGED_OBJECT_SOURCE_FLOW, ADD_OFFICE_MANAGED_OBJECT_SOURCE_TEAM, REMOVE_OFFICE_MANAGED_OBJECT_SOURCE_TEAM
    }

    /**
     * Default constructor.
     */
    public OfficeManagedObjectSourceModel() {
    }

    /**
     * Convenience constructor for new non-linked instance.
     */
    public OfficeManagedObjectSourceModel(
      String officeManagedObjectSourceName
    , String managedObjectSourceClassName
    , String objectType
    , String timeout
    ) {
        this.officeManagedObjectSourceName = officeManagedObjectSourceName;
        this.managedObjectSourceClassName = managedObjectSourceClassName;
        this.objectType = objectType;
        this.timeout = timeout;
    }

    /**
     * Convenience constructor.
     */
    public OfficeManagedObjectSourceModel(
      String officeManagedObjectSourceName
    , String managedObjectSourceClassName
    , String objectType
    , String timeout
    , PropertyModel[] property
    , OfficeManagedObjectToOfficeManagedObjectSourceModel[] officeManagedObject
    , OfficeInputManagedObjectDependencyModel[] officeInputManagedObjectDependency
    , OfficeManagedObjectSourceFlowModel[] officeManagedObjectSourceFlow
    , OfficeManagedObjectSourceTeamModel[] officeManagedObjectSourceTeam
    ) {
        this.officeManagedObjectSourceName = officeManagedObjectSourceName;
        this.managedObjectSourceClassName = managedObjectSourceClassName;
        this.objectType = objectType;
        this.timeout = timeout;
        if (property != null) {
            for (PropertyModel model : property) {
                this.property.add(model);
            }
        }
        if (officeManagedObject != null) {
            for (OfficeManagedObjectToOfficeManagedObjectSourceModel model : officeManagedObject) {
                this.officeManagedObject.add(model);
            }
        }
        if (officeInputManagedObjectDependency != null) {
            for (OfficeInputManagedObjectDependencyModel model : officeInputManagedObjectDependency) {
                this.officeInputManagedObjectDependency.add(model);
            }
        }
        if (officeManagedObjectSourceFlow != null) {
            for (OfficeManagedObjectSourceFlowModel model : officeManagedObjectSourceFlow) {
                this.officeManagedObjectSourceFlow.add(model);
            }
        }
        if (officeManagedObjectSourceTeam != null) {
            for (OfficeManagedObjectSourceTeamModel model : officeManagedObjectSourceTeam) {
                this.officeManagedObjectSourceTeam.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public OfficeManagedObjectSourceModel(
      String officeManagedObjectSourceName
    , String managedObjectSourceClassName
    , String objectType
    , String timeout
    , PropertyModel[] property
    , OfficeManagedObjectToOfficeManagedObjectSourceModel[] officeManagedObject
    , OfficeInputManagedObjectDependencyModel[] officeInputManagedObjectDependency
    , OfficeManagedObjectSourceFlowModel[] officeManagedObjectSourceFlow
    , OfficeManagedObjectSourceTeamModel[] officeManagedObjectSourceTeam
    , int x
    , int y
    ) {
        this.officeManagedObjectSourceName = officeManagedObjectSourceName;
        this.managedObjectSourceClassName = managedObjectSourceClassName;
        this.objectType = objectType;
        this.timeout = timeout;
        if (property != null) {
            for (PropertyModel model : property) {
                this.property.add(model);
            }
        }
        if (officeManagedObject != null) {
            for (OfficeManagedObjectToOfficeManagedObjectSourceModel model : officeManagedObject) {
                this.officeManagedObject.add(model);
            }
        }
        if (officeInputManagedObjectDependency != null) {
            for (OfficeInputManagedObjectDependencyModel model : officeInputManagedObjectDependency) {
                this.officeInputManagedObjectDependency.add(model);
            }
        }
        if (officeManagedObjectSourceFlow != null) {
            for (OfficeManagedObjectSourceFlowModel model : officeManagedObjectSourceFlow) {
                this.officeManagedObjectSourceFlow.add(model);
            }
        }
        if (officeManagedObjectSourceTeam != null) {
            for (OfficeManagedObjectSourceTeamModel model : officeManagedObjectSourceTeam) {
                this.officeManagedObjectSourceTeam.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }

    /**
     * Office managed object source name.
     */
    private String officeManagedObjectSourceName;

    public String getOfficeManagedObjectSourceName() {
        return this.officeManagedObjectSourceName;
    }

    public void setOfficeManagedObjectSourceName(String officeManagedObjectSourceName) {
        String oldValue = this.officeManagedObjectSourceName;
        this.officeManagedObjectSourceName = officeManagedObjectSourceName;
        this.changeField(oldValue, this.officeManagedObjectSourceName, OfficeManagedObjectSourceEvent.CHANGE_OFFICE_MANAGED_OBJECT_SOURCE_NAME);
    }

    /**
     * Managed object source class name.
     */
    private String managedObjectSourceClassName;

    public String getManagedObjectSourceClassName() {
        return this.managedObjectSourceClassName;
    }

    public void setManagedObjectSourceClassName(String managedObjectSourceClassName) {
        String oldValue = this.managedObjectSourceClassName;
        this.managedObjectSourceClassName = managedObjectSourceClassName;
        this.changeField(oldValue, this.managedObjectSourceClassName, OfficeManagedObjectSourceEvent.CHANGE_MANAGED_OBJECT_SOURCE_CLASS_NAME);
    }

    /**
     * Object type.
     */
    private String objectType;

    public String getObjectType() {
        return this.objectType;
    }

    public void setObjectType(String objectType) {
        String oldValue = this.objectType;
        this.objectType = objectType;
        this.changeField(oldValue, this.objectType, OfficeManagedObjectSourceEvent.CHANGE_OBJECT_TYPE);
    }

    /**
     * Timeout.
     */
    private String timeout;

    public String getTimeout() {
        return this.timeout;
    }

    public void setTimeout(String timeout) {
        String oldValue = this.timeout;
        this.timeout = timeout;
        this.changeField(oldValue, this.timeout, OfficeManagedObjectSourceEvent.CHANGE_TIMEOUT);
    }


    /**
     * Property.
     */
    private List<PropertyModel> property = new LinkedList<PropertyModel>();

    public List<PropertyModel> getProperties() {
        return this.property;
    }

    public void addProperty(PropertyModel property) {
        this.addItemToList(property, this.property, OfficeManagedObjectSourceEvent.ADD_PROPERTY);
    }

    public void removeProperty(PropertyModel property) {
        this.removeItemFromList(property, this.property, OfficeManagedObjectSourceEvent.REMOVE_PROPERTY);
    }

    /**
     * Office managed object.
     */
    private List<OfficeManagedObjectToOfficeManagedObjectSourceModel> officeManagedObject = new LinkedList<OfficeManagedObjectToOfficeManagedObjectSourceModel>();

    public List<OfficeManagedObjectToOfficeManagedObjectSourceModel> getOfficeManagedObjects() {
        return this.officeManagedObject;
    }

    public void addOfficeManagedObject(OfficeManagedObjectToOfficeManagedObjectSourceModel officeManagedObject) {
        this.addItemToList(officeManagedObject, this.officeManagedObject, OfficeManagedObjectSourceEvent.ADD_OFFICE_MANAGED_OBJECT);
    }

    public void removeOfficeManagedObject(OfficeManagedObjectToOfficeManagedObjectSourceModel officeManagedObject) {
        this.removeItemFromList(officeManagedObject, this.officeManagedObject, OfficeManagedObjectSourceEvent.REMOVE_OFFICE_MANAGED_OBJECT);
    }

    /**
     * Office input managed object dependency.
     */
    private List<OfficeInputManagedObjectDependencyModel> officeInputManagedObjectDependency = new LinkedList<OfficeInputManagedObjectDependencyModel>();

    public List<OfficeInputManagedObjectDependencyModel> getOfficeInputManagedObjectDependencies() {
        return this.officeInputManagedObjectDependency;
    }

    public void addOfficeInputManagedObjectDependency(OfficeInputManagedObjectDependencyModel officeInputManagedObjectDependency) {
        this.addItemToList(officeInputManagedObjectDependency, this.officeInputManagedObjectDependency, OfficeManagedObjectSourceEvent.ADD_OFFICE_INPUT_MANAGED_OBJECT_DEPENDENCY);
    }

    public void removeOfficeInputManagedObjectDependency(OfficeInputManagedObjectDependencyModel officeInputManagedObjectDependency) {
        this.removeItemFromList(officeInputManagedObjectDependency, this.officeInputManagedObjectDependency, OfficeManagedObjectSourceEvent.REMOVE_OFFICE_INPUT_MANAGED_OBJECT_DEPENDENCY);
    }

    /**
     * Office managed object source flow.
     */
    private List<OfficeManagedObjectSourceFlowModel> officeManagedObjectSourceFlow = new LinkedList<OfficeManagedObjectSourceFlowModel>();

    public List<OfficeManagedObjectSourceFlowModel> getOfficeManagedObjectSourceFlows() {
        return this.officeManagedObjectSourceFlow;
    }

    public void addOfficeManagedObjectSourceFlow(OfficeManagedObjectSourceFlowModel officeManagedObjectSourceFlow) {
        this.addItemToList(officeManagedObjectSourceFlow, this.officeManagedObjectSourceFlow, OfficeManagedObjectSourceEvent.ADD_OFFICE_MANAGED_OBJECT_SOURCE_FLOW);
    }

    public void removeOfficeManagedObjectSourceFlow(OfficeManagedObjectSourceFlowModel officeManagedObjectSourceFlow) {
        this.removeItemFromList(officeManagedObjectSourceFlow, this.officeManagedObjectSourceFlow, OfficeManagedObjectSourceEvent.REMOVE_OFFICE_MANAGED_OBJECT_SOURCE_FLOW);
    }

    /**
     * Office managed object source team.
     */
    private List<OfficeManagedObjectSourceTeamModel> officeManagedObjectSourceTeam = new LinkedList<OfficeManagedObjectSourceTeamModel>();

    public List<OfficeManagedObjectSourceTeamModel> getOfficeManagedObjectSourceTeams() {
        return this.officeManagedObjectSourceTeam;
    }

    public void addOfficeManagedObjectSourceTeam(OfficeManagedObjectSourceTeamModel officeManagedObjectSourceTeam) {
        this.addItemToList(officeManagedObjectSourceTeam, this.officeManagedObjectSourceTeam, OfficeManagedObjectSourceEvent.ADD_OFFICE_MANAGED_OBJECT_SOURCE_TEAM);
    }

    public void removeOfficeManagedObjectSourceTeam(OfficeManagedObjectSourceTeamModel officeManagedObjectSourceTeam) {
        this.removeItemFromList(officeManagedObjectSourceTeam, this.officeManagedObjectSourceTeam, OfficeManagedObjectSourceEvent.REMOVE_OFFICE_MANAGED_OBJECT_SOURCE_TEAM);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<OfficeManagedObjectSourceModel> removeConnections() {
        RemoveConnectionsAction<OfficeManagedObjectSourceModel> _action = new RemoveConnectionsAction<OfficeManagedObjectSourceModel>(this);
        _action.disconnect(this.officeManagedObject);
        return _action;
    }
}
