/*
 * 
 */
package net.officefloor.model.office;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class OfficeModel extends AbstractModel implements ItemModel<OfficeModel> {

    public static enum OfficeEvent {
     ADD_OFFICE_SECTION, REMOVE_OFFICE_SECTION, ADD_OFFICE_TEAM, REMOVE_OFFICE_TEAM, ADD_EXTERNAL_MANAGED_OBJECT, REMOVE_EXTERNAL_MANAGED_OBJECT, ADD_OFFICE_MANAGED_OBJECT_SOURCE, REMOVE_OFFICE_MANAGED_OBJECT_SOURCE, ADD_OFFICE_MANAGED_OBJECT, REMOVE_OFFICE_MANAGED_OBJECT, ADD_OFFICE_ESCALATION, REMOVE_OFFICE_ESCALATION, ADD_OFFICE_ADMINISTRATOR, REMOVE_OFFICE_ADMINISTRATOR, ADD_OFFICE_GOVERNANCE, REMOVE_OFFICE_GOVERNANCE, ADD_OFFICE_START, REMOVE_OFFICE_START
    }

    /**
     * Default constructor.
     */
    public OfficeModel() {
    }

    /**
     * Convenience constructor.
     */
    public OfficeModel(
      OfficeSectionModel[] officeSection
    , OfficeTeamModel[] officeTeam
    , ExternalManagedObjectModel[] externalManagedObject
    , OfficeManagedObjectSourceModel[] officeManagedObjectSource
    , OfficeManagedObjectModel[] officeManagedObject
    , OfficeEscalationModel[] officeEscalation
    , AdministratorModel[] officeAdministrator
    , OfficeGovernanceModel[] officeGovernance
    , OfficeStartModel[] officeStart
    ) {
        if (officeSection != null) {
            for (OfficeSectionModel model : officeSection) {
                this.officeSection.add(model);
            }
        }
        if (officeTeam != null) {
            for (OfficeTeamModel model : officeTeam) {
                this.officeTeam.add(model);
            }
        }
        if (externalManagedObject != null) {
            for (ExternalManagedObjectModel model : externalManagedObject) {
                this.externalManagedObject.add(model);
            }
        }
        if (officeManagedObjectSource != null) {
            for (OfficeManagedObjectSourceModel model : officeManagedObjectSource) {
                this.officeManagedObjectSource.add(model);
            }
        }
        if (officeManagedObject != null) {
            for (OfficeManagedObjectModel model : officeManagedObject) {
                this.officeManagedObject.add(model);
            }
        }
        if (officeEscalation != null) {
            for (OfficeEscalationModel model : officeEscalation) {
                this.officeEscalation.add(model);
            }
        }
        if (officeAdministrator != null) {
            for (AdministratorModel model : officeAdministrator) {
                this.officeAdministrator.add(model);
            }
        }
        if (officeGovernance != null) {
            for (OfficeGovernanceModel model : officeGovernance) {
                this.officeGovernance.add(model);
            }
        }
        if (officeStart != null) {
            for (OfficeStartModel model : officeStart) {
                this.officeStart.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public OfficeModel(
      OfficeSectionModel[] officeSection
    , OfficeTeamModel[] officeTeam
    , ExternalManagedObjectModel[] externalManagedObject
    , OfficeManagedObjectSourceModel[] officeManagedObjectSource
    , OfficeManagedObjectModel[] officeManagedObject
    , OfficeEscalationModel[] officeEscalation
    , AdministratorModel[] officeAdministrator
    , OfficeGovernanceModel[] officeGovernance
    , OfficeStartModel[] officeStart
    , int x
    , int y
    ) {
        if (officeSection != null) {
            for (OfficeSectionModel model : officeSection) {
                this.officeSection.add(model);
            }
        }
        if (officeTeam != null) {
            for (OfficeTeamModel model : officeTeam) {
                this.officeTeam.add(model);
            }
        }
        if (externalManagedObject != null) {
            for (ExternalManagedObjectModel model : externalManagedObject) {
                this.externalManagedObject.add(model);
            }
        }
        if (officeManagedObjectSource != null) {
            for (OfficeManagedObjectSourceModel model : officeManagedObjectSource) {
                this.officeManagedObjectSource.add(model);
            }
        }
        if (officeManagedObject != null) {
            for (OfficeManagedObjectModel model : officeManagedObject) {
                this.officeManagedObject.add(model);
            }
        }
        if (officeEscalation != null) {
            for (OfficeEscalationModel model : officeEscalation) {
                this.officeEscalation.add(model);
            }
        }
        if (officeAdministrator != null) {
            for (AdministratorModel model : officeAdministrator) {
                this.officeAdministrator.add(model);
            }
        }
        if (officeGovernance != null) {
            for (OfficeGovernanceModel model : officeGovernance) {
                this.officeGovernance.add(model);
            }
        }
        if (officeStart != null) {
            for (OfficeStartModel model : officeStart) {
                this.officeStart.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }


    /**
     * Office section.
     */
    private List<OfficeSectionModel> officeSection = new LinkedList<OfficeSectionModel>();

    public List<OfficeSectionModel> getOfficeSections() {
        return this.officeSection;
    }

    public void addOfficeSection(OfficeSectionModel officeSection) {
        this.addItemToList(officeSection, this.officeSection, OfficeEvent.ADD_OFFICE_SECTION);
    }

    public void removeOfficeSection(OfficeSectionModel officeSection) {
        this.removeItemFromList(officeSection, this.officeSection, OfficeEvent.REMOVE_OFFICE_SECTION);
    }

    /**
     * Office team.
     */
    private List<OfficeTeamModel> officeTeam = new LinkedList<OfficeTeamModel>();

    public List<OfficeTeamModel> getOfficeTeams() {
        return this.officeTeam;
    }

    public void addOfficeTeam(OfficeTeamModel officeTeam) {
        this.addItemToList(officeTeam, this.officeTeam, OfficeEvent.ADD_OFFICE_TEAM);
    }

    public void removeOfficeTeam(OfficeTeamModel officeTeam) {
        this.removeItemFromList(officeTeam, this.officeTeam, OfficeEvent.REMOVE_OFFICE_TEAM);
    }

    /**
     * External managed object.
     */
    private List<ExternalManagedObjectModel> externalManagedObject = new LinkedList<ExternalManagedObjectModel>();

    public List<ExternalManagedObjectModel> getExternalManagedObjects() {
        return this.externalManagedObject;
    }

    public void addExternalManagedObject(ExternalManagedObjectModel externalManagedObject) {
        this.addItemToList(externalManagedObject, this.externalManagedObject, OfficeEvent.ADD_EXTERNAL_MANAGED_OBJECT);
    }

    public void removeExternalManagedObject(ExternalManagedObjectModel externalManagedObject) {
        this.removeItemFromList(externalManagedObject, this.externalManagedObject, OfficeEvent.REMOVE_EXTERNAL_MANAGED_OBJECT);
    }

    /**
     * Office managed object source.
     */
    private List<OfficeManagedObjectSourceModel> officeManagedObjectSource = new LinkedList<OfficeManagedObjectSourceModel>();

    public List<OfficeManagedObjectSourceModel> getOfficeManagedObjectSources() {
        return this.officeManagedObjectSource;
    }

    public void addOfficeManagedObjectSource(OfficeManagedObjectSourceModel officeManagedObjectSource) {
        this.addItemToList(officeManagedObjectSource, this.officeManagedObjectSource, OfficeEvent.ADD_OFFICE_MANAGED_OBJECT_SOURCE);
    }

    public void removeOfficeManagedObjectSource(OfficeManagedObjectSourceModel officeManagedObjectSource) {
        this.removeItemFromList(officeManagedObjectSource, this.officeManagedObjectSource, OfficeEvent.REMOVE_OFFICE_MANAGED_OBJECT_SOURCE);
    }

    /**
     * Office managed object.
     */
    private List<OfficeManagedObjectModel> officeManagedObject = new LinkedList<OfficeManagedObjectModel>();

    public List<OfficeManagedObjectModel> getOfficeManagedObjects() {
        return this.officeManagedObject;
    }

    public void addOfficeManagedObject(OfficeManagedObjectModel officeManagedObject) {
        this.addItemToList(officeManagedObject, this.officeManagedObject, OfficeEvent.ADD_OFFICE_MANAGED_OBJECT);
    }

    public void removeOfficeManagedObject(OfficeManagedObjectModel officeManagedObject) {
        this.removeItemFromList(officeManagedObject, this.officeManagedObject, OfficeEvent.REMOVE_OFFICE_MANAGED_OBJECT);
    }

    /**
     * Office escalation.
     */
    private List<OfficeEscalationModel> officeEscalation = new LinkedList<OfficeEscalationModel>();

    public List<OfficeEscalationModel> getOfficeEscalations() {
        return this.officeEscalation;
    }

    public void addOfficeEscalation(OfficeEscalationModel officeEscalation) {
        this.addItemToList(officeEscalation, this.officeEscalation, OfficeEvent.ADD_OFFICE_ESCALATION);
    }

    public void removeOfficeEscalation(OfficeEscalationModel officeEscalation) {
        this.removeItemFromList(officeEscalation, this.officeEscalation, OfficeEvent.REMOVE_OFFICE_ESCALATION);
    }

    /**
     * Office administrator.
     */
    private List<AdministratorModel> officeAdministrator = new LinkedList<AdministratorModel>();

    public List<AdministratorModel> getOfficeAdministrators() {
        return this.officeAdministrator;
    }

    public void addOfficeAdministrator(AdministratorModel officeAdministrator) {
        this.addItemToList(officeAdministrator, this.officeAdministrator, OfficeEvent.ADD_OFFICE_ADMINISTRATOR);
    }

    public void removeOfficeAdministrator(AdministratorModel officeAdministrator) {
        this.removeItemFromList(officeAdministrator, this.officeAdministrator, OfficeEvent.REMOVE_OFFICE_ADMINISTRATOR);
    }

    /**
     * Office governance.
     */
    private List<OfficeGovernanceModel> officeGovernance = new LinkedList<OfficeGovernanceModel>();

    public List<OfficeGovernanceModel> getOfficeGovernances() {
        return this.officeGovernance;
    }

    public void addOfficeGovernance(OfficeGovernanceModel officeGovernance) {
        this.addItemToList(officeGovernance, this.officeGovernance, OfficeEvent.ADD_OFFICE_GOVERNANCE);
    }

    public void removeOfficeGovernance(OfficeGovernanceModel officeGovernance) {
        this.removeItemFromList(officeGovernance, this.officeGovernance, OfficeEvent.REMOVE_OFFICE_GOVERNANCE);
    }

    /**
     * Office start.
     */
    private List<OfficeStartModel> officeStart = new LinkedList<OfficeStartModel>();

    public List<OfficeStartModel> getOfficeStarts() {
        return this.officeStart;
    }

    public void addOfficeStart(OfficeStartModel officeStart) {
        this.addItemToList(officeStart, this.officeStart, OfficeEvent.ADD_OFFICE_START);
    }

    public void removeOfficeStart(OfficeStartModel officeStart) {
        this.removeItemFromList(officeStart, this.officeStart, OfficeEvent.REMOVE_OFFICE_START);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<OfficeModel> removeConnections() {
        RemoveConnectionsAction<OfficeModel> _action = new RemoveConnectionsAction<OfficeModel>(this);
        return _action;
    }
}
