/*
 * 
 */
package net.officefloor.model.office;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class OfficeSectionInputModel extends AbstractModel implements ItemModel<OfficeSectionInputModel> {

    public static enum OfficeSectionInputEvent {
     CHANGE_OFFICE_SECTION_INPUT_NAME, CHANGE_PARAMETER_TYPE, ADD_OFFICE_SECTION_OUTPUT, REMOVE_OFFICE_SECTION_OUTPUT, ADD_OFFICE_MANAGED_OBJECT_SOURCE_FLOW, REMOVE_OFFICE_MANAGED_OBJECT_SOURCE_FLOW, ADD_OFFICE_ESCALATION, REMOVE_OFFICE_ESCALATION, ADD_OFFICE_START, REMOVE_OFFICE_START
    }

    /**
     * Default constructor.
     */
    public OfficeSectionInputModel() {
    }

    /**
     * Convenience constructor for new non-linked instance.
     */
    public OfficeSectionInputModel(
      String officeSectionInputName
    , String parameterType
    ) {
        this.officeSectionInputName = officeSectionInputName;
        this.parameterType = parameterType;
    }

    /**
     * Convenience constructor.
     */
    public OfficeSectionInputModel(
      String officeSectionInputName
    , String parameterType
    , OfficeSectionOutputToOfficeSectionInputModel[] officeSectionOutput
    , OfficeManagedObjectSourceFlowToOfficeSectionInputModel[] officeManagedObjectSourceFlow
    , OfficeEscalationToOfficeSectionInputModel[] officeEscalation
    , OfficeStartToOfficeSectionInputModel[] officeStart
    ) {
        this.officeSectionInputName = officeSectionInputName;
        this.parameterType = parameterType;
        if (officeSectionOutput != null) {
            for (OfficeSectionOutputToOfficeSectionInputModel model : officeSectionOutput) {
                this.officeSectionOutput.add(model);
            }
        }
        if (officeManagedObjectSourceFlow != null) {
            for (OfficeManagedObjectSourceFlowToOfficeSectionInputModel model : officeManagedObjectSourceFlow) {
                this.officeManagedObjectSourceFlow.add(model);
            }
        }
        if (officeEscalation != null) {
            for (OfficeEscalationToOfficeSectionInputModel model : officeEscalation) {
                this.officeEscalation.add(model);
            }
        }
        if (officeStart != null) {
            for (OfficeStartToOfficeSectionInputModel model : officeStart) {
                this.officeStart.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public OfficeSectionInputModel(
      String officeSectionInputName
    , String parameterType
    , OfficeSectionOutputToOfficeSectionInputModel[] officeSectionOutput
    , OfficeManagedObjectSourceFlowToOfficeSectionInputModel[] officeManagedObjectSourceFlow
    , OfficeEscalationToOfficeSectionInputModel[] officeEscalation
    , OfficeStartToOfficeSectionInputModel[] officeStart
    , int x
    , int y
    ) {
        this.officeSectionInputName = officeSectionInputName;
        this.parameterType = parameterType;
        if (officeSectionOutput != null) {
            for (OfficeSectionOutputToOfficeSectionInputModel model : officeSectionOutput) {
                this.officeSectionOutput.add(model);
            }
        }
        if (officeManagedObjectSourceFlow != null) {
            for (OfficeManagedObjectSourceFlowToOfficeSectionInputModel model : officeManagedObjectSourceFlow) {
                this.officeManagedObjectSourceFlow.add(model);
            }
        }
        if (officeEscalation != null) {
            for (OfficeEscalationToOfficeSectionInputModel model : officeEscalation) {
                this.officeEscalation.add(model);
            }
        }
        if (officeStart != null) {
            for (OfficeStartToOfficeSectionInputModel model : officeStart) {
                this.officeStart.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }

    /**
     * Office section input name.
     */
    private String officeSectionInputName;

    public String getOfficeSectionInputName() {
        return this.officeSectionInputName;
    }

    public void setOfficeSectionInputName(String officeSectionInputName) {
        String oldValue = this.officeSectionInputName;
        this.officeSectionInputName = officeSectionInputName;
        this.changeField(oldValue, this.officeSectionInputName, OfficeSectionInputEvent.CHANGE_OFFICE_SECTION_INPUT_NAME);
    }

    /**
     * Parameter type.
     */
    private String parameterType;

    public String getParameterType() {
        return this.parameterType;
    }

    public void setParameterType(String parameterType) {
        String oldValue = this.parameterType;
        this.parameterType = parameterType;
        this.changeField(oldValue, this.parameterType, OfficeSectionInputEvent.CHANGE_PARAMETER_TYPE);
    }


    /**
     * Office section output.
     */
    private List<OfficeSectionOutputToOfficeSectionInputModel> officeSectionOutput = new LinkedList<OfficeSectionOutputToOfficeSectionInputModel>();

    public List<OfficeSectionOutputToOfficeSectionInputModel> getOfficeSectionOutputs() {
        return this.officeSectionOutput;
    }

    public void addOfficeSectionOutput(OfficeSectionOutputToOfficeSectionInputModel officeSectionOutput) {
        this.addItemToList(officeSectionOutput, this.officeSectionOutput, OfficeSectionInputEvent.ADD_OFFICE_SECTION_OUTPUT);
    }

    public void removeOfficeSectionOutput(OfficeSectionOutputToOfficeSectionInputModel officeSectionOutput) {
        this.removeItemFromList(officeSectionOutput, this.officeSectionOutput, OfficeSectionInputEvent.REMOVE_OFFICE_SECTION_OUTPUT);
    }

    /**
     * Office managed object source flow.
     */
    private List<OfficeManagedObjectSourceFlowToOfficeSectionInputModel> officeManagedObjectSourceFlow = new LinkedList<OfficeManagedObjectSourceFlowToOfficeSectionInputModel>();

    public List<OfficeManagedObjectSourceFlowToOfficeSectionInputModel> getOfficeManagedObjectSourceFlows() {
        return this.officeManagedObjectSourceFlow;
    }

    public void addOfficeManagedObjectSourceFlow(OfficeManagedObjectSourceFlowToOfficeSectionInputModel officeManagedObjectSourceFlow) {
        this.addItemToList(officeManagedObjectSourceFlow, this.officeManagedObjectSourceFlow, OfficeSectionInputEvent.ADD_OFFICE_MANAGED_OBJECT_SOURCE_FLOW);
    }

    public void removeOfficeManagedObjectSourceFlow(OfficeManagedObjectSourceFlowToOfficeSectionInputModel officeManagedObjectSourceFlow) {
        this.removeItemFromList(officeManagedObjectSourceFlow, this.officeManagedObjectSourceFlow, OfficeSectionInputEvent.REMOVE_OFFICE_MANAGED_OBJECT_SOURCE_FLOW);
    }

    /**
     * Office escalation.
     */
    private List<OfficeEscalationToOfficeSectionInputModel> officeEscalation = new LinkedList<OfficeEscalationToOfficeSectionInputModel>();

    public List<OfficeEscalationToOfficeSectionInputModel> getOfficeEscalations() {
        return this.officeEscalation;
    }

    public void addOfficeEscalation(OfficeEscalationToOfficeSectionInputModel officeEscalation) {
        this.addItemToList(officeEscalation, this.officeEscalation, OfficeSectionInputEvent.ADD_OFFICE_ESCALATION);
    }

    public void removeOfficeEscalation(OfficeEscalationToOfficeSectionInputModel officeEscalation) {
        this.removeItemFromList(officeEscalation, this.officeEscalation, OfficeSectionInputEvent.REMOVE_OFFICE_ESCALATION);
    }

    /**
     * Office start.
     */
    private List<OfficeStartToOfficeSectionInputModel> officeStart = new LinkedList<OfficeStartToOfficeSectionInputModel>();

    public List<OfficeStartToOfficeSectionInputModel> getOfficeStarts() {
        return this.officeStart;
    }

    public void addOfficeStart(OfficeStartToOfficeSectionInputModel officeStart) {
        this.addItemToList(officeStart, this.officeStart, OfficeSectionInputEvent.ADD_OFFICE_START);
    }

    public void removeOfficeStart(OfficeStartToOfficeSectionInputModel officeStart) {
        this.removeItemFromList(officeStart, this.officeStart, OfficeSectionInputEvent.REMOVE_OFFICE_START);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<OfficeSectionInputModel> removeConnections() {
        RemoveConnectionsAction<OfficeSectionInputModel> _action = new RemoveConnectionsAction<OfficeSectionInputModel>(this);
        _action.disconnect(this.officeSectionOutput);
        _action.disconnect(this.officeManagedObjectSourceFlow);
        _action.disconnect(this.officeEscalation);
        _action.disconnect(this.officeStart);
        return _action;
    }
}
