/*
 * 
 */
package net.officefloor.model.office;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class OfficeSectionManagedObjectModel extends AbstractModel implements ItemModel<OfficeSectionManagedObjectModel> {

    public static enum OfficeSectionManagedObjectEvent {
     CHANGE_OFFICE_SECTION_MANAGED_OBJECT_NAME, ADD_OFFICE_GOVERNANCE, REMOVE_OFFICE_GOVERNANCE, ADD_OFFICE_SECTION_MANAGED_OBJECT_TEAM, REMOVE_OFFICE_SECTION_MANAGED_OBJECT_TEAM
    }

    /**
     * Default constructor.
     */
    public OfficeSectionManagedObjectModel() {
    }

    /**
     * Convenience constructor for new non-linked instance.
     */
    public OfficeSectionManagedObjectModel(
      String officeSectionManagedObjectName
    ) {
        this.officeSectionManagedObjectName = officeSectionManagedObjectName;
    }

    /**
     * Convenience constructor.
     */
    public OfficeSectionManagedObjectModel(
      String officeSectionManagedObjectName
    , OfficeSectionManagedObjectToOfficeGovernanceModel[] officeGovernance
    , OfficeSectionManagedObjectTeamModel[] officeSectionManagedObjectTeam
    ) {
        this.officeSectionManagedObjectName = officeSectionManagedObjectName;
        if (officeGovernance != null) {
            for (OfficeSectionManagedObjectToOfficeGovernanceModel model : officeGovernance) {
                this.officeGovernance.add(model);
            }
        }
        if (officeSectionManagedObjectTeam != null) {
            for (OfficeSectionManagedObjectTeamModel model : officeSectionManagedObjectTeam) {
                this.officeSectionManagedObjectTeam.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public OfficeSectionManagedObjectModel(
      String officeSectionManagedObjectName
    , OfficeSectionManagedObjectToOfficeGovernanceModel[] officeGovernance
    , OfficeSectionManagedObjectTeamModel[] officeSectionManagedObjectTeam
    , int x
    , int y
    ) {
        this.officeSectionManagedObjectName = officeSectionManagedObjectName;
        if (officeGovernance != null) {
            for (OfficeSectionManagedObjectToOfficeGovernanceModel model : officeGovernance) {
                this.officeGovernance.add(model);
            }
        }
        if (officeSectionManagedObjectTeam != null) {
            for (OfficeSectionManagedObjectTeamModel model : officeSectionManagedObjectTeam) {
                this.officeSectionManagedObjectTeam.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }

    /**
     * Office section managed object name.
     */
    private String officeSectionManagedObjectName;

    public String getOfficeSectionManagedObjectName() {
        return this.officeSectionManagedObjectName;
    }

    public void setOfficeSectionManagedObjectName(String officeSectionManagedObjectName) {
        String oldValue = this.officeSectionManagedObjectName;
        this.officeSectionManagedObjectName = officeSectionManagedObjectName;
        this.changeField(oldValue, this.officeSectionManagedObjectName, OfficeSectionManagedObjectEvent.CHANGE_OFFICE_SECTION_MANAGED_OBJECT_NAME);
    }


    /**
     * Office governance.
     */
    private List<OfficeSectionManagedObjectToOfficeGovernanceModel> officeGovernance = new LinkedList<OfficeSectionManagedObjectToOfficeGovernanceModel>();

    public List<OfficeSectionManagedObjectToOfficeGovernanceModel> getOfficeGovernances() {
        return this.officeGovernance;
    }

    public void addOfficeGovernance(OfficeSectionManagedObjectToOfficeGovernanceModel officeGovernance) {
        this.addItemToList(officeGovernance, this.officeGovernance, OfficeSectionManagedObjectEvent.ADD_OFFICE_GOVERNANCE);
    }

    public void removeOfficeGovernance(OfficeSectionManagedObjectToOfficeGovernanceModel officeGovernance) {
        this.removeItemFromList(officeGovernance, this.officeGovernance, OfficeSectionManagedObjectEvent.REMOVE_OFFICE_GOVERNANCE);
    }

    /**
     * Office section managed object team.
     */
    private List<OfficeSectionManagedObjectTeamModel> officeSectionManagedObjectTeam = new LinkedList<OfficeSectionManagedObjectTeamModel>();

    public List<OfficeSectionManagedObjectTeamModel> getOfficeSectionManagedObjectTeams() {
        return this.officeSectionManagedObjectTeam;
    }

    public void addOfficeSectionManagedObjectTeam(OfficeSectionManagedObjectTeamModel officeSectionManagedObjectTeam) {
        this.addItemToList(officeSectionManagedObjectTeam, this.officeSectionManagedObjectTeam, OfficeSectionManagedObjectEvent.ADD_OFFICE_SECTION_MANAGED_OBJECT_TEAM);
    }

    public void removeOfficeSectionManagedObjectTeam(OfficeSectionManagedObjectTeamModel officeSectionManagedObjectTeam) {
        this.removeItemFromList(officeSectionManagedObjectTeam, this.officeSectionManagedObjectTeam, OfficeSectionManagedObjectEvent.REMOVE_OFFICE_SECTION_MANAGED_OBJECT_TEAM);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<OfficeSectionManagedObjectModel> removeConnections() {
        RemoveConnectionsAction<OfficeSectionManagedObjectModel> _action = new RemoveConnectionsAction<OfficeSectionManagedObjectModel>(this);
        _action.disconnect(this.officeGovernance);
        return _action;
    }
}
