/*
 * 
 */
package net.officefloor.model.office;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class OfficeSectionModel extends AbstractModel implements ItemModel<OfficeSectionModel> {

    public static enum OfficeSectionEvent {
     CHANGE_OFFICE_SECTION_NAME, CHANGE_SECTION_SOURCE_CLASS_NAME, CHANGE_SECTION_LOCATION, CHANGE_OFFICE_SUB_SECTION, ADD_PROPERTY, REMOVE_PROPERTY, ADD_OFFICE_SECTION_INPUT, REMOVE_OFFICE_SECTION_INPUT, ADD_OFFICE_SECTION_OUTPUT, REMOVE_OFFICE_SECTION_OUTPUT, ADD_OFFICE_SECTION_OBJECT, REMOVE_OFFICE_SECTION_OBJECT, ADD_OFFICE_SECTION_RESPONSIBILITY, REMOVE_OFFICE_SECTION_RESPONSIBILITY
    }

    /**
     * Default constructor.
     */
    public OfficeSectionModel() {
    }

    /**
     * Convenience constructor for new non-linked instance.
     */
    public OfficeSectionModel(
      String officeSectionName
    , String sectionSourceClassName
    , String sectionLocation
    ) {
        this.officeSectionName = officeSectionName;
        this.sectionSourceClassName = sectionSourceClassName;
        this.sectionLocation = sectionLocation;
    }

    /**
     * Convenience constructor.
     */
    public OfficeSectionModel(
      String officeSectionName
    , String sectionSourceClassName
    , String sectionLocation
    , OfficeSubSectionModel officeSubSection
    , PropertyModel[] property
    , OfficeSectionInputModel[] officeSectionInput
    , OfficeSectionOutputModel[] officeSectionOutput
    , OfficeSectionObjectModel[] officeSectionObject
    , OfficeSectionResponsibilityModel[] officeSectionResponsibility
    ) {
        this.officeSectionName = officeSectionName;
        this.sectionSourceClassName = sectionSourceClassName;
        this.sectionLocation = sectionLocation;
        this.officeSubSection = officeSubSection;
        if (property != null) {
            for (PropertyModel model : property) {
                this.property.add(model);
            }
        }
        if (officeSectionInput != null) {
            for (OfficeSectionInputModel model : officeSectionInput) {
                this.officeSectionInput.add(model);
            }
        }
        if (officeSectionOutput != null) {
            for (OfficeSectionOutputModel model : officeSectionOutput) {
                this.officeSectionOutput.add(model);
            }
        }
        if (officeSectionObject != null) {
            for (OfficeSectionObjectModel model : officeSectionObject) {
                this.officeSectionObject.add(model);
            }
        }
        if (officeSectionResponsibility != null) {
            for (OfficeSectionResponsibilityModel model : officeSectionResponsibility) {
                this.officeSectionResponsibility.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public OfficeSectionModel(
      String officeSectionName
    , String sectionSourceClassName
    , String sectionLocation
    , OfficeSubSectionModel officeSubSection
    , PropertyModel[] property
    , OfficeSectionInputModel[] officeSectionInput
    , OfficeSectionOutputModel[] officeSectionOutput
    , OfficeSectionObjectModel[] officeSectionObject
    , OfficeSectionResponsibilityModel[] officeSectionResponsibility
    , int x
    , int y
    ) {
        this.officeSectionName = officeSectionName;
        this.sectionSourceClassName = sectionSourceClassName;
        this.sectionLocation = sectionLocation;
        this.officeSubSection = officeSubSection;
        if (property != null) {
            for (PropertyModel model : property) {
                this.property.add(model);
            }
        }
        if (officeSectionInput != null) {
            for (OfficeSectionInputModel model : officeSectionInput) {
                this.officeSectionInput.add(model);
            }
        }
        if (officeSectionOutput != null) {
            for (OfficeSectionOutputModel model : officeSectionOutput) {
                this.officeSectionOutput.add(model);
            }
        }
        if (officeSectionObject != null) {
            for (OfficeSectionObjectModel model : officeSectionObject) {
                this.officeSectionObject.add(model);
            }
        }
        if (officeSectionResponsibility != null) {
            for (OfficeSectionResponsibilityModel model : officeSectionResponsibility) {
                this.officeSectionResponsibility.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }

    /**
     * Office section name.
     */
    private String officeSectionName;

    public String getOfficeSectionName() {
        return this.officeSectionName;
    }

    public void setOfficeSectionName(String officeSectionName) {
        String oldValue = this.officeSectionName;
        this.officeSectionName = officeSectionName;
        this.changeField(oldValue, this.officeSectionName, OfficeSectionEvent.CHANGE_OFFICE_SECTION_NAME);
    }

    /**
     * Section source class name.
     */
    private String sectionSourceClassName;

    public String getSectionSourceClassName() {
        return this.sectionSourceClassName;
    }

    public void setSectionSourceClassName(String sectionSourceClassName) {
        String oldValue = this.sectionSourceClassName;
        this.sectionSourceClassName = sectionSourceClassName;
        this.changeField(oldValue, this.sectionSourceClassName, OfficeSectionEvent.CHANGE_SECTION_SOURCE_CLASS_NAME);
    }

    /**
     * Section location.
     */
    private String sectionLocation;

    public String getSectionLocation() {
        return this.sectionLocation;
    }

    public void setSectionLocation(String sectionLocation) {
        String oldValue = this.sectionLocation;
        this.sectionLocation = sectionLocation;
        this.changeField(oldValue, this.sectionLocation, OfficeSectionEvent.CHANGE_SECTION_LOCATION);
    }

    /**
     * Office sub section.
     */
    private OfficeSubSectionModel officeSubSection;

    public OfficeSubSectionModel getOfficeSubSection() {
        return this.officeSubSection;
    }

    public void setOfficeSubSection(OfficeSubSectionModel officeSubSection) {
        OfficeSubSectionModel oldValue = this.officeSubSection;
        this.officeSubSection = officeSubSection;
        this.changeField(oldValue, this.officeSubSection, OfficeSectionEvent.CHANGE_OFFICE_SUB_SECTION);
    }


    /**
     * Property.
     */
    private List<PropertyModel> property = new LinkedList<PropertyModel>();

    public List<PropertyModel> getProperties() {
        return this.property;
    }

    public void addProperty(PropertyModel property) {
        this.addItemToList(property, this.property, OfficeSectionEvent.ADD_PROPERTY);
    }

    public void removeProperty(PropertyModel property) {
        this.removeItemFromList(property, this.property, OfficeSectionEvent.REMOVE_PROPERTY);
    }

    /**
     * Office section input.
     */
    private List<OfficeSectionInputModel> officeSectionInput = new LinkedList<OfficeSectionInputModel>();

    public List<OfficeSectionInputModel> getOfficeSectionInputs() {
        return this.officeSectionInput;
    }

    public void addOfficeSectionInput(OfficeSectionInputModel officeSectionInput) {
        this.addItemToList(officeSectionInput, this.officeSectionInput, OfficeSectionEvent.ADD_OFFICE_SECTION_INPUT);
    }

    public void removeOfficeSectionInput(OfficeSectionInputModel officeSectionInput) {
        this.removeItemFromList(officeSectionInput, this.officeSectionInput, OfficeSectionEvent.REMOVE_OFFICE_SECTION_INPUT);
    }

    /**
     * Office section output.
     */
    private List<OfficeSectionOutputModel> officeSectionOutput = new LinkedList<OfficeSectionOutputModel>();

    public List<OfficeSectionOutputModel> getOfficeSectionOutputs() {
        return this.officeSectionOutput;
    }

    public void addOfficeSectionOutput(OfficeSectionOutputModel officeSectionOutput) {
        this.addItemToList(officeSectionOutput, this.officeSectionOutput, OfficeSectionEvent.ADD_OFFICE_SECTION_OUTPUT);
    }

    public void removeOfficeSectionOutput(OfficeSectionOutputModel officeSectionOutput) {
        this.removeItemFromList(officeSectionOutput, this.officeSectionOutput, OfficeSectionEvent.REMOVE_OFFICE_SECTION_OUTPUT);
    }

    /**
     * Office section object.
     */
    private List<OfficeSectionObjectModel> officeSectionObject = new LinkedList<OfficeSectionObjectModel>();

    public List<OfficeSectionObjectModel> getOfficeSectionObjects() {
        return this.officeSectionObject;
    }

    public void addOfficeSectionObject(OfficeSectionObjectModel officeSectionObject) {
        this.addItemToList(officeSectionObject, this.officeSectionObject, OfficeSectionEvent.ADD_OFFICE_SECTION_OBJECT);
    }

    public void removeOfficeSectionObject(OfficeSectionObjectModel officeSectionObject) {
        this.removeItemFromList(officeSectionObject, this.officeSectionObject, OfficeSectionEvent.REMOVE_OFFICE_SECTION_OBJECT);
    }

    /**
     * Office section responsibility.
     */
    private List<OfficeSectionResponsibilityModel> officeSectionResponsibility = new LinkedList<OfficeSectionResponsibilityModel>();

    public List<OfficeSectionResponsibilityModel> getOfficeSectionResponsibilities() {
        return this.officeSectionResponsibility;
    }

    public void addOfficeSectionResponsibility(OfficeSectionResponsibilityModel officeSectionResponsibility) {
        this.addItemToList(officeSectionResponsibility, this.officeSectionResponsibility, OfficeSectionEvent.ADD_OFFICE_SECTION_RESPONSIBILITY);
    }

    public void removeOfficeSectionResponsibility(OfficeSectionResponsibilityModel officeSectionResponsibility) {
        this.removeItemFromList(officeSectionResponsibility, this.officeSectionResponsibility, OfficeSectionEvent.REMOVE_OFFICE_SECTION_RESPONSIBILITY);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<OfficeSectionModel> removeConnections() {
        RemoveConnectionsAction<OfficeSectionModel> _action = new RemoveConnectionsAction<OfficeSectionModel>(this);
        return _action;
    }
}
