/*
 * 
 */
package net.officefloor.model.office;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class OfficeSubSectionModel extends AbstractModel implements ItemModel<OfficeSubSectionModel> {

    public static enum OfficeSubSectionEvent {
     CHANGE_OFFICE_SUB_SECTION_NAME, ADD_OFFICE_TASK, REMOVE_OFFICE_TASK, ADD_OFFICE_SECTION_MANAGED_OBJECT, REMOVE_OFFICE_SECTION_MANAGED_OBJECT, ADD_OFFICE_SUB_SECTION, REMOVE_OFFICE_SUB_SECTION, ADD_OFFICE_GOVERNANCE, REMOVE_OFFICE_GOVERNANCE
    }

    /**
     * Default constructor.
     */
    public OfficeSubSectionModel() {
    }

    /**
     * Convenience constructor for new non-linked instance.
     */
    public OfficeSubSectionModel(
      String officeSubSectionName
    ) {
        this.officeSubSectionName = officeSubSectionName;
    }

    /**
     * Convenience constructor.
     */
    public OfficeSubSectionModel(
      String officeSubSectionName
    , OfficeTaskModel[] officeTask
    , OfficeSectionManagedObjectModel[] officeSectionManagedObject
    , OfficeSubSectionModel[] officeSubSection
    , OfficeSubSectionToOfficeGovernanceModel[] officeGovernance
    ) {
        this.officeSubSectionName = officeSubSectionName;
        if (officeTask != null) {
            for (OfficeTaskModel model : officeTask) {
                this.officeTask.add(model);
            }
        }
        if (officeSectionManagedObject != null) {
            for (OfficeSectionManagedObjectModel model : officeSectionManagedObject) {
                this.officeSectionManagedObject.add(model);
            }
        }
        if (officeSubSection != null) {
            for (OfficeSubSectionModel model : officeSubSection) {
                this.officeSubSection.add(model);
            }
        }
        if (officeGovernance != null) {
            for (OfficeSubSectionToOfficeGovernanceModel model : officeGovernance) {
                this.officeGovernance.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public OfficeSubSectionModel(
      String officeSubSectionName
    , OfficeTaskModel[] officeTask
    , OfficeSectionManagedObjectModel[] officeSectionManagedObject
    , OfficeSubSectionModel[] officeSubSection
    , OfficeSubSectionToOfficeGovernanceModel[] officeGovernance
    , int x
    , int y
    ) {
        this.officeSubSectionName = officeSubSectionName;
        if (officeTask != null) {
            for (OfficeTaskModel model : officeTask) {
                this.officeTask.add(model);
            }
        }
        if (officeSectionManagedObject != null) {
            for (OfficeSectionManagedObjectModel model : officeSectionManagedObject) {
                this.officeSectionManagedObject.add(model);
            }
        }
        if (officeSubSection != null) {
            for (OfficeSubSectionModel model : officeSubSection) {
                this.officeSubSection.add(model);
            }
        }
        if (officeGovernance != null) {
            for (OfficeSubSectionToOfficeGovernanceModel model : officeGovernance) {
                this.officeGovernance.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }

    /**
     * Office sub section name.
     */
    private String officeSubSectionName;

    public String getOfficeSubSectionName() {
        return this.officeSubSectionName;
    }

    public void setOfficeSubSectionName(String officeSubSectionName) {
        String oldValue = this.officeSubSectionName;
        this.officeSubSectionName = officeSubSectionName;
        this.changeField(oldValue, this.officeSubSectionName, OfficeSubSectionEvent.CHANGE_OFFICE_SUB_SECTION_NAME);
    }


    /**
     * Office task.
     */
    private List<OfficeTaskModel> officeTask = new LinkedList<OfficeTaskModel>();

    public List<OfficeTaskModel> getOfficeTasks() {
        return this.officeTask;
    }

    public void addOfficeTask(OfficeTaskModel officeTask) {
        this.addItemToList(officeTask, this.officeTask, OfficeSubSectionEvent.ADD_OFFICE_TASK);
    }

    public void removeOfficeTask(OfficeTaskModel officeTask) {
        this.removeItemFromList(officeTask, this.officeTask, OfficeSubSectionEvent.REMOVE_OFFICE_TASK);
    }

    /**
     * Office section managed object.
     */
    private List<OfficeSectionManagedObjectModel> officeSectionManagedObject = new LinkedList<OfficeSectionManagedObjectModel>();

    public List<OfficeSectionManagedObjectModel> getOfficeSectionManagedObjects() {
        return this.officeSectionManagedObject;
    }

    public void addOfficeSectionManagedObject(OfficeSectionManagedObjectModel officeSectionManagedObject) {
        this.addItemToList(officeSectionManagedObject, this.officeSectionManagedObject, OfficeSubSectionEvent.ADD_OFFICE_SECTION_MANAGED_OBJECT);
    }

    public void removeOfficeSectionManagedObject(OfficeSectionManagedObjectModel officeSectionManagedObject) {
        this.removeItemFromList(officeSectionManagedObject, this.officeSectionManagedObject, OfficeSubSectionEvent.REMOVE_OFFICE_SECTION_MANAGED_OBJECT);
    }

    /**
     * Office sub section.
     */
    private List<OfficeSubSectionModel> officeSubSection = new LinkedList<OfficeSubSectionModel>();

    public List<OfficeSubSectionModel> getOfficeSubSections() {
        return this.officeSubSection;
    }

    public void addOfficeSubSection(OfficeSubSectionModel officeSubSection) {
        this.addItemToList(officeSubSection, this.officeSubSection, OfficeSubSectionEvent.ADD_OFFICE_SUB_SECTION);
    }

    public void removeOfficeSubSection(OfficeSubSectionModel officeSubSection) {
        this.removeItemFromList(officeSubSection, this.officeSubSection, OfficeSubSectionEvent.REMOVE_OFFICE_SUB_SECTION);
    }

    /**
     * Office governance.
     */
    private List<OfficeSubSectionToOfficeGovernanceModel> officeGovernance = new LinkedList<OfficeSubSectionToOfficeGovernanceModel>();

    public List<OfficeSubSectionToOfficeGovernanceModel> getOfficeGovernances() {
        return this.officeGovernance;
    }

    public void addOfficeGovernance(OfficeSubSectionToOfficeGovernanceModel officeGovernance) {
        this.addItemToList(officeGovernance, this.officeGovernance, OfficeSubSectionEvent.ADD_OFFICE_GOVERNANCE);
    }

    public void removeOfficeGovernance(OfficeSubSectionToOfficeGovernanceModel officeGovernance) {
        this.removeItemFromList(officeGovernance, this.officeGovernance, OfficeSubSectionEvent.REMOVE_OFFICE_GOVERNANCE);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<OfficeSubSectionModel> removeConnections() {
        RemoveConnectionsAction<OfficeSubSectionModel> _action = new RemoveConnectionsAction<OfficeSubSectionModel>(this);
        _action.disconnect(this.officeGovernance);
        return _action;
    }
}
