/*
 * 
 */
package net.officefloor.model.office;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class OfficeTaskModel extends AbstractModel implements ItemModel<OfficeTaskModel> {

    public static enum OfficeTaskEvent {
     CHANGE_OFFICE_TASK_NAME, ADD_PRE_DUTY, REMOVE_PRE_DUTY, ADD_POST_DUTY, REMOVE_POST_DUTY, ADD_OFFICE_GOVERNANCE, REMOVE_OFFICE_GOVERNANCE
    }

    /**
     * Default constructor.
     */
    public OfficeTaskModel() {
    }

    /**
     * Convenience constructor for new non-linked instance.
     */
    public OfficeTaskModel(
      String officeTaskName
    ) {
        this.officeTaskName = officeTaskName;
    }

    /**
     * Convenience constructor.
     */
    public OfficeTaskModel(
      String officeTaskName
    , OfficeTaskToPreDutyModel[] preDuty
    , OfficeTaskToPostDutyModel[] postDuty
    , OfficeTaskToOfficeGovernanceModel[] officeGovernance
    ) {
        this.officeTaskName = officeTaskName;
        if (preDuty != null) {
            for (OfficeTaskToPreDutyModel model : preDuty) {
                this.preDuty.add(model);
            }
        }
        if (postDuty != null) {
            for (OfficeTaskToPostDutyModel model : postDuty) {
                this.postDuty.add(model);
            }
        }
        if (officeGovernance != null) {
            for (OfficeTaskToOfficeGovernanceModel model : officeGovernance) {
                this.officeGovernance.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public OfficeTaskModel(
      String officeTaskName
    , OfficeTaskToPreDutyModel[] preDuty
    , OfficeTaskToPostDutyModel[] postDuty
    , OfficeTaskToOfficeGovernanceModel[] officeGovernance
    , int x
    , int y
    ) {
        this.officeTaskName = officeTaskName;
        if (preDuty != null) {
            for (OfficeTaskToPreDutyModel model : preDuty) {
                this.preDuty.add(model);
            }
        }
        if (postDuty != null) {
            for (OfficeTaskToPostDutyModel model : postDuty) {
                this.postDuty.add(model);
            }
        }
        if (officeGovernance != null) {
            for (OfficeTaskToOfficeGovernanceModel model : officeGovernance) {
                this.officeGovernance.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }

    /**
     * Office task name.
     */
    private String officeTaskName;

    public String getOfficeTaskName() {
        return this.officeTaskName;
    }

    public void setOfficeTaskName(String officeTaskName) {
        String oldValue = this.officeTaskName;
        this.officeTaskName = officeTaskName;
        this.changeField(oldValue, this.officeTaskName, OfficeTaskEvent.CHANGE_OFFICE_TASK_NAME);
    }


    /**
     * Pre duty.
     */
    private List<OfficeTaskToPreDutyModel> preDuty = new LinkedList<OfficeTaskToPreDutyModel>();

    public List<OfficeTaskToPreDutyModel> getPreDuties() {
        return this.preDuty;
    }

    public void addPreDuty(OfficeTaskToPreDutyModel preDuty) {
        this.addItemToList(preDuty, this.preDuty, OfficeTaskEvent.ADD_PRE_DUTY);
    }

    public void removePreDuty(OfficeTaskToPreDutyModel preDuty) {
        this.removeItemFromList(preDuty, this.preDuty, OfficeTaskEvent.REMOVE_PRE_DUTY);
    }

    /**
     * Post duty.
     */
    private List<OfficeTaskToPostDutyModel> postDuty = new LinkedList<OfficeTaskToPostDutyModel>();

    public List<OfficeTaskToPostDutyModel> getPostDuties() {
        return this.postDuty;
    }

    public void addPostDuty(OfficeTaskToPostDutyModel postDuty) {
        this.addItemToList(postDuty, this.postDuty, OfficeTaskEvent.ADD_POST_DUTY);
    }

    public void removePostDuty(OfficeTaskToPostDutyModel postDuty) {
        this.removeItemFromList(postDuty, this.postDuty, OfficeTaskEvent.REMOVE_POST_DUTY);
    }

    /**
     * Office governance.
     */
    private List<OfficeTaskToOfficeGovernanceModel> officeGovernance = new LinkedList<OfficeTaskToOfficeGovernanceModel>();

    public List<OfficeTaskToOfficeGovernanceModel> getOfficeGovernances() {
        return this.officeGovernance;
    }

    public void addOfficeGovernance(OfficeTaskToOfficeGovernanceModel officeGovernance) {
        this.addItemToList(officeGovernance, this.officeGovernance, OfficeTaskEvent.ADD_OFFICE_GOVERNANCE);
    }

    public void removeOfficeGovernance(OfficeTaskToOfficeGovernanceModel officeGovernance) {
        this.removeItemFromList(officeGovernance, this.officeGovernance, OfficeTaskEvent.REMOVE_OFFICE_GOVERNANCE);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<OfficeTaskModel> removeConnections() {
        RemoveConnectionsAction<OfficeTaskModel> _action = new RemoveConnectionsAction<OfficeTaskModel>(this);
        _action.disconnect(this.preDuty);
        _action.disconnect(this.postDuty);
        _action.disconnect(this.officeGovernance);
        return _action;
    }
}
