/*
 * 
 */
package net.officefloor.model.office;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class OfficeTeamModel extends AbstractModel implements ItemModel<OfficeTeamModel> {

    public static enum OfficeTeamEvent {
     CHANGE_OFFICE_TEAM_NAME, ADD_OFFICE_SECTION_RESPONSIBILITY, REMOVE_OFFICE_SECTION_RESPONSIBILITY, ADD_OFFICE_MANAGED_OBJECT_SOURCE_TEAM, REMOVE_OFFICE_MANAGED_OBJECT_SOURCE_TEAM, ADD_ADMINISTRATOR, REMOVE_ADMINISTRATOR, ADD_OFFICE_GOVERNANCE, REMOVE_OFFICE_GOVERNANCE
    }

    /**
     * Default constructor.
     */
    public OfficeTeamModel() {
    }

    /**
     * Convenience constructor for new non-linked instance.
     */
    public OfficeTeamModel(
      String officeTeamName
    ) {
        this.officeTeamName = officeTeamName;
    }

    /**
     * Convenience constructor.
     */
    public OfficeTeamModel(
      String officeTeamName
    , OfficeSectionResponsibilityToOfficeTeamModel[] officeSectionResponsibility
    , OfficeManagedObjectSourceTeamToOfficeTeamModel[] officeManagedObjectSourceTeam
    , AdministratorToOfficeTeamModel[] administrator
    , OfficeGovernanceToOfficeTeamModel[] officeGovernance
    ) {
        this.officeTeamName = officeTeamName;
        if (officeSectionResponsibility != null) {
            for (OfficeSectionResponsibilityToOfficeTeamModel model : officeSectionResponsibility) {
                this.officeSectionResponsibility.add(model);
            }
        }
        if (officeManagedObjectSourceTeam != null) {
            for (OfficeManagedObjectSourceTeamToOfficeTeamModel model : officeManagedObjectSourceTeam) {
                this.officeManagedObjectSourceTeam.add(model);
            }
        }
        if (administrator != null) {
            for (AdministratorToOfficeTeamModel model : administrator) {
                this.administrator.add(model);
            }
        }
        if (officeGovernance != null) {
            for (OfficeGovernanceToOfficeTeamModel model : officeGovernance) {
                this.officeGovernance.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public OfficeTeamModel(
      String officeTeamName
    , OfficeSectionResponsibilityToOfficeTeamModel[] officeSectionResponsibility
    , OfficeManagedObjectSourceTeamToOfficeTeamModel[] officeManagedObjectSourceTeam
    , AdministratorToOfficeTeamModel[] administrator
    , OfficeGovernanceToOfficeTeamModel[] officeGovernance
    , int x
    , int y
    ) {
        this.officeTeamName = officeTeamName;
        if (officeSectionResponsibility != null) {
            for (OfficeSectionResponsibilityToOfficeTeamModel model : officeSectionResponsibility) {
                this.officeSectionResponsibility.add(model);
            }
        }
        if (officeManagedObjectSourceTeam != null) {
            for (OfficeManagedObjectSourceTeamToOfficeTeamModel model : officeManagedObjectSourceTeam) {
                this.officeManagedObjectSourceTeam.add(model);
            }
        }
        if (administrator != null) {
            for (AdministratorToOfficeTeamModel model : administrator) {
                this.administrator.add(model);
            }
        }
        if (officeGovernance != null) {
            for (OfficeGovernanceToOfficeTeamModel model : officeGovernance) {
                this.officeGovernance.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }

    /**
     * Office team name.
     */
    private String officeTeamName;

    public String getOfficeTeamName() {
        return this.officeTeamName;
    }

    public void setOfficeTeamName(String officeTeamName) {
        String oldValue = this.officeTeamName;
        this.officeTeamName = officeTeamName;
        this.changeField(oldValue, this.officeTeamName, OfficeTeamEvent.CHANGE_OFFICE_TEAM_NAME);
    }


    /**
     * Office section responsibility.
     */
    private List<OfficeSectionResponsibilityToOfficeTeamModel> officeSectionResponsibility = new LinkedList<OfficeSectionResponsibilityToOfficeTeamModel>();

    public List<OfficeSectionResponsibilityToOfficeTeamModel> getOfficeSectionResponsibilities() {
        return this.officeSectionResponsibility;
    }

    public void addOfficeSectionResponsibility(OfficeSectionResponsibilityToOfficeTeamModel officeSectionResponsibility) {
        this.addItemToList(officeSectionResponsibility, this.officeSectionResponsibility, OfficeTeamEvent.ADD_OFFICE_SECTION_RESPONSIBILITY);
    }

    public void removeOfficeSectionResponsibility(OfficeSectionResponsibilityToOfficeTeamModel officeSectionResponsibility) {
        this.removeItemFromList(officeSectionResponsibility, this.officeSectionResponsibility, OfficeTeamEvent.REMOVE_OFFICE_SECTION_RESPONSIBILITY);
    }

    /**
     * Office managed object source team.
     */
    private List<OfficeManagedObjectSourceTeamToOfficeTeamModel> officeManagedObjectSourceTeam = new LinkedList<OfficeManagedObjectSourceTeamToOfficeTeamModel>();

    public List<OfficeManagedObjectSourceTeamToOfficeTeamModel> getOfficeManagedObjectSourceTeams() {
        return this.officeManagedObjectSourceTeam;
    }

    public void addOfficeManagedObjectSourceTeam(OfficeManagedObjectSourceTeamToOfficeTeamModel officeManagedObjectSourceTeam) {
        this.addItemToList(officeManagedObjectSourceTeam, this.officeManagedObjectSourceTeam, OfficeTeamEvent.ADD_OFFICE_MANAGED_OBJECT_SOURCE_TEAM);
    }

    public void removeOfficeManagedObjectSourceTeam(OfficeManagedObjectSourceTeamToOfficeTeamModel officeManagedObjectSourceTeam) {
        this.removeItemFromList(officeManagedObjectSourceTeam, this.officeManagedObjectSourceTeam, OfficeTeamEvent.REMOVE_OFFICE_MANAGED_OBJECT_SOURCE_TEAM);
    }

    /**
     * Administrator.
     */
    private List<AdministratorToOfficeTeamModel> administrator = new LinkedList<AdministratorToOfficeTeamModel>();

    public List<AdministratorToOfficeTeamModel> getAdministrators() {
        return this.administrator;
    }

    public void addAdministrator(AdministratorToOfficeTeamModel administrator) {
        this.addItemToList(administrator, this.administrator, OfficeTeamEvent.ADD_ADMINISTRATOR);
    }

    public void removeAdministrator(AdministratorToOfficeTeamModel administrator) {
        this.removeItemFromList(administrator, this.administrator, OfficeTeamEvent.REMOVE_ADMINISTRATOR);
    }

    /**
     * Office governance.
     */
    private List<OfficeGovernanceToOfficeTeamModel> officeGovernance = new LinkedList<OfficeGovernanceToOfficeTeamModel>();

    public List<OfficeGovernanceToOfficeTeamModel> getOfficeGovernances() {
        return this.officeGovernance;
    }

    public void addOfficeGovernance(OfficeGovernanceToOfficeTeamModel officeGovernance) {
        this.addItemToList(officeGovernance, this.officeGovernance, OfficeTeamEvent.ADD_OFFICE_GOVERNANCE);
    }

    public void removeOfficeGovernance(OfficeGovernanceToOfficeTeamModel officeGovernance) {
        this.removeItemFromList(officeGovernance, this.officeGovernance, OfficeTeamEvent.REMOVE_OFFICE_GOVERNANCE);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<OfficeTeamModel> removeConnections() {
        RemoveConnectionsAction<OfficeTeamModel> _action = new RemoveConnectionsAction<OfficeTeamModel>(this);
        _action.disconnect(this.officeSectionResponsibility);
        _action.disconnect(this.officeManagedObjectSourceTeam);
        _action.disconnect(this.administrator);
        _action.disconnect(this.officeGovernance);
        return _action;
    }
}
