/*
 * 
 */
package net.officefloor.model.officefloor;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class DeployedOfficeInputModel extends AbstractModel implements ItemModel<DeployedOfficeInputModel> {

    public static enum DeployedOfficeInputEvent {
     CHANGE_SECTION_NAME, CHANGE_SECTION_INPUT_NAME, CHANGE_PARAMETER_TYPE, ADD_OFFICE_FLOOR_MANAGED_OBJECT_SOURCE_FLOW, REMOVE_OFFICE_FLOOR_MANAGED_OBJECT_SOURCE_FLOW
    }

    /**
     * Default constructor.
     */
    public DeployedOfficeInputModel() {
    }

    /**
     * Convenience constructor for new non-linked instance.
     */
    public DeployedOfficeInputModel(
      String sectionName
    , String sectionInputName
    , String parameterType
    ) {
        this.sectionName = sectionName;
        this.sectionInputName = sectionInputName;
        this.parameterType = parameterType;
    }

    /**
     * Convenience constructor.
     */
    public DeployedOfficeInputModel(
      String sectionName
    , String sectionInputName
    , String parameterType
    , OfficeFloorManagedObjectSourceFlowToDeployedOfficeInputModel[] officeFloorManagedObjectSourceFlow
    ) {
        this.sectionName = sectionName;
        this.sectionInputName = sectionInputName;
        this.parameterType = parameterType;
        if (officeFloorManagedObjectSourceFlow != null) {
            for (OfficeFloorManagedObjectSourceFlowToDeployedOfficeInputModel model : officeFloorManagedObjectSourceFlow) {
                this.officeFloorManagedObjectSourceFlow.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public DeployedOfficeInputModel(
      String sectionName
    , String sectionInputName
    , String parameterType
    , OfficeFloorManagedObjectSourceFlowToDeployedOfficeInputModel[] officeFloorManagedObjectSourceFlow
    , int x
    , int y
    ) {
        this.sectionName = sectionName;
        this.sectionInputName = sectionInputName;
        this.parameterType = parameterType;
        if (officeFloorManagedObjectSourceFlow != null) {
            for (OfficeFloorManagedObjectSourceFlowToDeployedOfficeInputModel model : officeFloorManagedObjectSourceFlow) {
                this.officeFloorManagedObjectSourceFlow.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }

    /**
     * Section name.
     */
    private String sectionName;

    public String getSectionName() {
        return this.sectionName;
    }

    public void setSectionName(String sectionName) {
        String oldValue = this.sectionName;
        this.sectionName = sectionName;
        this.changeField(oldValue, this.sectionName, DeployedOfficeInputEvent.CHANGE_SECTION_NAME);
    }

    /**
     * Section input name.
     */
    private String sectionInputName;

    public String getSectionInputName() {
        return this.sectionInputName;
    }

    public void setSectionInputName(String sectionInputName) {
        String oldValue = this.sectionInputName;
        this.sectionInputName = sectionInputName;
        this.changeField(oldValue, this.sectionInputName, DeployedOfficeInputEvent.CHANGE_SECTION_INPUT_NAME);
    }

    /**
     * Parameter type.
     */
    private String parameterType;

    public String getParameterType() {
        return this.parameterType;
    }

    public void setParameterType(String parameterType) {
        String oldValue = this.parameterType;
        this.parameterType = parameterType;
        this.changeField(oldValue, this.parameterType, DeployedOfficeInputEvent.CHANGE_PARAMETER_TYPE);
    }


    /**
     * Office floor managed object source flow.
     */
    private List<OfficeFloorManagedObjectSourceFlowToDeployedOfficeInputModel> officeFloorManagedObjectSourceFlow = new LinkedList<OfficeFloorManagedObjectSourceFlowToDeployedOfficeInputModel>();

    public List<OfficeFloorManagedObjectSourceFlowToDeployedOfficeInputModel> getOfficeFloorManagedObjectSourceFlows() {
        return this.officeFloorManagedObjectSourceFlow;
    }

    public void addOfficeFloorManagedObjectSourceFlow(OfficeFloorManagedObjectSourceFlowToDeployedOfficeInputModel officeFloorManagedObjectSourceFlow) {
        this.addItemToList(officeFloorManagedObjectSourceFlow, this.officeFloorManagedObjectSourceFlow, DeployedOfficeInputEvent.ADD_OFFICE_FLOOR_MANAGED_OBJECT_SOURCE_FLOW);
    }

    public void removeOfficeFloorManagedObjectSourceFlow(OfficeFloorManagedObjectSourceFlowToDeployedOfficeInputModel officeFloorManagedObjectSourceFlow) {
        this.removeItemFromList(officeFloorManagedObjectSourceFlow, this.officeFloorManagedObjectSourceFlow, DeployedOfficeInputEvent.REMOVE_OFFICE_FLOOR_MANAGED_OBJECT_SOURCE_FLOW);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<DeployedOfficeInputModel> removeConnections() {
        RemoveConnectionsAction<DeployedOfficeInputModel> _action = new RemoveConnectionsAction<DeployedOfficeInputModel>(this);
        _action.disconnect(this.officeFloorManagedObjectSourceFlow);
        return _action;
    }
}
