/*
 * 
 */
package net.officefloor.model.officefloor;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class DeployedOfficeModel extends AbstractModel implements ItemModel<DeployedOfficeModel> {

    public static enum DeployedOfficeEvent {
     CHANGE_DEPLOYED_OFFICE_NAME, CHANGE_OFFICE_SOURCE_CLASS_NAME, CHANGE_OFFICE_LOCATION, ADD_PROPERTY, REMOVE_PROPERTY, ADD_DEPLOYED_OFFICE_OBJECT, REMOVE_DEPLOYED_OFFICE_OBJECT, ADD_DEPLOYED_OFFICE_INPUT, REMOVE_DEPLOYED_OFFICE_INPUT, ADD_DEPLOYED_OFFICE_TEAM, REMOVE_DEPLOYED_OFFICE_TEAM, ADD_OFFICE_FLOOR_MANAGED_OBJECT_SOURCE, REMOVE_OFFICE_FLOOR_MANAGED_OBJECT_SOURCE
    }

    /**
     * Default constructor.
     */
    public DeployedOfficeModel() {
    }

    /**
     * Convenience constructor for new non-linked instance.
     */
    public DeployedOfficeModel(
      String deployedOfficeName
    , String officeSourceClassName
    , String officeLocation
    ) {
        this.deployedOfficeName = deployedOfficeName;
        this.officeSourceClassName = officeSourceClassName;
        this.officeLocation = officeLocation;
    }

    /**
     * Convenience constructor.
     */
    public DeployedOfficeModel(
      String deployedOfficeName
    , String officeSourceClassName
    , String officeLocation
    , PropertyModel[] property
    , DeployedOfficeObjectModel[] deployedOfficeObject
    , DeployedOfficeInputModel[] deployedOfficeInput
    , DeployedOfficeTeamModel[] deployedOfficeTeam
    , OfficeFloorManagedObjectSourceToDeployedOfficeModel[] officeFloorManagedObjectSource
    ) {
        this.deployedOfficeName = deployedOfficeName;
        this.officeSourceClassName = officeSourceClassName;
        this.officeLocation = officeLocation;
        if (property != null) {
            for (PropertyModel model : property) {
                this.property.add(model);
            }
        }
        if (deployedOfficeObject != null) {
            for (DeployedOfficeObjectModel model : deployedOfficeObject) {
                this.deployedOfficeObject.add(model);
            }
        }
        if (deployedOfficeInput != null) {
            for (DeployedOfficeInputModel model : deployedOfficeInput) {
                this.deployedOfficeInput.add(model);
            }
        }
        if (deployedOfficeTeam != null) {
            for (DeployedOfficeTeamModel model : deployedOfficeTeam) {
                this.deployedOfficeTeam.add(model);
            }
        }
        if (officeFloorManagedObjectSource != null) {
            for (OfficeFloorManagedObjectSourceToDeployedOfficeModel model : officeFloorManagedObjectSource) {
                this.officeFloorManagedObjectSource.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public DeployedOfficeModel(
      String deployedOfficeName
    , String officeSourceClassName
    , String officeLocation
    , PropertyModel[] property
    , DeployedOfficeObjectModel[] deployedOfficeObject
    , DeployedOfficeInputModel[] deployedOfficeInput
    , DeployedOfficeTeamModel[] deployedOfficeTeam
    , OfficeFloorManagedObjectSourceToDeployedOfficeModel[] officeFloorManagedObjectSource
    , int x
    , int y
    ) {
        this.deployedOfficeName = deployedOfficeName;
        this.officeSourceClassName = officeSourceClassName;
        this.officeLocation = officeLocation;
        if (property != null) {
            for (PropertyModel model : property) {
                this.property.add(model);
            }
        }
        if (deployedOfficeObject != null) {
            for (DeployedOfficeObjectModel model : deployedOfficeObject) {
                this.deployedOfficeObject.add(model);
            }
        }
        if (deployedOfficeInput != null) {
            for (DeployedOfficeInputModel model : deployedOfficeInput) {
                this.deployedOfficeInput.add(model);
            }
        }
        if (deployedOfficeTeam != null) {
            for (DeployedOfficeTeamModel model : deployedOfficeTeam) {
                this.deployedOfficeTeam.add(model);
            }
        }
        if (officeFloorManagedObjectSource != null) {
            for (OfficeFloorManagedObjectSourceToDeployedOfficeModel model : officeFloorManagedObjectSource) {
                this.officeFloorManagedObjectSource.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }

    /**
     * Deployed office name.
     */
    private String deployedOfficeName;

    public String getDeployedOfficeName() {
        return this.deployedOfficeName;
    }

    public void setDeployedOfficeName(String deployedOfficeName) {
        String oldValue = this.deployedOfficeName;
        this.deployedOfficeName = deployedOfficeName;
        this.changeField(oldValue, this.deployedOfficeName, DeployedOfficeEvent.CHANGE_DEPLOYED_OFFICE_NAME);
    }

    /**
     * Office source class name.
     */
    private String officeSourceClassName;

    public String getOfficeSourceClassName() {
        return this.officeSourceClassName;
    }

    public void setOfficeSourceClassName(String officeSourceClassName) {
        String oldValue = this.officeSourceClassName;
        this.officeSourceClassName = officeSourceClassName;
        this.changeField(oldValue, this.officeSourceClassName, DeployedOfficeEvent.CHANGE_OFFICE_SOURCE_CLASS_NAME);
    }

    /**
     * Office location.
     */
    private String officeLocation;

    public String getOfficeLocation() {
        return this.officeLocation;
    }

    public void setOfficeLocation(String officeLocation) {
        String oldValue = this.officeLocation;
        this.officeLocation = officeLocation;
        this.changeField(oldValue, this.officeLocation, DeployedOfficeEvent.CHANGE_OFFICE_LOCATION);
    }


    /**
     * Property.
     */
    private List<PropertyModel> property = new LinkedList<PropertyModel>();

    public List<PropertyModel> getProperties() {
        return this.property;
    }

    public void addProperty(PropertyModel property) {
        this.addItemToList(property, this.property, DeployedOfficeEvent.ADD_PROPERTY);
    }

    public void removeProperty(PropertyModel property) {
        this.removeItemFromList(property, this.property, DeployedOfficeEvent.REMOVE_PROPERTY);
    }

    /**
     * Deployed office object.
     */
    private List<DeployedOfficeObjectModel> deployedOfficeObject = new LinkedList<DeployedOfficeObjectModel>();

    public List<DeployedOfficeObjectModel> getDeployedOfficeObjects() {
        return this.deployedOfficeObject;
    }

    public void addDeployedOfficeObject(DeployedOfficeObjectModel deployedOfficeObject) {
        this.addItemToList(deployedOfficeObject, this.deployedOfficeObject, DeployedOfficeEvent.ADD_DEPLOYED_OFFICE_OBJECT);
    }

    public void removeDeployedOfficeObject(DeployedOfficeObjectModel deployedOfficeObject) {
        this.removeItemFromList(deployedOfficeObject, this.deployedOfficeObject, DeployedOfficeEvent.REMOVE_DEPLOYED_OFFICE_OBJECT);
    }

    /**
     * Deployed office input.
     */
    private List<DeployedOfficeInputModel> deployedOfficeInput = new LinkedList<DeployedOfficeInputModel>();

    public List<DeployedOfficeInputModel> getDeployedOfficeInputs() {
        return this.deployedOfficeInput;
    }

    public void addDeployedOfficeInput(DeployedOfficeInputModel deployedOfficeInput) {
        this.addItemToList(deployedOfficeInput, this.deployedOfficeInput, DeployedOfficeEvent.ADD_DEPLOYED_OFFICE_INPUT);
    }

    public void removeDeployedOfficeInput(DeployedOfficeInputModel deployedOfficeInput) {
        this.removeItemFromList(deployedOfficeInput, this.deployedOfficeInput, DeployedOfficeEvent.REMOVE_DEPLOYED_OFFICE_INPUT);
    }

    /**
     * Deployed office team.
     */
    private List<DeployedOfficeTeamModel> deployedOfficeTeam = new LinkedList<DeployedOfficeTeamModel>();

    public List<DeployedOfficeTeamModel> getDeployedOfficeTeams() {
        return this.deployedOfficeTeam;
    }

    public void addDeployedOfficeTeam(DeployedOfficeTeamModel deployedOfficeTeam) {
        this.addItemToList(deployedOfficeTeam, this.deployedOfficeTeam, DeployedOfficeEvent.ADD_DEPLOYED_OFFICE_TEAM);
    }

    public void removeDeployedOfficeTeam(DeployedOfficeTeamModel deployedOfficeTeam) {
        this.removeItemFromList(deployedOfficeTeam, this.deployedOfficeTeam, DeployedOfficeEvent.REMOVE_DEPLOYED_OFFICE_TEAM);
    }

    /**
     * Office floor managed object source.
     */
    private List<OfficeFloorManagedObjectSourceToDeployedOfficeModel> officeFloorManagedObjectSource = new LinkedList<OfficeFloorManagedObjectSourceToDeployedOfficeModel>();

    public List<OfficeFloorManagedObjectSourceToDeployedOfficeModel> getOfficeFloorManagedObjectSources() {
        return this.officeFloorManagedObjectSource;
    }

    public void addOfficeFloorManagedObjectSource(OfficeFloorManagedObjectSourceToDeployedOfficeModel officeFloorManagedObjectSource) {
        this.addItemToList(officeFloorManagedObjectSource, this.officeFloorManagedObjectSource, DeployedOfficeEvent.ADD_OFFICE_FLOOR_MANAGED_OBJECT_SOURCE);
    }

    public void removeOfficeFloorManagedObjectSource(OfficeFloorManagedObjectSourceToDeployedOfficeModel officeFloorManagedObjectSource) {
        this.removeItemFromList(officeFloorManagedObjectSource, this.officeFloorManagedObjectSource, DeployedOfficeEvent.REMOVE_OFFICE_FLOOR_MANAGED_OBJECT_SOURCE);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<DeployedOfficeModel> removeConnections() {
        RemoveConnectionsAction<DeployedOfficeModel> _action = new RemoveConnectionsAction<DeployedOfficeModel>(this);
        _action.disconnect(this.officeFloorManagedObjectSource);
        return _action;
    }
}
