/*
 * 
 */
package net.officefloor.model.officefloor;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class OfficeFloorManagedObjectModel extends AbstractModel implements ItemModel<OfficeFloorManagedObjectModel> {

    public static enum OfficeFloorManagedObjectEvent {
     CHANGE_OFFICE_FLOOR_MANAGED_OBJECT_NAME, CHANGE_MANAGED_OBJECT_SCOPE, CHANGE_OFFICE_FLOOR_MANAGED_OBJECT_SOURCE, ADD_DEPLOYED_OFFICE_OBJECT, REMOVE_DEPLOYED_OFFICE_OBJECT, ADD_DEPENDENT_OFFICE_FLOOR_MANAGED_OBJECT, REMOVE_DEPENDENT_OFFICE_FLOOR_MANAGED_OBJECT, ADD_DEPENDENT_OFFICE_FLOOR_MANAGED_OBJECT_SOURCE_INPUT, REMOVE_DEPENDENT_OFFICE_FLOOR_MANAGED_OBJECT_SOURCE_INPUT, ADD_OFFICE_FLOOR_MANAGED_OBJECT_DEPENDENCY, REMOVE_OFFICE_FLOOR_MANAGED_OBJECT_DEPENDENCY
    }

    /**
     * Default constructor.
     */
    public OfficeFloorManagedObjectModel() {
    }

    /**
     * Convenience constructor for new non-linked instance.
     */
    public OfficeFloorManagedObjectModel(
      String officeFloorManagedObjectName
    , String managedObjectScope
    ) {
        this.officeFloorManagedObjectName = officeFloorManagedObjectName;
        this.managedObjectScope = managedObjectScope;
    }

    /**
     * Convenience constructor.
     */
    public OfficeFloorManagedObjectModel(
      String officeFloorManagedObjectName
    , String managedObjectScope
    , OfficeFloorManagedObjectToOfficeFloorManagedObjectSourceModel officeFloorManagedObjectSource
    , DeployedOfficeObjectToOfficeFloorManagedObjectModel[] deployedOfficeObject
    , OfficeFloorManagedObjectDependencyToOfficeFloorManagedObjectModel[] dependentOfficeFloorManagedObject
    , OfficeFloorManagedObjectSourceInputDependencyToOfficeFloorManagedObjectModel[] dependentOfficeFloorManagedObjectSourceInput
    , OfficeFloorManagedObjectDependencyModel[] officeFloorManagedObjectDependency
    ) {
        this.officeFloorManagedObjectName = officeFloorManagedObjectName;
        this.managedObjectScope = managedObjectScope;
        this.officeFloorManagedObjectSource = officeFloorManagedObjectSource;
        if (deployedOfficeObject != null) {
            for (DeployedOfficeObjectToOfficeFloorManagedObjectModel model : deployedOfficeObject) {
                this.deployedOfficeObject.add(model);
            }
        }
        if (dependentOfficeFloorManagedObject != null) {
            for (OfficeFloorManagedObjectDependencyToOfficeFloorManagedObjectModel model : dependentOfficeFloorManagedObject) {
                this.dependentOfficeFloorManagedObject.add(model);
            }
        }
        if (dependentOfficeFloorManagedObjectSourceInput != null) {
            for (OfficeFloorManagedObjectSourceInputDependencyToOfficeFloorManagedObjectModel model : dependentOfficeFloorManagedObjectSourceInput) {
                this.dependentOfficeFloorManagedObjectSourceInput.add(model);
            }
        }
        if (officeFloorManagedObjectDependency != null) {
            for (OfficeFloorManagedObjectDependencyModel model : officeFloorManagedObjectDependency) {
                this.officeFloorManagedObjectDependency.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public OfficeFloorManagedObjectModel(
      String officeFloorManagedObjectName
    , String managedObjectScope
    , OfficeFloorManagedObjectToOfficeFloorManagedObjectSourceModel officeFloorManagedObjectSource
    , DeployedOfficeObjectToOfficeFloorManagedObjectModel[] deployedOfficeObject
    , OfficeFloorManagedObjectDependencyToOfficeFloorManagedObjectModel[] dependentOfficeFloorManagedObject
    , OfficeFloorManagedObjectSourceInputDependencyToOfficeFloorManagedObjectModel[] dependentOfficeFloorManagedObjectSourceInput
    , OfficeFloorManagedObjectDependencyModel[] officeFloorManagedObjectDependency
    , int x
    , int y
    ) {
        this.officeFloorManagedObjectName = officeFloorManagedObjectName;
        this.managedObjectScope = managedObjectScope;
        this.officeFloorManagedObjectSource = officeFloorManagedObjectSource;
        if (deployedOfficeObject != null) {
            for (DeployedOfficeObjectToOfficeFloorManagedObjectModel model : deployedOfficeObject) {
                this.deployedOfficeObject.add(model);
            }
        }
        if (dependentOfficeFloorManagedObject != null) {
            for (OfficeFloorManagedObjectDependencyToOfficeFloorManagedObjectModel model : dependentOfficeFloorManagedObject) {
                this.dependentOfficeFloorManagedObject.add(model);
            }
        }
        if (dependentOfficeFloorManagedObjectSourceInput != null) {
            for (OfficeFloorManagedObjectSourceInputDependencyToOfficeFloorManagedObjectModel model : dependentOfficeFloorManagedObjectSourceInput) {
                this.dependentOfficeFloorManagedObjectSourceInput.add(model);
            }
        }
        if (officeFloorManagedObjectDependency != null) {
            for (OfficeFloorManagedObjectDependencyModel model : officeFloorManagedObjectDependency) {
                this.officeFloorManagedObjectDependency.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }

    /**
     * Office floor managed object name.
     */
    private String officeFloorManagedObjectName;

    public String getOfficeFloorManagedObjectName() {
        return this.officeFloorManagedObjectName;
    }

    public void setOfficeFloorManagedObjectName(String officeFloorManagedObjectName) {
        String oldValue = this.officeFloorManagedObjectName;
        this.officeFloorManagedObjectName = officeFloorManagedObjectName;
        this.changeField(oldValue, this.officeFloorManagedObjectName, OfficeFloorManagedObjectEvent.CHANGE_OFFICE_FLOOR_MANAGED_OBJECT_NAME);
    }

    /**
     * Managed object scope.
     */
    private String managedObjectScope;

    public String getManagedObjectScope() {
        return this.managedObjectScope;
    }

    public void setManagedObjectScope(String managedObjectScope) {
        String oldValue = this.managedObjectScope;
        this.managedObjectScope = managedObjectScope;
        this.changeField(oldValue, this.managedObjectScope, OfficeFloorManagedObjectEvent.CHANGE_MANAGED_OBJECT_SCOPE);
    }

    /**
     * Office floor managed object source.
     */
    private OfficeFloorManagedObjectToOfficeFloorManagedObjectSourceModel officeFloorManagedObjectSource;

    public OfficeFloorManagedObjectToOfficeFloorManagedObjectSourceModel getOfficeFloorManagedObjectSource() {
        return this.officeFloorManagedObjectSource;
    }

    public void setOfficeFloorManagedObjectSource(OfficeFloorManagedObjectToOfficeFloorManagedObjectSourceModel officeFloorManagedObjectSource) {
        OfficeFloorManagedObjectToOfficeFloorManagedObjectSourceModel oldValue = this.officeFloorManagedObjectSource;
        this.officeFloorManagedObjectSource = officeFloorManagedObjectSource;
        this.changeField(oldValue, this.officeFloorManagedObjectSource, OfficeFloorManagedObjectEvent.CHANGE_OFFICE_FLOOR_MANAGED_OBJECT_SOURCE);
    }


    /**
     * Deployed office object.
     */
    private List<DeployedOfficeObjectToOfficeFloorManagedObjectModel> deployedOfficeObject = new LinkedList<DeployedOfficeObjectToOfficeFloorManagedObjectModel>();

    public List<DeployedOfficeObjectToOfficeFloorManagedObjectModel> getDeployedOfficeObjects() {
        return this.deployedOfficeObject;
    }

    public void addDeployedOfficeObject(DeployedOfficeObjectToOfficeFloorManagedObjectModel deployedOfficeObject) {
        this.addItemToList(deployedOfficeObject, this.deployedOfficeObject, OfficeFloorManagedObjectEvent.ADD_DEPLOYED_OFFICE_OBJECT);
    }

    public void removeDeployedOfficeObject(DeployedOfficeObjectToOfficeFloorManagedObjectModel deployedOfficeObject) {
        this.removeItemFromList(deployedOfficeObject, this.deployedOfficeObject, OfficeFloorManagedObjectEvent.REMOVE_DEPLOYED_OFFICE_OBJECT);
    }

    /**
     * Dependent office floor managed object.
     */
    private List<OfficeFloorManagedObjectDependencyToOfficeFloorManagedObjectModel> dependentOfficeFloorManagedObject = new LinkedList<OfficeFloorManagedObjectDependencyToOfficeFloorManagedObjectModel>();

    public List<OfficeFloorManagedObjectDependencyToOfficeFloorManagedObjectModel> getDependentOfficeFloorManagedObjects() {
        return this.dependentOfficeFloorManagedObject;
    }

    public void addDependentOfficeFloorManagedObject(OfficeFloorManagedObjectDependencyToOfficeFloorManagedObjectModel dependentOfficeFloorManagedObject) {
        this.addItemToList(dependentOfficeFloorManagedObject, this.dependentOfficeFloorManagedObject, OfficeFloorManagedObjectEvent.ADD_DEPENDENT_OFFICE_FLOOR_MANAGED_OBJECT);
    }

    public void removeDependentOfficeFloorManagedObject(OfficeFloorManagedObjectDependencyToOfficeFloorManagedObjectModel dependentOfficeFloorManagedObject) {
        this.removeItemFromList(dependentOfficeFloorManagedObject, this.dependentOfficeFloorManagedObject, OfficeFloorManagedObjectEvent.REMOVE_DEPENDENT_OFFICE_FLOOR_MANAGED_OBJECT);
    }

    /**
     * Dependent office floor managed object source input.
     */
    private List<OfficeFloorManagedObjectSourceInputDependencyToOfficeFloorManagedObjectModel> dependentOfficeFloorManagedObjectSourceInput = new LinkedList<OfficeFloorManagedObjectSourceInputDependencyToOfficeFloorManagedObjectModel>();

    public List<OfficeFloorManagedObjectSourceInputDependencyToOfficeFloorManagedObjectModel> getDependentOfficeFloorManagedObjectSourceInputs() {
        return this.dependentOfficeFloorManagedObjectSourceInput;
    }

    public void addDependentOfficeFloorManagedObjectSourceInput(OfficeFloorManagedObjectSourceInputDependencyToOfficeFloorManagedObjectModel dependentOfficeFloorManagedObjectSourceInput) {
        this.addItemToList(dependentOfficeFloorManagedObjectSourceInput, this.dependentOfficeFloorManagedObjectSourceInput, OfficeFloorManagedObjectEvent.ADD_DEPENDENT_OFFICE_FLOOR_MANAGED_OBJECT_SOURCE_INPUT);
    }

    public void removeDependentOfficeFloorManagedObjectSourceInput(OfficeFloorManagedObjectSourceInputDependencyToOfficeFloorManagedObjectModel dependentOfficeFloorManagedObjectSourceInput) {
        this.removeItemFromList(dependentOfficeFloorManagedObjectSourceInput, this.dependentOfficeFloorManagedObjectSourceInput, OfficeFloorManagedObjectEvent.REMOVE_DEPENDENT_OFFICE_FLOOR_MANAGED_OBJECT_SOURCE_INPUT);
    }

    /**
     * Office floor managed object dependency.
     */
    private List<OfficeFloorManagedObjectDependencyModel> officeFloorManagedObjectDependency = new LinkedList<OfficeFloorManagedObjectDependencyModel>();

    public List<OfficeFloorManagedObjectDependencyModel> getOfficeFloorManagedObjectDependencies() {
        return this.officeFloorManagedObjectDependency;
    }

    public void addOfficeFloorManagedObjectDependency(OfficeFloorManagedObjectDependencyModel officeFloorManagedObjectDependency) {
        this.addItemToList(officeFloorManagedObjectDependency, this.officeFloorManagedObjectDependency, OfficeFloorManagedObjectEvent.ADD_OFFICE_FLOOR_MANAGED_OBJECT_DEPENDENCY);
    }

    public void removeOfficeFloorManagedObjectDependency(OfficeFloorManagedObjectDependencyModel officeFloorManagedObjectDependency) {
        this.removeItemFromList(officeFloorManagedObjectDependency, this.officeFloorManagedObjectDependency, OfficeFloorManagedObjectEvent.REMOVE_OFFICE_FLOOR_MANAGED_OBJECT_DEPENDENCY);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<OfficeFloorManagedObjectModel> removeConnections() {
        RemoveConnectionsAction<OfficeFloorManagedObjectModel> _action = new RemoveConnectionsAction<OfficeFloorManagedObjectModel>(this);
        _action.disconnect(this.officeFloorManagedObjectSource);
        _action.disconnect(this.deployedOfficeObject);
        _action.disconnect(this.dependentOfficeFloorManagedObject);
        _action.disconnect(this.dependentOfficeFloorManagedObjectSourceInput);
        return _action;
    }
}
