/*
 * 
 */
package net.officefloor.model.officefloor;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class OfficeFloorModel extends AbstractModel implements ItemModel<OfficeFloorModel> {

    public static enum OfficeFloorEvent {
     ADD_OFFICE_FLOOR_SUPPLIER, REMOVE_OFFICE_FLOOR_SUPPLIER, ADD_OFFICE_FLOOR_MANAGED_OBJECT_SOURCE, REMOVE_OFFICE_FLOOR_MANAGED_OBJECT_SOURCE, ADD_OFFICE_FLOOR_INPUT_MANAGED_OBJECT, REMOVE_OFFICE_FLOOR_INPUT_MANAGED_OBJECT, ADD_OFFICE_FLOOR_MANAGED_OBJECT, REMOVE_OFFICE_FLOOR_MANAGED_OBJECT, ADD_OFFICE_FLOOR_TEAM, REMOVE_OFFICE_FLOOR_TEAM, ADD_DEPLOYED_OFFICE, REMOVE_DEPLOYED_OFFICE
    }

    /**
     * Default constructor.
     */
    public OfficeFloorModel() {
    }

    /**
     * Convenience constructor.
     */
    public OfficeFloorModel(
      OfficeFloorSupplierModel[] officeFloorSupplier
    , OfficeFloorManagedObjectSourceModel[] officeFloorManagedObjectSource
    , OfficeFloorInputManagedObjectModel[] officeFloorInputManagedObject
    , OfficeFloorManagedObjectModel[] officeFloorManagedObject
    , OfficeFloorTeamModel[] officeFloorTeam
    , DeployedOfficeModel[] deployedOffice
    ) {
        if (officeFloorSupplier != null) {
            for (OfficeFloorSupplierModel model : officeFloorSupplier) {
                this.officeFloorSupplier.add(model);
            }
        }
        if (officeFloorManagedObjectSource != null) {
            for (OfficeFloorManagedObjectSourceModel model : officeFloorManagedObjectSource) {
                this.officeFloorManagedObjectSource.add(model);
            }
        }
        if (officeFloorInputManagedObject != null) {
            for (OfficeFloorInputManagedObjectModel model : officeFloorInputManagedObject) {
                this.officeFloorInputManagedObject.add(model);
            }
        }
        if (officeFloorManagedObject != null) {
            for (OfficeFloorManagedObjectModel model : officeFloorManagedObject) {
                this.officeFloorManagedObject.add(model);
            }
        }
        if (officeFloorTeam != null) {
            for (OfficeFloorTeamModel model : officeFloorTeam) {
                this.officeFloorTeam.add(model);
            }
        }
        if (deployedOffice != null) {
            for (DeployedOfficeModel model : deployedOffice) {
                this.deployedOffice.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public OfficeFloorModel(
      OfficeFloorSupplierModel[] officeFloorSupplier
    , OfficeFloorManagedObjectSourceModel[] officeFloorManagedObjectSource
    , OfficeFloorInputManagedObjectModel[] officeFloorInputManagedObject
    , OfficeFloorManagedObjectModel[] officeFloorManagedObject
    , OfficeFloorTeamModel[] officeFloorTeam
    , DeployedOfficeModel[] deployedOffice
    , int x
    , int y
    ) {
        if (officeFloorSupplier != null) {
            for (OfficeFloorSupplierModel model : officeFloorSupplier) {
                this.officeFloorSupplier.add(model);
            }
        }
        if (officeFloorManagedObjectSource != null) {
            for (OfficeFloorManagedObjectSourceModel model : officeFloorManagedObjectSource) {
                this.officeFloorManagedObjectSource.add(model);
            }
        }
        if (officeFloorInputManagedObject != null) {
            for (OfficeFloorInputManagedObjectModel model : officeFloorInputManagedObject) {
                this.officeFloorInputManagedObject.add(model);
            }
        }
        if (officeFloorManagedObject != null) {
            for (OfficeFloorManagedObjectModel model : officeFloorManagedObject) {
                this.officeFloorManagedObject.add(model);
            }
        }
        if (officeFloorTeam != null) {
            for (OfficeFloorTeamModel model : officeFloorTeam) {
                this.officeFloorTeam.add(model);
            }
        }
        if (deployedOffice != null) {
            for (DeployedOfficeModel model : deployedOffice) {
                this.deployedOffice.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }


    /**
     * Office floor supplier.
     */
    private List<OfficeFloorSupplierModel> officeFloorSupplier = new LinkedList<OfficeFloorSupplierModel>();

    public List<OfficeFloorSupplierModel> getOfficeFloorSuppliers() {
        return this.officeFloorSupplier;
    }

    public void addOfficeFloorSupplier(OfficeFloorSupplierModel officeFloorSupplier) {
        this.addItemToList(officeFloorSupplier, this.officeFloorSupplier, OfficeFloorEvent.ADD_OFFICE_FLOOR_SUPPLIER);
    }

    public void removeOfficeFloorSupplier(OfficeFloorSupplierModel officeFloorSupplier) {
        this.removeItemFromList(officeFloorSupplier, this.officeFloorSupplier, OfficeFloorEvent.REMOVE_OFFICE_FLOOR_SUPPLIER);
    }

    /**
     * Office floor managed object source.
     */
    private List<OfficeFloorManagedObjectSourceModel> officeFloorManagedObjectSource = new LinkedList<OfficeFloorManagedObjectSourceModel>();

    public List<OfficeFloorManagedObjectSourceModel> getOfficeFloorManagedObjectSources() {
        return this.officeFloorManagedObjectSource;
    }

    public void addOfficeFloorManagedObjectSource(OfficeFloorManagedObjectSourceModel officeFloorManagedObjectSource) {
        this.addItemToList(officeFloorManagedObjectSource, this.officeFloorManagedObjectSource, OfficeFloorEvent.ADD_OFFICE_FLOOR_MANAGED_OBJECT_SOURCE);
    }

    public void removeOfficeFloorManagedObjectSource(OfficeFloorManagedObjectSourceModel officeFloorManagedObjectSource) {
        this.removeItemFromList(officeFloorManagedObjectSource, this.officeFloorManagedObjectSource, OfficeFloorEvent.REMOVE_OFFICE_FLOOR_MANAGED_OBJECT_SOURCE);
    }

    /**
     * Office floor input managed object.
     */
    private List<OfficeFloorInputManagedObjectModel> officeFloorInputManagedObject = new LinkedList<OfficeFloorInputManagedObjectModel>();

    public List<OfficeFloorInputManagedObjectModel> getOfficeFloorInputManagedObjects() {
        return this.officeFloorInputManagedObject;
    }

    public void addOfficeFloorInputManagedObject(OfficeFloorInputManagedObjectModel officeFloorInputManagedObject) {
        this.addItemToList(officeFloorInputManagedObject, this.officeFloorInputManagedObject, OfficeFloorEvent.ADD_OFFICE_FLOOR_INPUT_MANAGED_OBJECT);
    }

    public void removeOfficeFloorInputManagedObject(OfficeFloorInputManagedObjectModel officeFloorInputManagedObject) {
        this.removeItemFromList(officeFloorInputManagedObject, this.officeFloorInputManagedObject, OfficeFloorEvent.REMOVE_OFFICE_FLOOR_INPUT_MANAGED_OBJECT);
    }

    /**
     * Office floor managed object.
     */
    private List<OfficeFloorManagedObjectModel> officeFloorManagedObject = new LinkedList<OfficeFloorManagedObjectModel>();

    public List<OfficeFloorManagedObjectModel> getOfficeFloorManagedObjects() {
        return this.officeFloorManagedObject;
    }

    public void addOfficeFloorManagedObject(OfficeFloorManagedObjectModel officeFloorManagedObject) {
        this.addItemToList(officeFloorManagedObject, this.officeFloorManagedObject, OfficeFloorEvent.ADD_OFFICE_FLOOR_MANAGED_OBJECT);
    }

    public void removeOfficeFloorManagedObject(OfficeFloorManagedObjectModel officeFloorManagedObject) {
        this.removeItemFromList(officeFloorManagedObject, this.officeFloorManagedObject, OfficeFloorEvent.REMOVE_OFFICE_FLOOR_MANAGED_OBJECT);
    }

    /**
     * Office floor team.
     */
    private List<OfficeFloorTeamModel> officeFloorTeam = new LinkedList<OfficeFloorTeamModel>();

    public List<OfficeFloorTeamModel> getOfficeFloorTeams() {
        return this.officeFloorTeam;
    }

    public void addOfficeFloorTeam(OfficeFloorTeamModel officeFloorTeam) {
        this.addItemToList(officeFloorTeam, this.officeFloorTeam, OfficeFloorEvent.ADD_OFFICE_FLOOR_TEAM);
    }

    public void removeOfficeFloorTeam(OfficeFloorTeamModel officeFloorTeam) {
        this.removeItemFromList(officeFloorTeam, this.officeFloorTeam, OfficeFloorEvent.REMOVE_OFFICE_FLOOR_TEAM);
    }

    /**
     * Deployed office.
     */
    private List<DeployedOfficeModel> deployedOffice = new LinkedList<DeployedOfficeModel>();

    public List<DeployedOfficeModel> getDeployedOffices() {
        return this.deployedOffice;
    }

    public void addDeployedOffice(DeployedOfficeModel deployedOffice) {
        this.addItemToList(deployedOffice, this.deployedOffice, OfficeFloorEvent.ADD_DEPLOYED_OFFICE);
    }

    public void removeDeployedOffice(DeployedOfficeModel deployedOffice) {
        this.removeItemFromList(deployedOffice, this.deployedOffice, OfficeFloorEvent.REMOVE_DEPLOYED_OFFICE);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<OfficeFloorModel> removeConnections() {
        RemoveConnectionsAction<OfficeFloorModel> _action = new RemoveConnectionsAction<OfficeFloorModel>(this);
        return _action;
    }
}
