/*
 * 
 */
package net.officefloor.model.officefloor;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class OfficeFloorSupplierModel extends AbstractModel implements ItemModel<OfficeFloorSupplierModel> {

    public static enum OfficeFloorSupplierEvent {
     CHANGE_OFFICE_FLOOR_SUPPLIER_NAME, CHANGE_SUPPLIER_SOURCE_CLASS_NAME, ADD_PROPERTY, REMOVE_PROPERTY, ADD_OFFICE_FLOOR_MANAGED_OBJECT_SOURCE, REMOVE_OFFICE_FLOOR_MANAGED_OBJECT_SOURCE
    }

    /**
     * Default constructor.
     */
    public OfficeFloorSupplierModel() {
    }

    /**
     * Convenience constructor for new non-linked instance.
     */
    public OfficeFloorSupplierModel(
      String officeFloorSupplierName
    , String supplierSourceClassName
    ) {
        this.officeFloorSupplierName = officeFloorSupplierName;
        this.supplierSourceClassName = supplierSourceClassName;
    }

    /**
     * Convenience constructor.
     */
    public OfficeFloorSupplierModel(
      String officeFloorSupplierName
    , String supplierSourceClassName
    , PropertyModel[] property
    , OfficeFloorManagedObjectSourceToOfficeFloorSupplierModel[] officeFloorManagedObjectSource
    ) {
        this.officeFloorSupplierName = officeFloorSupplierName;
        this.supplierSourceClassName = supplierSourceClassName;
        if (property != null) {
            for (PropertyModel model : property) {
                this.property.add(model);
            }
        }
        if (officeFloorManagedObjectSource != null) {
            for (OfficeFloorManagedObjectSourceToOfficeFloorSupplierModel model : officeFloorManagedObjectSource) {
                this.officeFloorManagedObjectSource.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public OfficeFloorSupplierModel(
      String officeFloorSupplierName
    , String supplierSourceClassName
    , PropertyModel[] property
    , OfficeFloorManagedObjectSourceToOfficeFloorSupplierModel[] officeFloorManagedObjectSource
    , int x
    , int y
    ) {
        this.officeFloorSupplierName = officeFloorSupplierName;
        this.supplierSourceClassName = supplierSourceClassName;
        if (property != null) {
            for (PropertyModel model : property) {
                this.property.add(model);
            }
        }
        if (officeFloorManagedObjectSource != null) {
            for (OfficeFloorManagedObjectSourceToOfficeFloorSupplierModel model : officeFloorManagedObjectSource) {
                this.officeFloorManagedObjectSource.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }

    /**
     * Office floor supplier name.
     */
    private String officeFloorSupplierName;

    public String getOfficeFloorSupplierName() {
        return this.officeFloorSupplierName;
    }

    public void setOfficeFloorSupplierName(String officeFloorSupplierName) {
        String oldValue = this.officeFloorSupplierName;
        this.officeFloorSupplierName = officeFloorSupplierName;
        this.changeField(oldValue, this.officeFloorSupplierName, OfficeFloorSupplierEvent.CHANGE_OFFICE_FLOOR_SUPPLIER_NAME);
    }

    /**
     * Supplier source class name.
     */
    private String supplierSourceClassName;

    public String getSupplierSourceClassName() {
        return this.supplierSourceClassName;
    }

    public void setSupplierSourceClassName(String supplierSourceClassName) {
        String oldValue = this.supplierSourceClassName;
        this.supplierSourceClassName = supplierSourceClassName;
        this.changeField(oldValue, this.supplierSourceClassName, OfficeFloorSupplierEvent.CHANGE_SUPPLIER_SOURCE_CLASS_NAME);
    }


    /**
     * Property.
     */
    private List<PropertyModel> property = new LinkedList<PropertyModel>();

    public List<PropertyModel> getProperties() {
        return this.property;
    }

    public void addProperty(PropertyModel property) {
        this.addItemToList(property, this.property, OfficeFloorSupplierEvent.ADD_PROPERTY);
    }

    public void removeProperty(PropertyModel property) {
        this.removeItemFromList(property, this.property, OfficeFloorSupplierEvent.REMOVE_PROPERTY);
    }

    /**
     * Office floor managed object source.
     */
    private List<OfficeFloorManagedObjectSourceToOfficeFloorSupplierModel> officeFloorManagedObjectSource = new LinkedList<OfficeFloorManagedObjectSourceToOfficeFloorSupplierModel>();

    public List<OfficeFloorManagedObjectSourceToOfficeFloorSupplierModel> getOfficeFloorManagedObjectSources() {
        return this.officeFloorManagedObjectSource;
    }

    public void addOfficeFloorManagedObjectSource(OfficeFloorManagedObjectSourceToOfficeFloorSupplierModel officeFloorManagedObjectSource) {
        this.addItemToList(officeFloorManagedObjectSource, this.officeFloorManagedObjectSource, OfficeFloorSupplierEvent.ADD_OFFICE_FLOOR_MANAGED_OBJECT_SOURCE);
    }

    public void removeOfficeFloorManagedObjectSource(OfficeFloorManagedObjectSourceToOfficeFloorSupplierModel officeFloorManagedObjectSource) {
        this.removeItemFromList(officeFloorManagedObjectSource, this.officeFloorManagedObjectSource, OfficeFloorSupplierEvent.REMOVE_OFFICE_FLOOR_MANAGED_OBJECT_SOURCE);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<OfficeFloorSupplierModel> removeConnections() {
        RemoveConnectionsAction<OfficeFloorSupplierModel> _action = new RemoveConnectionsAction<OfficeFloorSupplierModel>(this);
        _action.disconnect(this.officeFloorManagedObjectSource);
        return _action;
    }
}
