/*
 * 
 */
package net.officefloor.model.officefloor;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class OfficeFloorTeamModel extends AbstractModel implements ItemModel<OfficeFloorTeamModel> {

    public static enum OfficeFloorTeamEvent {
     CHANGE_OFFICE_FLOOR_TEAM_NAME, CHANGE_TEAM_SOURCE_CLASS_NAME, ADD_PROPERTY, REMOVE_PROPERTY, ADD_DEPLOYED_OFFICE_TEAM, REMOVE_DEPLOYED_OFFICE_TEAM, ADD_OFFICE_FLOOR_MANAGED_OBJECT_SOURCE_TEAM, REMOVE_OFFICE_FLOOR_MANAGED_OBJECT_SOURCE_TEAM
    }

    /**
     * Default constructor.
     */
    public OfficeFloorTeamModel() {
    }

    /**
     * Convenience constructor for new non-linked instance.
     */
    public OfficeFloorTeamModel(
      String officeFloorTeamName
    , String teamSourceClassName
    ) {
        this.officeFloorTeamName = officeFloorTeamName;
        this.teamSourceClassName = teamSourceClassName;
    }

    /**
     * Convenience constructor.
     */
    public OfficeFloorTeamModel(
      String officeFloorTeamName
    , String teamSourceClassName
    , PropertyModel[] property
    , DeployedOfficeTeamToOfficeFloorTeamModel[] deployedOfficeTeam
    , OfficeFloorManagedObjectSourceTeamToOfficeFloorTeamModel[] officeFloorManagedObjectSourceTeam
    ) {
        this.officeFloorTeamName = officeFloorTeamName;
        this.teamSourceClassName = teamSourceClassName;
        if (property != null) {
            for (PropertyModel model : property) {
                this.property.add(model);
            }
        }
        if (deployedOfficeTeam != null) {
            for (DeployedOfficeTeamToOfficeFloorTeamModel model : deployedOfficeTeam) {
                this.deployedOfficeTeam.add(model);
            }
        }
        if (officeFloorManagedObjectSourceTeam != null) {
            for (OfficeFloorManagedObjectSourceTeamToOfficeFloorTeamModel model : officeFloorManagedObjectSourceTeam) {
                this.officeFloorManagedObjectSourceTeam.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public OfficeFloorTeamModel(
      String officeFloorTeamName
    , String teamSourceClassName
    , PropertyModel[] property
    , DeployedOfficeTeamToOfficeFloorTeamModel[] deployedOfficeTeam
    , OfficeFloorManagedObjectSourceTeamToOfficeFloorTeamModel[] officeFloorManagedObjectSourceTeam
    , int x
    , int y
    ) {
        this.officeFloorTeamName = officeFloorTeamName;
        this.teamSourceClassName = teamSourceClassName;
        if (property != null) {
            for (PropertyModel model : property) {
                this.property.add(model);
            }
        }
        if (deployedOfficeTeam != null) {
            for (DeployedOfficeTeamToOfficeFloorTeamModel model : deployedOfficeTeam) {
                this.deployedOfficeTeam.add(model);
            }
        }
        if (officeFloorManagedObjectSourceTeam != null) {
            for (OfficeFloorManagedObjectSourceTeamToOfficeFloorTeamModel model : officeFloorManagedObjectSourceTeam) {
                this.officeFloorManagedObjectSourceTeam.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }

    /**
     * Office floor team name.
     */
    private String officeFloorTeamName;

    public String getOfficeFloorTeamName() {
        return this.officeFloorTeamName;
    }

    public void setOfficeFloorTeamName(String officeFloorTeamName) {
        String oldValue = this.officeFloorTeamName;
        this.officeFloorTeamName = officeFloorTeamName;
        this.changeField(oldValue, this.officeFloorTeamName, OfficeFloorTeamEvent.CHANGE_OFFICE_FLOOR_TEAM_NAME);
    }

    /**
     * Team source class name.
     */
    private String teamSourceClassName;

    public String getTeamSourceClassName() {
        return this.teamSourceClassName;
    }

    public void setTeamSourceClassName(String teamSourceClassName) {
        String oldValue = this.teamSourceClassName;
        this.teamSourceClassName = teamSourceClassName;
        this.changeField(oldValue, this.teamSourceClassName, OfficeFloorTeamEvent.CHANGE_TEAM_SOURCE_CLASS_NAME);
    }


    /**
     * Property.
     */
    private List<PropertyModel> property = new LinkedList<PropertyModel>();

    public List<PropertyModel> getProperties() {
        return this.property;
    }

    public void addProperty(PropertyModel property) {
        this.addItemToList(property, this.property, OfficeFloorTeamEvent.ADD_PROPERTY);
    }

    public void removeProperty(PropertyModel property) {
        this.removeItemFromList(property, this.property, OfficeFloorTeamEvent.REMOVE_PROPERTY);
    }

    /**
     * Deployed office team.
     */
    private List<DeployedOfficeTeamToOfficeFloorTeamModel> deployedOfficeTeam = new LinkedList<DeployedOfficeTeamToOfficeFloorTeamModel>();

    public List<DeployedOfficeTeamToOfficeFloorTeamModel> getDeployedOfficeTeams() {
        return this.deployedOfficeTeam;
    }

    public void addDeployedOfficeTeam(DeployedOfficeTeamToOfficeFloorTeamModel deployedOfficeTeam) {
        this.addItemToList(deployedOfficeTeam, this.deployedOfficeTeam, OfficeFloorTeamEvent.ADD_DEPLOYED_OFFICE_TEAM);
    }

    public void removeDeployedOfficeTeam(DeployedOfficeTeamToOfficeFloorTeamModel deployedOfficeTeam) {
        this.removeItemFromList(deployedOfficeTeam, this.deployedOfficeTeam, OfficeFloorTeamEvent.REMOVE_DEPLOYED_OFFICE_TEAM);
    }

    /**
     * Office floor managed object source team.
     */
    private List<OfficeFloorManagedObjectSourceTeamToOfficeFloorTeamModel> officeFloorManagedObjectSourceTeam = new LinkedList<OfficeFloorManagedObjectSourceTeamToOfficeFloorTeamModel>();

    public List<OfficeFloorManagedObjectSourceTeamToOfficeFloorTeamModel> getOfficeFloorManagedObjectSourceTeams() {
        return this.officeFloorManagedObjectSourceTeam;
    }

    public void addOfficeFloorManagedObjectSourceTeam(OfficeFloorManagedObjectSourceTeamToOfficeFloorTeamModel officeFloorManagedObjectSourceTeam) {
        this.addItemToList(officeFloorManagedObjectSourceTeam, this.officeFloorManagedObjectSourceTeam, OfficeFloorTeamEvent.ADD_OFFICE_FLOOR_MANAGED_OBJECT_SOURCE_TEAM);
    }

    public void removeOfficeFloorManagedObjectSourceTeam(OfficeFloorManagedObjectSourceTeamToOfficeFloorTeamModel officeFloorManagedObjectSourceTeam) {
        this.removeItemFromList(officeFloorManagedObjectSourceTeam, this.officeFloorManagedObjectSourceTeam, OfficeFloorTeamEvent.REMOVE_OFFICE_FLOOR_MANAGED_OBJECT_SOURCE_TEAM);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<OfficeFloorTeamModel> removeConnections() {
        RemoveConnectionsAction<OfficeFloorTeamModel> _action = new RemoveConnectionsAction<OfficeFloorTeamModel>(this);
        _action.disconnect(this.deployedOfficeTeam);
        _action.disconnect(this.officeFloorManagedObjectSourceTeam);
        return _action;
    }
}
