/*
 * 
 */
package net.officefloor.model.section;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class ExternalFlowModel extends AbstractModel implements ItemModel<ExternalFlowModel> {

    public static enum ExternalFlowEvent {
     CHANGE_EXTERNAL_FLOW_NAME, CHANGE_ARGUMENT_TYPE, ADD_SUB_SECTION_OUTPUT, REMOVE_SUB_SECTION_OUTPUT, ADD_SECTION_MANAGED_OBJECT_SOURCE_FLOW, REMOVE_SECTION_MANAGED_OBJECT_SOURCE_FLOW
    }

    /**
     * Default constructor.
     */
    public ExternalFlowModel() {
    }

    /**
     * Convenience constructor for new non-linked instance.
     */
    public ExternalFlowModel(
      String externalFlowName
    , String argumentType
    ) {
        this.externalFlowName = externalFlowName;
        this.argumentType = argumentType;
    }

    /**
     * Convenience constructor.
     */
    public ExternalFlowModel(
      String externalFlowName
    , String argumentType
    , SubSectionOutputToExternalFlowModel[] subSectionOutput
    , SectionManagedObjectSourceFlowToExternalFlowModel[] sectionManagedObjectSourceFlow
    ) {
        this.externalFlowName = externalFlowName;
        this.argumentType = argumentType;
        if (subSectionOutput != null) {
            for (SubSectionOutputToExternalFlowModel model : subSectionOutput) {
                this.subSectionOutput.add(model);
            }
        }
        if (sectionManagedObjectSourceFlow != null) {
            for (SectionManagedObjectSourceFlowToExternalFlowModel model : sectionManagedObjectSourceFlow) {
                this.sectionManagedObjectSourceFlow.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public ExternalFlowModel(
      String externalFlowName
    , String argumentType
    , SubSectionOutputToExternalFlowModel[] subSectionOutput
    , SectionManagedObjectSourceFlowToExternalFlowModel[] sectionManagedObjectSourceFlow
    , int x
    , int y
    ) {
        this.externalFlowName = externalFlowName;
        this.argumentType = argumentType;
        if (subSectionOutput != null) {
            for (SubSectionOutputToExternalFlowModel model : subSectionOutput) {
                this.subSectionOutput.add(model);
            }
        }
        if (sectionManagedObjectSourceFlow != null) {
            for (SectionManagedObjectSourceFlowToExternalFlowModel model : sectionManagedObjectSourceFlow) {
                this.sectionManagedObjectSourceFlow.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }

    /**
     * External flow name.
     */
    private String externalFlowName;

    public String getExternalFlowName() {
        return this.externalFlowName;
    }

    public void setExternalFlowName(String externalFlowName) {
        String oldValue = this.externalFlowName;
        this.externalFlowName = externalFlowName;
        this.changeField(oldValue, this.externalFlowName, ExternalFlowEvent.CHANGE_EXTERNAL_FLOW_NAME);
    }

    /**
     * Argument type.
     */
    private String argumentType;

    public String getArgumentType() {
        return this.argumentType;
    }

    public void setArgumentType(String argumentType) {
        String oldValue = this.argumentType;
        this.argumentType = argumentType;
        this.changeField(oldValue, this.argumentType, ExternalFlowEvent.CHANGE_ARGUMENT_TYPE);
    }


    /**
     * Sub section output.
     */
    private List<SubSectionOutputToExternalFlowModel> subSectionOutput = new LinkedList<SubSectionOutputToExternalFlowModel>();

    public List<SubSectionOutputToExternalFlowModel> getSubSectionOutputs() {
        return this.subSectionOutput;
    }

    public void addSubSectionOutput(SubSectionOutputToExternalFlowModel subSectionOutput) {
        this.addItemToList(subSectionOutput, this.subSectionOutput, ExternalFlowEvent.ADD_SUB_SECTION_OUTPUT);
    }

    public void removeSubSectionOutput(SubSectionOutputToExternalFlowModel subSectionOutput) {
        this.removeItemFromList(subSectionOutput, this.subSectionOutput, ExternalFlowEvent.REMOVE_SUB_SECTION_OUTPUT);
    }

    /**
     * Section managed object source flow.
     */
    private List<SectionManagedObjectSourceFlowToExternalFlowModel> sectionManagedObjectSourceFlow = new LinkedList<SectionManagedObjectSourceFlowToExternalFlowModel>();

    public List<SectionManagedObjectSourceFlowToExternalFlowModel> getSectionManagedObjectSourceFlows() {
        return this.sectionManagedObjectSourceFlow;
    }

    public void addSectionManagedObjectSourceFlow(SectionManagedObjectSourceFlowToExternalFlowModel sectionManagedObjectSourceFlow) {
        this.addItemToList(sectionManagedObjectSourceFlow, this.sectionManagedObjectSourceFlow, ExternalFlowEvent.ADD_SECTION_MANAGED_OBJECT_SOURCE_FLOW);
    }

    public void removeSectionManagedObjectSourceFlow(SectionManagedObjectSourceFlowToExternalFlowModel sectionManagedObjectSourceFlow) {
        this.removeItemFromList(sectionManagedObjectSourceFlow, this.sectionManagedObjectSourceFlow, ExternalFlowEvent.REMOVE_SECTION_MANAGED_OBJECT_SOURCE_FLOW);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<ExternalFlowModel> removeConnections() {
        RemoveConnectionsAction<ExternalFlowModel> _action = new RemoveConnectionsAction<ExternalFlowModel>(this);
        _action.disconnect(this.subSectionOutput);
        _action.disconnect(this.sectionManagedObjectSourceFlow);
        return _action;
    }
}
