/*
 * 
 */
package net.officefloor.model.section;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class ExternalManagedObjectModel extends AbstractModel implements ItemModel<ExternalManagedObjectModel> {

    public static enum ExternalManagedObjectEvent {
     CHANGE_EXTERNAL_MANAGED_OBJECT_NAME, CHANGE_OBJECT_TYPE, ADD_SUB_SECTION_OBJECT, REMOVE_SUB_SECTION_OBJECT, ADD_DEPENDENT_SECTION_MANAGED_OBJECT, REMOVE_DEPENDENT_SECTION_MANAGED_OBJECT
    }

    /**
     * Default constructor.
     */
    public ExternalManagedObjectModel() {
    }

    /**
     * Convenience constructor for new non-linked instance.
     */
    public ExternalManagedObjectModel(
      String externalManagedObjectName
    , String objectType
    ) {
        this.externalManagedObjectName = externalManagedObjectName;
        this.objectType = objectType;
    }

    /**
     * Convenience constructor.
     */
    public ExternalManagedObjectModel(
      String externalManagedObjectName
    , String objectType
    , SubSectionObjectToExternalManagedObjectModel[] subSectionObject
    , SectionManagedObjectDependencyToExternalManagedObjectModel[] dependentSectionManagedObject
    ) {
        this.externalManagedObjectName = externalManagedObjectName;
        this.objectType = objectType;
        if (subSectionObject != null) {
            for (SubSectionObjectToExternalManagedObjectModel model : subSectionObject) {
                this.subSectionObject.add(model);
            }
        }
        if (dependentSectionManagedObject != null) {
            for (SectionManagedObjectDependencyToExternalManagedObjectModel model : dependentSectionManagedObject) {
                this.dependentSectionManagedObject.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public ExternalManagedObjectModel(
      String externalManagedObjectName
    , String objectType
    , SubSectionObjectToExternalManagedObjectModel[] subSectionObject
    , SectionManagedObjectDependencyToExternalManagedObjectModel[] dependentSectionManagedObject
    , int x
    , int y
    ) {
        this.externalManagedObjectName = externalManagedObjectName;
        this.objectType = objectType;
        if (subSectionObject != null) {
            for (SubSectionObjectToExternalManagedObjectModel model : subSectionObject) {
                this.subSectionObject.add(model);
            }
        }
        if (dependentSectionManagedObject != null) {
            for (SectionManagedObjectDependencyToExternalManagedObjectModel model : dependentSectionManagedObject) {
                this.dependentSectionManagedObject.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }

    /**
     * External managed object name.
     */
    private String externalManagedObjectName;

    public String getExternalManagedObjectName() {
        return this.externalManagedObjectName;
    }

    public void setExternalManagedObjectName(String externalManagedObjectName) {
        String oldValue = this.externalManagedObjectName;
        this.externalManagedObjectName = externalManagedObjectName;
        this.changeField(oldValue, this.externalManagedObjectName, ExternalManagedObjectEvent.CHANGE_EXTERNAL_MANAGED_OBJECT_NAME);
    }

    /**
     * Object type.
     */
    private String objectType;

    public String getObjectType() {
        return this.objectType;
    }

    public void setObjectType(String objectType) {
        String oldValue = this.objectType;
        this.objectType = objectType;
        this.changeField(oldValue, this.objectType, ExternalManagedObjectEvent.CHANGE_OBJECT_TYPE);
    }


    /**
     * Sub section object.
     */
    private List<SubSectionObjectToExternalManagedObjectModel> subSectionObject = new LinkedList<SubSectionObjectToExternalManagedObjectModel>();

    public List<SubSectionObjectToExternalManagedObjectModel> getSubSectionObjects() {
        return this.subSectionObject;
    }

    public void addSubSectionObject(SubSectionObjectToExternalManagedObjectModel subSectionObject) {
        this.addItemToList(subSectionObject, this.subSectionObject, ExternalManagedObjectEvent.ADD_SUB_SECTION_OBJECT);
    }

    public void removeSubSectionObject(SubSectionObjectToExternalManagedObjectModel subSectionObject) {
        this.removeItemFromList(subSectionObject, this.subSectionObject, ExternalManagedObjectEvent.REMOVE_SUB_SECTION_OBJECT);
    }

    /**
     * Dependent section managed object.
     */
    private List<SectionManagedObjectDependencyToExternalManagedObjectModel> dependentSectionManagedObject = new LinkedList<SectionManagedObjectDependencyToExternalManagedObjectModel>();

    public List<SectionManagedObjectDependencyToExternalManagedObjectModel> getDependentSectionManagedObjects() {
        return this.dependentSectionManagedObject;
    }

    public void addDependentSectionManagedObject(SectionManagedObjectDependencyToExternalManagedObjectModel dependentSectionManagedObject) {
        this.addItemToList(dependentSectionManagedObject, this.dependentSectionManagedObject, ExternalManagedObjectEvent.ADD_DEPENDENT_SECTION_MANAGED_OBJECT);
    }

    public void removeDependentSectionManagedObject(SectionManagedObjectDependencyToExternalManagedObjectModel dependentSectionManagedObject) {
        this.removeItemFromList(dependentSectionManagedObject, this.dependentSectionManagedObject, ExternalManagedObjectEvent.REMOVE_DEPENDENT_SECTION_MANAGED_OBJECT);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<ExternalManagedObjectModel> removeConnections() {
        RemoveConnectionsAction<ExternalManagedObjectModel> _action = new RemoveConnectionsAction<ExternalManagedObjectModel>(this);
        _action.disconnect(this.subSectionObject);
        _action.disconnect(this.dependentSectionManagedObject);
        return _action;
    }
}
