/*
 * 
 */
package net.officefloor.model.section;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class SectionManagedObjectModel extends AbstractModel implements ItemModel<SectionManagedObjectModel> {

    public static enum SectionManagedObjectEvent {
     CHANGE_SECTION_MANAGED_OBJECT_NAME, CHANGE_MANAGED_OBJECT_SCOPE, CHANGE_SECTION_MANAGED_OBJECT_SOURCE, ADD_SUB_SECTION_OBJECT, REMOVE_SUB_SECTION_OBJECT, ADD_SECTION_MANAGED_OBJECT_DEPENDENCY, REMOVE_SECTION_MANAGED_OBJECT_DEPENDENCY, ADD_DEPENDENT_SECTION_MANAGED_OBJECT, REMOVE_DEPENDENT_SECTION_MANAGED_OBJECT
    }

    /**
     * Default constructor.
     */
    public SectionManagedObjectModel() {
    }

    /**
     * Convenience constructor for new non-linked instance.
     */
    public SectionManagedObjectModel(
      String sectionManagedObjectName
    , String managedObjectScope
    ) {
        this.sectionManagedObjectName = sectionManagedObjectName;
        this.managedObjectScope = managedObjectScope;
    }

    /**
     * Convenience constructor.
     */
    public SectionManagedObjectModel(
      String sectionManagedObjectName
    , String managedObjectScope
    , SectionManagedObjectToSectionManagedObjectSourceModel sectionManagedObjectSource
    , SubSectionObjectToSectionManagedObjectModel[] subSectionObject
    , SectionManagedObjectDependencyModel[] sectionManagedObjectDependency
    , SectionManagedObjectDependencyToSectionManagedObjectModel[] dependentSectionManagedObject
    ) {
        this.sectionManagedObjectName = sectionManagedObjectName;
        this.managedObjectScope = managedObjectScope;
        this.sectionManagedObjectSource = sectionManagedObjectSource;
        if (subSectionObject != null) {
            for (SubSectionObjectToSectionManagedObjectModel model : subSectionObject) {
                this.subSectionObject.add(model);
            }
        }
        if (sectionManagedObjectDependency != null) {
            for (SectionManagedObjectDependencyModel model : sectionManagedObjectDependency) {
                this.sectionManagedObjectDependency.add(model);
            }
        }
        if (dependentSectionManagedObject != null) {
            for (SectionManagedObjectDependencyToSectionManagedObjectModel model : dependentSectionManagedObject) {
                this.dependentSectionManagedObject.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public SectionManagedObjectModel(
      String sectionManagedObjectName
    , String managedObjectScope
    , SectionManagedObjectToSectionManagedObjectSourceModel sectionManagedObjectSource
    , SubSectionObjectToSectionManagedObjectModel[] subSectionObject
    , SectionManagedObjectDependencyModel[] sectionManagedObjectDependency
    , SectionManagedObjectDependencyToSectionManagedObjectModel[] dependentSectionManagedObject
    , int x
    , int y
    ) {
        this.sectionManagedObjectName = sectionManagedObjectName;
        this.managedObjectScope = managedObjectScope;
        this.sectionManagedObjectSource = sectionManagedObjectSource;
        if (subSectionObject != null) {
            for (SubSectionObjectToSectionManagedObjectModel model : subSectionObject) {
                this.subSectionObject.add(model);
            }
        }
        if (sectionManagedObjectDependency != null) {
            for (SectionManagedObjectDependencyModel model : sectionManagedObjectDependency) {
                this.sectionManagedObjectDependency.add(model);
            }
        }
        if (dependentSectionManagedObject != null) {
            for (SectionManagedObjectDependencyToSectionManagedObjectModel model : dependentSectionManagedObject) {
                this.dependentSectionManagedObject.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }

    /**
     * Section managed object name.
     */
    private String sectionManagedObjectName;

    public String getSectionManagedObjectName() {
        return this.sectionManagedObjectName;
    }

    public void setSectionManagedObjectName(String sectionManagedObjectName) {
        String oldValue = this.sectionManagedObjectName;
        this.sectionManagedObjectName = sectionManagedObjectName;
        this.changeField(oldValue, this.sectionManagedObjectName, SectionManagedObjectEvent.CHANGE_SECTION_MANAGED_OBJECT_NAME);
    }

    /**
     * Managed object scope.
     */
    private String managedObjectScope;

    public String getManagedObjectScope() {
        return this.managedObjectScope;
    }

    public void setManagedObjectScope(String managedObjectScope) {
        String oldValue = this.managedObjectScope;
        this.managedObjectScope = managedObjectScope;
        this.changeField(oldValue, this.managedObjectScope, SectionManagedObjectEvent.CHANGE_MANAGED_OBJECT_SCOPE);
    }

    /**
     * Section managed object source.
     */
    private SectionManagedObjectToSectionManagedObjectSourceModel sectionManagedObjectSource;

    public SectionManagedObjectToSectionManagedObjectSourceModel getSectionManagedObjectSource() {
        return this.sectionManagedObjectSource;
    }

    public void setSectionManagedObjectSource(SectionManagedObjectToSectionManagedObjectSourceModel sectionManagedObjectSource) {
        SectionManagedObjectToSectionManagedObjectSourceModel oldValue = this.sectionManagedObjectSource;
        this.sectionManagedObjectSource = sectionManagedObjectSource;
        this.changeField(oldValue, this.sectionManagedObjectSource, SectionManagedObjectEvent.CHANGE_SECTION_MANAGED_OBJECT_SOURCE);
    }


    /**
     * Sub section object.
     */
    private List<SubSectionObjectToSectionManagedObjectModel> subSectionObject = new LinkedList<SubSectionObjectToSectionManagedObjectModel>();

    public List<SubSectionObjectToSectionManagedObjectModel> getSubSectionObjects() {
        return this.subSectionObject;
    }

    public void addSubSectionObject(SubSectionObjectToSectionManagedObjectModel subSectionObject) {
        this.addItemToList(subSectionObject, this.subSectionObject, SectionManagedObjectEvent.ADD_SUB_SECTION_OBJECT);
    }

    public void removeSubSectionObject(SubSectionObjectToSectionManagedObjectModel subSectionObject) {
        this.removeItemFromList(subSectionObject, this.subSectionObject, SectionManagedObjectEvent.REMOVE_SUB_SECTION_OBJECT);
    }

    /**
     * Section managed object dependency.
     */
    private List<SectionManagedObjectDependencyModel> sectionManagedObjectDependency = new LinkedList<SectionManagedObjectDependencyModel>();

    public List<SectionManagedObjectDependencyModel> getSectionManagedObjectDependencies() {
        return this.sectionManagedObjectDependency;
    }

    public void addSectionManagedObjectDependency(SectionManagedObjectDependencyModel sectionManagedObjectDependency) {
        this.addItemToList(sectionManagedObjectDependency, this.sectionManagedObjectDependency, SectionManagedObjectEvent.ADD_SECTION_MANAGED_OBJECT_DEPENDENCY);
    }

    public void removeSectionManagedObjectDependency(SectionManagedObjectDependencyModel sectionManagedObjectDependency) {
        this.removeItemFromList(sectionManagedObjectDependency, this.sectionManagedObjectDependency, SectionManagedObjectEvent.REMOVE_SECTION_MANAGED_OBJECT_DEPENDENCY);
    }

    /**
     * Dependent section managed object.
     */
    private List<SectionManagedObjectDependencyToSectionManagedObjectModel> dependentSectionManagedObject = new LinkedList<SectionManagedObjectDependencyToSectionManagedObjectModel>();

    public List<SectionManagedObjectDependencyToSectionManagedObjectModel> getDependentSectionManagedObjects() {
        return this.dependentSectionManagedObject;
    }

    public void addDependentSectionManagedObject(SectionManagedObjectDependencyToSectionManagedObjectModel dependentSectionManagedObject) {
        this.addItemToList(dependentSectionManagedObject, this.dependentSectionManagedObject, SectionManagedObjectEvent.ADD_DEPENDENT_SECTION_MANAGED_OBJECT);
    }

    public void removeDependentSectionManagedObject(SectionManagedObjectDependencyToSectionManagedObjectModel dependentSectionManagedObject) {
        this.removeItemFromList(dependentSectionManagedObject, this.dependentSectionManagedObject, SectionManagedObjectEvent.REMOVE_DEPENDENT_SECTION_MANAGED_OBJECT);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<SectionManagedObjectModel> removeConnections() {
        RemoveConnectionsAction<SectionManagedObjectModel> _action = new RemoveConnectionsAction<SectionManagedObjectModel>(this);
        _action.disconnect(this.sectionManagedObjectSource);
        _action.disconnect(this.subSectionObject);
        _action.disconnect(this.dependentSectionManagedObject);
        return _action;
    }
}
