/*
 * 
 */
package net.officefloor.model.section;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class SectionManagedObjectSourceModel extends AbstractModel implements ItemModel<SectionManagedObjectSourceModel> {

    public static enum SectionManagedObjectSourceEvent {
     CHANGE_SECTION_MANAGED_OBJECT_SOURCE_NAME, CHANGE_MANAGED_OBJECT_SOURCE_CLASS_NAME, CHANGE_OBJECT_TYPE, CHANGE_TIMEOUT, ADD_PROPERTY, REMOVE_PROPERTY, ADD_SECTION_MANAGED_OBJECT, REMOVE_SECTION_MANAGED_OBJECT, ADD_SECTION_MANAGED_OBJECT_SOURCE_FLOW, REMOVE_SECTION_MANAGED_OBJECT_SOURCE_FLOW
    }

    /**
     * Default constructor.
     */
    public SectionManagedObjectSourceModel() {
    }

    /**
     * Convenience constructor for new non-linked instance.
     */
    public SectionManagedObjectSourceModel(
      String sectionManagedObjectSourceName
    , String managedObjectSourceClassName
    , String objectType
    , String timeout
    ) {
        this.sectionManagedObjectSourceName = sectionManagedObjectSourceName;
        this.managedObjectSourceClassName = managedObjectSourceClassName;
        this.objectType = objectType;
        this.timeout = timeout;
    }

    /**
     * Convenience constructor.
     */
    public SectionManagedObjectSourceModel(
      String sectionManagedObjectSourceName
    , String managedObjectSourceClassName
    , String objectType
    , String timeout
    , PropertyModel[] property
    , SectionManagedObjectToSectionManagedObjectSourceModel[] sectionManagedObject
    , SectionManagedObjectSourceFlowModel[] sectionManagedObjectSourceFlow
    ) {
        this.sectionManagedObjectSourceName = sectionManagedObjectSourceName;
        this.managedObjectSourceClassName = managedObjectSourceClassName;
        this.objectType = objectType;
        this.timeout = timeout;
        if (property != null) {
            for (PropertyModel model : property) {
                this.property.add(model);
            }
        }
        if (sectionManagedObject != null) {
            for (SectionManagedObjectToSectionManagedObjectSourceModel model : sectionManagedObject) {
                this.sectionManagedObject.add(model);
            }
        }
        if (sectionManagedObjectSourceFlow != null) {
            for (SectionManagedObjectSourceFlowModel model : sectionManagedObjectSourceFlow) {
                this.sectionManagedObjectSourceFlow.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public SectionManagedObjectSourceModel(
      String sectionManagedObjectSourceName
    , String managedObjectSourceClassName
    , String objectType
    , String timeout
    , PropertyModel[] property
    , SectionManagedObjectToSectionManagedObjectSourceModel[] sectionManagedObject
    , SectionManagedObjectSourceFlowModel[] sectionManagedObjectSourceFlow
    , int x
    , int y
    ) {
        this.sectionManagedObjectSourceName = sectionManagedObjectSourceName;
        this.managedObjectSourceClassName = managedObjectSourceClassName;
        this.objectType = objectType;
        this.timeout = timeout;
        if (property != null) {
            for (PropertyModel model : property) {
                this.property.add(model);
            }
        }
        if (sectionManagedObject != null) {
            for (SectionManagedObjectToSectionManagedObjectSourceModel model : sectionManagedObject) {
                this.sectionManagedObject.add(model);
            }
        }
        if (sectionManagedObjectSourceFlow != null) {
            for (SectionManagedObjectSourceFlowModel model : sectionManagedObjectSourceFlow) {
                this.sectionManagedObjectSourceFlow.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }

    /**
     * Section managed object source name.
     */
    private String sectionManagedObjectSourceName;

    public String getSectionManagedObjectSourceName() {
        return this.sectionManagedObjectSourceName;
    }

    public void setSectionManagedObjectSourceName(String sectionManagedObjectSourceName) {
        String oldValue = this.sectionManagedObjectSourceName;
        this.sectionManagedObjectSourceName = sectionManagedObjectSourceName;
        this.changeField(oldValue, this.sectionManagedObjectSourceName, SectionManagedObjectSourceEvent.CHANGE_SECTION_MANAGED_OBJECT_SOURCE_NAME);
    }

    /**
     * Managed object source class name.
     */
    private String managedObjectSourceClassName;

    public String getManagedObjectSourceClassName() {
        return this.managedObjectSourceClassName;
    }

    public void setManagedObjectSourceClassName(String managedObjectSourceClassName) {
        String oldValue = this.managedObjectSourceClassName;
        this.managedObjectSourceClassName = managedObjectSourceClassName;
        this.changeField(oldValue, this.managedObjectSourceClassName, SectionManagedObjectSourceEvent.CHANGE_MANAGED_OBJECT_SOURCE_CLASS_NAME);
    }

    /**
     * Object type.
     */
    private String objectType;

    public String getObjectType() {
        return this.objectType;
    }

    public void setObjectType(String objectType) {
        String oldValue = this.objectType;
        this.objectType = objectType;
        this.changeField(oldValue, this.objectType, SectionManagedObjectSourceEvent.CHANGE_OBJECT_TYPE);
    }

    /**
     * Timeout.
     */
    private String timeout;

    public String getTimeout() {
        return this.timeout;
    }

    public void setTimeout(String timeout) {
        String oldValue = this.timeout;
        this.timeout = timeout;
        this.changeField(oldValue, this.timeout, SectionManagedObjectSourceEvent.CHANGE_TIMEOUT);
    }


    /**
     * Property.
     */
    private List<PropertyModel> property = new LinkedList<PropertyModel>();

    public List<PropertyModel> getProperties() {
        return this.property;
    }

    public void addProperty(PropertyModel property) {
        this.addItemToList(property, this.property, SectionManagedObjectSourceEvent.ADD_PROPERTY);
    }

    public void removeProperty(PropertyModel property) {
        this.removeItemFromList(property, this.property, SectionManagedObjectSourceEvent.REMOVE_PROPERTY);
    }

    /**
     * Section managed object.
     */
    private List<SectionManagedObjectToSectionManagedObjectSourceModel> sectionManagedObject = new LinkedList<SectionManagedObjectToSectionManagedObjectSourceModel>();

    public List<SectionManagedObjectToSectionManagedObjectSourceModel> getSectionManagedObjects() {
        return this.sectionManagedObject;
    }

    public void addSectionManagedObject(SectionManagedObjectToSectionManagedObjectSourceModel sectionManagedObject) {
        this.addItemToList(sectionManagedObject, this.sectionManagedObject, SectionManagedObjectSourceEvent.ADD_SECTION_MANAGED_OBJECT);
    }

    public void removeSectionManagedObject(SectionManagedObjectToSectionManagedObjectSourceModel sectionManagedObject) {
        this.removeItemFromList(sectionManagedObject, this.sectionManagedObject, SectionManagedObjectSourceEvent.REMOVE_SECTION_MANAGED_OBJECT);
    }

    /**
     * Section managed object source flow.
     */
    private List<SectionManagedObjectSourceFlowModel> sectionManagedObjectSourceFlow = new LinkedList<SectionManagedObjectSourceFlowModel>();

    public List<SectionManagedObjectSourceFlowModel> getSectionManagedObjectSourceFlows() {
        return this.sectionManagedObjectSourceFlow;
    }

    public void addSectionManagedObjectSourceFlow(SectionManagedObjectSourceFlowModel sectionManagedObjectSourceFlow) {
        this.addItemToList(sectionManagedObjectSourceFlow, this.sectionManagedObjectSourceFlow, SectionManagedObjectSourceEvent.ADD_SECTION_MANAGED_OBJECT_SOURCE_FLOW);
    }

    public void removeSectionManagedObjectSourceFlow(SectionManagedObjectSourceFlowModel sectionManagedObjectSourceFlow) {
        this.removeItemFromList(sectionManagedObjectSourceFlow, this.sectionManagedObjectSourceFlow, SectionManagedObjectSourceEvent.REMOVE_SECTION_MANAGED_OBJECT_SOURCE_FLOW);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<SectionManagedObjectSourceModel> removeConnections() {
        RemoveConnectionsAction<SectionManagedObjectSourceModel> _action = new RemoveConnectionsAction<SectionManagedObjectSourceModel>(this);
        _action.disconnect(this.sectionManagedObject);
        return _action;
    }
}
