/*
 * 
 */
package net.officefloor.model.section;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class SectionModel extends AbstractModel implements ItemModel<SectionModel> {

    public static enum SectionEvent {
     ADD_EXTERNAL_MANAGED_OBJECT, REMOVE_EXTERNAL_MANAGED_OBJECT, ADD_SECTION_MANAGED_OBJECT_SOURCE, REMOVE_SECTION_MANAGED_OBJECT_SOURCE, ADD_SECTION_MANAGED_OBJECT, REMOVE_SECTION_MANAGED_OBJECT, ADD_EXTERNAL_FLOW, REMOVE_EXTERNAL_FLOW, ADD_SUB_SECTION, REMOVE_SUB_SECTION
    }

    /**
     * Default constructor.
     */
    public SectionModel() {
    }

    /**
     * Convenience constructor.
     */
    public SectionModel(
      ExternalManagedObjectModel[] externalManagedObject
    , SectionManagedObjectSourceModel[] sectionManagedObjectSource
    , SectionManagedObjectModel[] sectionManagedObject
    , ExternalFlowModel[] externalFlow
    , SubSectionModel[] subSection
    ) {
        if (externalManagedObject != null) {
            for (ExternalManagedObjectModel model : externalManagedObject) {
                this.externalManagedObject.add(model);
            }
        }
        if (sectionManagedObjectSource != null) {
            for (SectionManagedObjectSourceModel model : sectionManagedObjectSource) {
                this.sectionManagedObjectSource.add(model);
            }
        }
        if (sectionManagedObject != null) {
            for (SectionManagedObjectModel model : sectionManagedObject) {
                this.sectionManagedObject.add(model);
            }
        }
        if (externalFlow != null) {
            for (ExternalFlowModel model : externalFlow) {
                this.externalFlow.add(model);
            }
        }
        if (subSection != null) {
            for (SubSectionModel model : subSection) {
                this.subSection.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public SectionModel(
      ExternalManagedObjectModel[] externalManagedObject
    , SectionManagedObjectSourceModel[] sectionManagedObjectSource
    , SectionManagedObjectModel[] sectionManagedObject
    , ExternalFlowModel[] externalFlow
    , SubSectionModel[] subSection
    , int x
    , int y
    ) {
        if (externalManagedObject != null) {
            for (ExternalManagedObjectModel model : externalManagedObject) {
                this.externalManagedObject.add(model);
            }
        }
        if (sectionManagedObjectSource != null) {
            for (SectionManagedObjectSourceModel model : sectionManagedObjectSource) {
                this.sectionManagedObjectSource.add(model);
            }
        }
        if (sectionManagedObject != null) {
            for (SectionManagedObjectModel model : sectionManagedObject) {
                this.sectionManagedObject.add(model);
            }
        }
        if (externalFlow != null) {
            for (ExternalFlowModel model : externalFlow) {
                this.externalFlow.add(model);
            }
        }
        if (subSection != null) {
            for (SubSectionModel model : subSection) {
                this.subSection.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }


    /**
     * External managed object.
     */
    private List<ExternalManagedObjectModel> externalManagedObject = new LinkedList<ExternalManagedObjectModel>();

    public List<ExternalManagedObjectModel> getExternalManagedObjects() {
        return this.externalManagedObject;
    }

    public void addExternalManagedObject(ExternalManagedObjectModel externalManagedObject) {
        this.addItemToList(externalManagedObject, this.externalManagedObject, SectionEvent.ADD_EXTERNAL_MANAGED_OBJECT);
    }

    public void removeExternalManagedObject(ExternalManagedObjectModel externalManagedObject) {
        this.removeItemFromList(externalManagedObject, this.externalManagedObject, SectionEvent.REMOVE_EXTERNAL_MANAGED_OBJECT);
    }

    /**
     * Section managed object source.
     */
    private List<SectionManagedObjectSourceModel> sectionManagedObjectSource = new LinkedList<SectionManagedObjectSourceModel>();

    public List<SectionManagedObjectSourceModel> getSectionManagedObjectSources() {
        return this.sectionManagedObjectSource;
    }

    public void addSectionManagedObjectSource(SectionManagedObjectSourceModel sectionManagedObjectSource) {
        this.addItemToList(sectionManagedObjectSource, this.sectionManagedObjectSource, SectionEvent.ADD_SECTION_MANAGED_OBJECT_SOURCE);
    }

    public void removeSectionManagedObjectSource(SectionManagedObjectSourceModel sectionManagedObjectSource) {
        this.removeItemFromList(sectionManagedObjectSource, this.sectionManagedObjectSource, SectionEvent.REMOVE_SECTION_MANAGED_OBJECT_SOURCE);
    }

    /**
     * Section managed object.
     */
    private List<SectionManagedObjectModel> sectionManagedObject = new LinkedList<SectionManagedObjectModel>();

    public List<SectionManagedObjectModel> getSectionManagedObjects() {
        return this.sectionManagedObject;
    }

    public void addSectionManagedObject(SectionManagedObjectModel sectionManagedObject) {
        this.addItemToList(sectionManagedObject, this.sectionManagedObject, SectionEvent.ADD_SECTION_MANAGED_OBJECT);
    }

    public void removeSectionManagedObject(SectionManagedObjectModel sectionManagedObject) {
        this.removeItemFromList(sectionManagedObject, this.sectionManagedObject, SectionEvent.REMOVE_SECTION_MANAGED_OBJECT);
    }

    /**
     * External flow.
     */
    private List<ExternalFlowModel> externalFlow = new LinkedList<ExternalFlowModel>();

    public List<ExternalFlowModel> getExternalFlows() {
        return this.externalFlow;
    }

    public void addExternalFlow(ExternalFlowModel externalFlow) {
        this.addItemToList(externalFlow, this.externalFlow, SectionEvent.ADD_EXTERNAL_FLOW);
    }

    public void removeExternalFlow(ExternalFlowModel externalFlow) {
        this.removeItemFromList(externalFlow, this.externalFlow, SectionEvent.REMOVE_EXTERNAL_FLOW);
    }

    /**
     * Sub section.
     */
    private List<SubSectionModel> subSection = new LinkedList<SubSectionModel>();

    public List<SubSectionModel> getSubSections() {
        return this.subSection;
    }

    public void addSubSection(SubSectionModel subSection) {
        this.addItemToList(subSection, this.subSection, SectionEvent.ADD_SUB_SECTION);
    }

    public void removeSubSection(SubSectionModel subSection) {
        this.removeItemFromList(subSection, this.subSection, SectionEvent.REMOVE_SUB_SECTION);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<SectionModel> removeConnections() {
        RemoveConnectionsAction<SectionModel> _action = new RemoveConnectionsAction<SectionModel>(this);
        return _action;
    }
}
