/*
 * 
 */
package net.officefloor.model.section;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class SubSectionInputModel extends AbstractModel implements ItemModel<SubSectionInputModel> {

    public static enum SubSectionInputEvent {
     CHANGE_SUB_SECTION_INPUT_NAME, CHANGE_PARAMETER_TYPE, CHANGE_IS_PUBLIC, CHANGE_PUBLIC_INPUT_NAME, ADD_SUB_SECTION_OUTPUT, REMOVE_SUB_SECTION_OUTPUT, ADD_SECTION_MANAGED_OBJECT_SOURCE_FLOW, REMOVE_SECTION_MANAGED_OBJECT_SOURCE_FLOW
    }

    /**
     * Default constructor.
     */
    public SubSectionInputModel() {
    }

    /**
     * Convenience constructor for new non-linked instance.
     */
    public SubSectionInputModel(
      String subSectionInputName
    , String parameterType
    , boolean isPublic
    , String publicInputName
    ) {
        this.subSectionInputName = subSectionInputName;
        this.parameterType = parameterType;
        this.isPublic = isPublic;
        this.publicInputName = publicInputName;
    }

    /**
     * Convenience constructor.
     */
    public SubSectionInputModel(
      String subSectionInputName
    , String parameterType
    , boolean isPublic
    , String publicInputName
    , SubSectionOutputToSubSectionInputModel[] subSectionOutput
    , SectionManagedObjectSourceFlowToSubSectionInputModel[] sectionManagedObjectSourceFlow
    ) {
        this.subSectionInputName = subSectionInputName;
        this.parameterType = parameterType;
        this.isPublic = isPublic;
        this.publicInputName = publicInputName;
        if (subSectionOutput != null) {
            for (SubSectionOutputToSubSectionInputModel model : subSectionOutput) {
                this.subSectionOutput.add(model);
            }
        }
        if (sectionManagedObjectSourceFlow != null) {
            for (SectionManagedObjectSourceFlowToSubSectionInputModel model : sectionManagedObjectSourceFlow) {
                this.sectionManagedObjectSourceFlow.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public SubSectionInputModel(
      String subSectionInputName
    , String parameterType
    , boolean isPublic
    , String publicInputName
    , SubSectionOutputToSubSectionInputModel[] subSectionOutput
    , SectionManagedObjectSourceFlowToSubSectionInputModel[] sectionManagedObjectSourceFlow
    , int x
    , int y
    ) {
        this.subSectionInputName = subSectionInputName;
        this.parameterType = parameterType;
        this.isPublic = isPublic;
        this.publicInputName = publicInputName;
        if (subSectionOutput != null) {
            for (SubSectionOutputToSubSectionInputModel model : subSectionOutput) {
                this.subSectionOutput.add(model);
            }
        }
        if (sectionManagedObjectSourceFlow != null) {
            for (SectionManagedObjectSourceFlowToSubSectionInputModel model : sectionManagedObjectSourceFlow) {
                this.sectionManagedObjectSourceFlow.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }

    /**
     * Sub section input name.
     */
    private String subSectionInputName;

    public String getSubSectionInputName() {
        return this.subSectionInputName;
    }

    public void setSubSectionInputName(String subSectionInputName) {
        String oldValue = this.subSectionInputName;
        this.subSectionInputName = subSectionInputName;
        this.changeField(oldValue, this.subSectionInputName, SubSectionInputEvent.CHANGE_SUB_SECTION_INPUT_NAME);
    }

    /**
     * Parameter type.
     */
    private String parameterType;

    public String getParameterType() {
        return this.parameterType;
    }

    public void setParameterType(String parameterType) {
        String oldValue = this.parameterType;
        this.parameterType = parameterType;
        this.changeField(oldValue, this.parameterType, SubSectionInputEvent.CHANGE_PARAMETER_TYPE);
    }

    /**
     * Is public.
     */
    private boolean isPublic;

    public boolean getIsPublic() {
        return this.isPublic;
    }

    public void setIsPublic(boolean isPublic) {
        boolean oldValue = this.isPublic;
        this.isPublic = isPublic;
        this.changeField(oldValue, this.isPublic, SubSectionInputEvent.CHANGE_IS_PUBLIC);
    }

    /**
     * Public input name.
     */
    private String publicInputName;

    public String getPublicInputName() {
        return this.publicInputName;
    }

    public void setPublicInputName(String publicInputName) {
        String oldValue = this.publicInputName;
        this.publicInputName = publicInputName;
        this.changeField(oldValue, this.publicInputName, SubSectionInputEvent.CHANGE_PUBLIC_INPUT_NAME);
    }


    /**
     * Sub section output.
     */
    private List<SubSectionOutputToSubSectionInputModel> subSectionOutput = new LinkedList<SubSectionOutputToSubSectionInputModel>();

    public List<SubSectionOutputToSubSectionInputModel> getSubSectionOutputs() {
        return this.subSectionOutput;
    }

    public void addSubSectionOutput(SubSectionOutputToSubSectionInputModel subSectionOutput) {
        this.addItemToList(subSectionOutput, this.subSectionOutput, SubSectionInputEvent.ADD_SUB_SECTION_OUTPUT);
    }

    public void removeSubSectionOutput(SubSectionOutputToSubSectionInputModel subSectionOutput) {
        this.removeItemFromList(subSectionOutput, this.subSectionOutput, SubSectionInputEvent.REMOVE_SUB_SECTION_OUTPUT);
    }

    /**
     * Section managed object source flow.
     */
    private List<SectionManagedObjectSourceFlowToSubSectionInputModel> sectionManagedObjectSourceFlow = new LinkedList<SectionManagedObjectSourceFlowToSubSectionInputModel>();

    public List<SectionManagedObjectSourceFlowToSubSectionInputModel> getSectionManagedObjectSourceFlows() {
        return this.sectionManagedObjectSourceFlow;
    }

    public void addSectionManagedObjectSourceFlow(SectionManagedObjectSourceFlowToSubSectionInputModel sectionManagedObjectSourceFlow) {
        this.addItemToList(sectionManagedObjectSourceFlow, this.sectionManagedObjectSourceFlow, SubSectionInputEvent.ADD_SECTION_MANAGED_OBJECT_SOURCE_FLOW);
    }

    public void removeSectionManagedObjectSourceFlow(SectionManagedObjectSourceFlowToSubSectionInputModel sectionManagedObjectSourceFlow) {
        this.removeItemFromList(sectionManagedObjectSourceFlow, this.sectionManagedObjectSourceFlow, SubSectionInputEvent.REMOVE_SECTION_MANAGED_OBJECT_SOURCE_FLOW);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<SubSectionInputModel> removeConnections() {
        RemoveConnectionsAction<SubSectionInputModel> _action = new RemoveConnectionsAction<SubSectionInputModel>(this);
        _action.disconnect(this.subSectionOutput);
        _action.disconnect(this.sectionManagedObjectSourceFlow);
        return _action;
    }
}
