/*
 * 
 */
package net.officefloor.model.section;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class SubSectionModel extends AbstractModel implements ItemModel<SubSectionModel> {

    public static enum SubSectionEvent {
     CHANGE_SUB_SECTION_NAME, CHANGE_SECTION_SOURCE_CLASS_NAME, CHANGE_SECTION_LOCATION, ADD_PROPERTY, REMOVE_PROPERTY, ADD_SUB_SECTION_INPUT, REMOVE_SUB_SECTION_INPUT, ADD_SUB_SECTION_OUTPUT, REMOVE_SUB_SECTION_OUTPUT, ADD_SUB_SECTION_OBJECT, REMOVE_SUB_SECTION_OBJECT
    }

    /**
     * Default constructor.
     */
    public SubSectionModel() {
    }

    /**
     * Convenience constructor for new non-linked instance.
     */
    public SubSectionModel(
      String subSectionName
    , String sectionSourceClassName
    , String sectionLocation
    ) {
        this.subSectionName = subSectionName;
        this.sectionSourceClassName = sectionSourceClassName;
        this.sectionLocation = sectionLocation;
    }

    /**
     * Convenience constructor.
     */
    public SubSectionModel(
      String subSectionName
    , String sectionSourceClassName
    , String sectionLocation
    , PropertyModel[] property
    , SubSectionInputModel[] subSectionInput
    , SubSectionOutputModel[] subSectionOutput
    , SubSectionObjectModel[] subSectionObject
    ) {
        this.subSectionName = subSectionName;
        this.sectionSourceClassName = sectionSourceClassName;
        this.sectionLocation = sectionLocation;
        if (property != null) {
            for (PropertyModel model : property) {
                this.property.add(model);
            }
        }
        if (subSectionInput != null) {
            for (SubSectionInputModel model : subSectionInput) {
                this.subSectionInput.add(model);
            }
        }
        if (subSectionOutput != null) {
            for (SubSectionOutputModel model : subSectionOutput) {
                this.subSectionOutput.add(model);
            }
        }
        if (subSectionObject != null) {
            for (SubSectionObjectModel model : subSectionObject) {
                this.subSectionObject.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public SubSectionModel(
      String subSectionName
    , String sectionSourceClassName
    , String sectionLocation
    , PropertyModel[] property
    , SubSectionInputModel[] subSectionInput
    , SubSectionOutputModel[] subSectionOutput
    , SubSectionObjectModel[] subSectionObject
    , int x
    , int y
    ) {
        this.subSectionName = subSectionName;
        this.sectionSourceClassName = sectionSourceClassName;
        this.sectionLocation = sectionLocation;
        if (property != null) {
            for (PropertyModel model : property) {
                this.property.add(model);
            }
        }
        if (subSectionInput != null) {
            for (SubSectionInputModel model : subSectionInput) {
                this.subSectionInput.add(model);
            }
        }
        if (subSectionOutput != null) {
            for (SubSectionOutputModel model : subSectionOutput) {
                this.subSectionOutput.add(model);
            }
        }
        if (subSectionObject != null) {
            for (SubSectionObjectModel model : subSectionObject) {
                this.subSectionObject.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }

    /**
     * Sub section name.
     */
    private String subSectionName;

    public String getSubSectionName() {
        return this.subSectionName;
    }

    public void setSubSectionName(String subSectionName) {
        String oldValue = this.subSectionName;
        this.subSectionName = subSectionName;
        this.changeField(oldValue, this.subSectionName, SubSectionEvent.CHANGE_SUB_SECTION_NAME);
    }

    /**
     * Section source class name.
     */
    private String sectionSourceClassName;

    public String getSectionSourceClassName() {
        return this.sectionSourceClassName;
    }

    public void setSectionSourceClassName(String sectionSourceClassName) {
        String oldValue = this.sectionSourceClassName;
        this.sectionSourceClassName = sectionSourceClassName;
        this.changeField(oldValue, this.sectionSourceClassName, SubSectionEvent.CHANGE_SECTION_SOURCE_CLASS_NAME);
    }

    /**
     * Section location.
     */
    private String sectionLocation;

    public String getSectionLocation() {
        return this.sectionLocation;
    }

    public void setSectionLocation(String sectionLocation) {
        String oldValue = this.sectionLocation;
        this.sectionLocation = sectionLocation;
        this.changeField(oldValue, this.sectionLocation, SubSectionEvent.CHANGE_SECTION_LOCATION);
    }


    /**
     * Property.
     */
    private List<PropertyModel> property = new LinkedList<PropertyModel>();

    public List<PropertyModel> getProperties() {
        return this.property;
    }

    public void addProperty(PropertyModel property) {
        this.addItemToList(property, this.property, SubSectionEvent.ADD_PROPERTY);
    }

    public void removeProperty(PropertyModel property) {
        this.removeItemFromList(property, this.property, SubSectionEvent.REMOVE_PROPERTY);
    }

    /**
     * Sub section input.
     */
    private List<SubSectionInputModel> subSectionInput = new LinkedList<SubSectionInputModel>();

    public List<SubSectionInputModel> getSubSectionInputs() {
        return this.subSectionInput;
    }

    public void addSubSectionInput(SubSectionInputModel subSectionInput) {
        this.addItemToList(subSectionInput, this.subSectionInput, SubSectionEvent.ADD_SUB_SECTION_INPUT);
    }

    public void removeSubSectionInput(SubSectionInputModel subSectionInput) {
        this.removeItemFromList(subSectionInput, this.subSectionInput, SubSectionEvent.REMOVE_SUB_SECTION_INPUT);
    }

    /**
     * Sub section output.
     */
    private List<SubSectionOutputModel> subSectionOutput = new LinkedList<SubSectionOutputModel>();

    public List<SubSectionOutputModel> getSubSectionOutputs() {
        return this.subSectionOutput;
    }

    public void addSubSectionOutput(SubSectionOutputModel subSectionOutput) {
        this.addItemToList(subSectionOutput, this.subSectionOutput, SubSectionEvent.ADD_SUB_SECTION_OUTPUT);
    }

    public void removeSubSectionOutput(SubSectionOutputModel subSectionOutput) {
        this.removeItemFromList(subSectionOutput, this.subSectionOutput, SubSectionEvent.REMOVE_SUB_SECTION_OUTPUT);
    }

    /**
     * Sub section object.
     */
    private List<SubSectionObjectModel> subSectionObject = new LinkedList<SubSectionObjectModel>();

    public List<SubSectionObjectModel> getSubSectionObjects() {
        return this.subSectionObject;
    }

    public void addSubSectionObject(SubSectionObjectModel subSectionObject) {
        this.addItemToList(subSectionObject, this.subSectionObject, SubSectionEvent.ADD_SUB_SECTION_OBJECT);
    }

    public void removeSubSectionObject(SubSectionObjectModel subSectionObject) {
        this.removeItemFromList(subSectionObject, this.subSectionObject, SubSectionEvent.REMOVE_SUB_SECTION_OBJECT);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<SubSectionModel> removeConnections() {
        RemoveConnectionsAction<SubSectionModel> _action = new RemoveConnectionsAction<SubSectionModel>(this);
        for (SubSectionInputModel _cascade : this.subSectionInput) {
            _action.addCascadeModel(_cascade.removeConnections());
        }
        for (SubSectionOutputModel _cascade : this.subSectionOutput) {
            _action.addCascadeModel(_cascade.removeConnections());
        }
        for (SubSectionObjectModel _cascade : this.subSectionObject) {
            _action.addCascadeModel(_cascade.removeConnections());
        }
        return _action;
    }
}
